#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "energy.h"
#include "pfunc.h"

/**
 * Probabilities of all blocks
 * 
 */
double *PbR, *PbsR, *PR, *PmR, *PbS, *PbsS, *PS, *PmS;
double *PfR, *PfS;
double **PRT[20];
double **PDT[20];

double **PTu[4], **PTsu[4];
double **PTd[4], **PTsd[4];
double **PTe, **PTse;
double **PBond[8];

double **Pinter;
double *weightR, *weightS;


void initialize_prob(void)
{
	int i, j;
	double *temp;
    
	PbR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));
    PbsR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));
	PR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));
	PmR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));
	PfR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));
	weightR = (double *) space(sizeof(double)*(len_r*(len_r+1)/2+2));

	PbS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));
    PbsS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));
	PS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));
	PmS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));
	PfS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));
	weightS = (double *) space(sizeof(double)*(len_s*(len_s+1)/2+2));

	Pinter = (double **) space(sizeof(double *)*(len_r+1));
	temp = (double *) space(sizeof(double)*((len_r+1)*(len_s+1)));
	for (i=0; i<len_r+1; i++) {
        Pinter[i] = temp;
        temp += len_s+1;
	}

	for (j=0; j<20; j++) {
        PDT[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PDT[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
	}
    
	for (j=0; j<20; j++) {
        PRT[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PRT[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
	}
    
	for (j=0; j<4; j++) {
        PTu[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        PTsu[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        PTd[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        PTsd[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        PBond[j] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
        PBond[j+4] = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
      
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PTu[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
        
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PTsu[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
        
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PTd[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
        
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PTsd[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
        
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PBond[j][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        }
        
        temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
        for (i=0; i<len_r*(len_r+1)/2+2; i++) {
            PBond[j+4][i] = temp;
            temp += len_s*(len_s+1)/2+2;
        } 
	}
    
	PTe = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
	temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
	for (i=0; i<len_r*(len_r+1)/2+2; i++) {
        PTe[i] = temp;
        temp += len_s*(len_s+1)/2+2;
	}

    PTse = (double **) space(sizeof(double *)*((len_r*(len_r+1)/2+2)));
    temp = (double *) space(sizeof(double)*((len_r*(len_r+1)/2+2)*(len_s*(len_s+1)/2+2)));
	for (i=0; i<len_r*(len_r+1)/2+2; i++) {
        PTse[i] = temp;
        temp += len_s*(len_s+1)/2+2;
	}

    return;
}

void free_prob(void)
{
	int i;

	free(PR); free(PbR); free(PbsR); free(PmR); free(PfR);
	free(PS); free(PbS); free(PbsS); free(PmS); free(PfS);
	free(weightR); free(weightS);

	free(Pinter);

	for (i=0; i<20; i++) {
	  free(PRT[i][0]); free(PRT[i]);
	}
	for (i=0; i<20; i++) { 
	  free(PDT[i][0]); free(PDT[i]);
	}
	for (i=0; i<4; i++) {
	  free(PTu[i][0]);     free(PTu[i]);
      free(PTsu[i][0]);    free(PTsu[i]);
	  free(PTd[i][0]);     free(PTd[i]);
      free(PTsd[i][0]);    free(PTsd[i]);
	  free(PBond[i][0]);   free(PBond[i]);
	  free(PBond[i+4][0]); free(PBond[i+4]);
	}

	free(PTe[0]);  free(PTe);
    free(PTse[0]); free(PTse);
}

/**
 * calculate probabilities of secondary structures
 * 
 */
void calc_sec_prob(int len, double *Q, double *Qb, double *Qbs, double *Qm, double *Qf, int *indx, 
                   double *Ps, double *Pb, double *Pbs, double *Pm, double *Pf, int **ptype, int sig)
{
	int i, j, k, h, l;
    int gap, st;
	double pro;
	int G, *stack_G;
    int type_hl, type_2hl, type_ij;
	int type, type_2;

    stack_G = (int *) space(sizeof(int)*(num_align+1));

    for (gap=len-1; gap>=TURN+1; gap--) {
        /*
        //#pragma omp parallel default (shared) private (st,h,l,i,j,k,pro,G,type_hl,type_2hl, \
        //                                               type_ij,type,type_2) firstprivate (stack_G)
        //#pragma omp for schedule (static,1)
        */
        for (st=1; st<=len-gap; st++) {
            h = st;
            l = st+gap;
            
            //Q
            if (Q[indx[l]+h] != 0.0) {
                for (i=h; i<=(l-TURN-3); i++)
                    for (j=i+TURN+3; j<=l; j++) {
                        if (j == l)
                            pro = Qb[indx[j]+i]/Q[indx[l]+h];
                        else {
                            pro = (Qb[indx[j]+i]*Q[indx[l]+j+1])/Q[indx[l]+h];
                            Ps[indx[l]+j+1] += pro*Ps[indx[l]+h];
                        }
                        Pb[indx[j]+i] += pro*Ps[indx[l]+h];
                    }
            }
    
            //Qbs
            if (Qbs[indx[l]+h] != 0.0) {
                for (i=h+1; i<=(l-TURN-4); i++)
                    for (j=i+TURN+3; j<l; j++) {
                        type = ptype[0][indx[j]+i];
                        type_2 = ptype[0][indx[j-1]+i+1];
                
                        if (type==NO_PAIR || type_2==NO_PAIR)
                            continue;
                        if (i==h+1 && j==l-1)
                            continue;
                
                        //interior loop
                        G = 0;
                        if (sig == 1) {
                            for (k=0; k<=num_align; k++) {
                                type_hl = ptype[k][indx[l]+h];
                                type_ij = ptype[k][indx[j]+i];

                                if (type_hl == 0)
                                    type_hl = 7;
                                if (type_ij == 0)
                                    type_ij = 7;
                                G += calc_interior_energy(i-h-1, l-j-1, type_hl, rtype[type_ij],
                                                          aSR[k][h+1], aSR[k][l-1], aSR[k][i-1], aSR[k][j+1]);
                            }
                        }
                        else  {
                            for (k=0; k<=num_align; k++) {
                                type_hl = ptype[k][indx[l]+h];
                                type_ij = ptype[k][indx[j]+i];

                                if (type_hl == 0)
                                    type_hl = 7;
                                if (type_ij == 0)
                                    type_ij = 7;
                                G += calc_interior_energy(l-j-1, i-h-1, rtype[type_hl], type_ij,
                                                          aSS[k][l-1], aSS[k][h+1], aSS[k][j+1], aSS[k][i-1]);
                            }
                        }
                        pro = (Qb[indx[j]+i]*EXP(((double) G)/num_align))/Qbs[indx[l]+h];
                        Pb[indx[j]+i] += pro*Pbs[indx[l]+h];
                
                        //multi-loop
                        G = 0;
                        if (sig == 1) {
                            for (k=1; k<=num_align; k++) {
                                G += P->MLclosing+P->MLintern[ptype[k][indx[l]+h]]
                                    + P->MLintern[ptype[k][indx[j]+i]]+(i-h-1)*P->MLbase;
                            }
                        }
                        else if (sig == 2) {
                            for (k=1; k<=num_align; k++) {
                                G = P->MLclosing+P->MLintern[rtype[ptype[k][indx[l]+h]]]
                                    + P->MLintern[rtype[ptype[k][indx[j]+i]]]+(i-h-1)*P->MLbase;
                            }
                        }
                        if (j == l-1)
                            pro = 0.0;
                        else {
                            pro = (Qb[indx[j]+i]*Qm[indx[l-1]+j+1]*EXP(((double) G)/num_align))/Qbs[indx[l]+h];
                            Pm[indx[l-1]+j+1] += pro*Pbs[indx[l]+h];
                        }
                        Pb[indx[j]+i] += pro*Pbs[indx[l]+h];
                    }
            }
    
            //Qb
            if (Qb[indx[l]+h] != 0.0) {
                for (i=h+2; i<=(l-TURN-5); i++)
                    for (j=i+TURN+3; j<l-1; j++) {
                        type = ptype[0][indx[j]+i];
                        type_2 = ptype[0][indx[j-1]+i+1];
                
                        if (type==NO_PAIR || type_2==NO_PAIR)
                            continue;

                
                        if (sig == 1) {
                            for (k=1; k<=num_align; k++) {
                                type_hl = ptype[k][indx[l]+h];
                                type_2hl = ptype[k][indx[l-1]+h+1];
                        
                                if (type_hl == 0)
                                    type_hl = 7;
                                if (type_2hl == 0)
                                    type_2hl = 7;
                                stack_G[k] = P->stack[type_hl][rtype[type_2hl]];
                            }
                        }
                        else if (sig == 2) {
                            for (k=1; k<=num_align; k++) {
                                type_hl = ptype[k][indx[l]+h];
                                type_2hl = ptype[k][indx[l-1]+h+1];
                        
                                if (type_hl == 0)
                                    type_hl = 7;
                                if (type_2hl == 0)
                                    type_2hl = 7;
                                stack_G[k] = P->stack[rtype[type_hl]][type_2hl];
                            }
                        }
                
                        //Qbs contained
                        if (i==h+2 && j==l-2) {
                            int tmp_type;
                    
                            G = 0;
                            if (sig == 1) {
                                for (k=1; k<=num_align; k++) {
                                    type_2hl = ptype[k][indx[l-1]+h+1];
                                    tmp_type = ptype[k][indx[l-2]+h+2];
                            
                                    if (type_2hl == 0)
                                        type_2hl = 7;
                                    if (tmp_type == 0)
                                        tmp_type = 7;
                                    G += stack_G[k]+P->stack[type_2hl][rtype[tmp_type]];
                                }
                            }
                            else if (sig == 2) {
                                for (k=1; k<=num_align; k++) {
                                    type_2hl = ptype[k][indx[l-1]+h+1];
                                    tmp_type = ptype[k][indx[l-2]+h+2];
                            
                                    if (type_2hl == 0)
                                        type_2hl = 7;
                                    if (tmp_type == 0)
                                        tmp_type = 7;
                                    G += stack_G[k]+P->stack[rtype[type_2hl]][tmp_type];
                                }
                            }
                            pro = Qbs[indx[l-2]+h+2]*EXP(((double) G)/num_align)/Qb[indx[l]+h];
                            Pbs[indx[j]+i] += pro*Pb[indx[l]+h];
                        }
                
                        //interior loop
                        G = 0;
                        if (sig == 1) {
                            for (k=1; k<=num_align; k++) {
                                type_2hl = ptype[k][indx[l-1]+h+1];
                                type_ij = ptype[k][indx[j]+i];

                                if (type_2hl == 0)
                                    type_2hl = 7;
                                if (type_ij == 0)
                                    type_ij = 7;
                                G += calc_interior_energy(i-h-2, l-j-2, type_2hl, rtype[type_ij],
                                                          aSR[k][h+2], aSR[k][l-2], aSR[k][i-1], aSR[k][j+1])+stack_G[k];
                            }
                        }
                        else if (sig == 2) {
                            for (k=1; k<=num_align; k++) {
                                type_2hl = ptype[k][indx[l-1]+h+1];
                                type_ij = ptype[k][indx[j]+i];

                                if (type_2hl == 0)
                                    type_2hl = 7;
                                if (type_ij == 0)
                                    type_ij = 7;
                                G += calc_interior_energy(l-j-2, i-h-2, rtype[type_2hl], type_ij,
                                                          aSS[k][l-2], aSS[k][h+2], aSS[k][j+1], aSS[k][i-1])+stack_G[k];
                            }
                        }
                        pro = (Qb[indx[j]+i]*EXP(((double) G)/num_align))/Qb[indx[l]+h];
                        Pb[indx[j]+i] += pro*Pb[indx[l]+h];
                
                        //multi-loop
                        G = 0;
                        if (sig == 1) {
                            for (k=1; k<=num_align; k++) {
                                G += P->MLclosing+P->MLintern[ptype[k][indx[l-1]+h+1]]
                                    +P->MLintern[ptype[k][indx[j]+i]]+(i-h-1)*P->MLbase+stack_G[k];
                            }
                        }
                        else if (sig == 2) {
                            for (k=1; k<=num_align; k++) {
                                G += P->MLclosing+P->MLintern[rtype[ptype[k][indx[l-1]+h+1]]]
                                    +P->MLintern[rtype[ptype[k][indx[j]+i]]]+(i-h-1)*P->MLbase+stack_G[k];
                            }
                        }
                        if (j == l-2)
                            pro = 0.0;      //has already been calculated
                        else {
                            pro = (Qb[indx[j]+i]*Qm[indx[l-2]+j+1]*EXP(((double) G)/num_align))/Qb[indx[l]+h];
                            Pm[indx[l-2]+j+1] += pro*Pb[indx[l]+h];
                        }
                        Pb[indx[j]+i] += pro*Pb[indx[l]+h];
                    }
            }
    
            //Qm
            if (Qm[indx[l]+h] != 0.0) {
                for (i=h; i<=(l-TURN-3); i++)
                    for (j=i+TURN+3; j<=l; j++) {
                        type = ptype[0][indx[j]+i];
                        type_2 = ptype[0][indx[j-1]+i+1];
                
                        if (type==NO_PAIR || type_2==NO_PAIR)
                            continue;

                        G = 0;
                        if (sig == 1) {
                            for (k=1; k<=num_align; k++)
                                G += (i-h)*P->MLbase+P->MLintern[ptype[k][indx[j]+i]];
                        }
                        else if (sig == 2) {
                            for (k=1; k<=num_align; k++)
                                G += (i-h)*P->MLbase+P->MLintern[rtype[ptype[k][indx[j]+i]]];
                        }
                        if (j == l)
                            pro = (Qb[indx[j]+i]*EXP(((double) G)/num_align))/Qm[indx[l]+h];
                        else {
                            pro = (Qb[indx[j]+i]*(Qm[indx[l]+j+1]+EXP((l-j)*P->MLbase))
                                   *EXP(((double) G)/num_align))/Qm[indx[l]+h];
                            Pm[indx[l]+j+1] += pro*Pm[indx[l]+h]*Qm[indx[l]+j+1]
                                /(Qm[indx[l]+j+1]+EXP((l-j)*P->MLbase));
                        }
                        Pb[indx[j]+i] += pro*Pm[indx[l]+h];
                    }
            }
    
            //Qf
            if (Qf[indx[l]+h] != 0.0) {
                for (i=h; i<=(l-TURN-3); i++)
                    for (j=i+TURN+3; j<=l; j++) {
                        type = ptype[0][indx[j]+i];
                        type_2 = ptype[0][indx[j-1]+i+1];
                
                        if (type==NO_PAIR || type_2==NO_PAIR)
                            continue;
                
                        if (j == l)
                            pro = (Qb[indx[j]+i]*EXP((i-h)*BETA3+BETA2))/Qf[indx[l]+h];
                        else {
                            pro = (Qb[indx[j]+i]*(Qf[indx[l]+j+1]+EXP((l-j)*BETA3))
                                   *EXP((i-h)*BETA3+BETA2))/Qf[indx[l]+h];
                            Pf[indx[l]+j+1] += pro*Pf[indx[l]+h]*Qf[indx[l]+j+1]
                                /(Qf[indx[l]+j+1]+EXP((l-j)*BETA3));
                        }
                        Pb[indx[j]+i] += pro*Pf[indx[l]+h];
                    }
            }
        }
    }

    free(stack_G);
}

void calc_hybrid_prob()
{
    int i, j, r, s;
    int ir, jr, is, js;
	int irjr, isjs, k1, k2, k;
    int type1, type2;
	int type, typeI, typeI2, G;
	double Perc,Qpro;

    for (j=len_r-1; j>=0; j--)
        #pragma omp parallel default (shared) private (i,r,s,ir,jr,is,js,irjr,isjs,k1,k2,k, \
                                                       type1,type2,type,typeI,typeI2,G,Perc,Qpro)
        #pragma omp for schedule (static)
        for (i=1; i<=len_r-j; i++) 
            for (s=len_s-1; s>=0; s--) {
                for (r=1; r<=len_s-s; r++) {
                    ir = i; jr = i+j;
                    is = r; js = r+s;
                    
                    irjr = indxR[jr]+ir;
                    isjs = indxS[js]+is;
                    
                    for (k=0; k<4; k++) {
                        PBond[k+4][irjr][isjs] += PBond[k][irjr][isjs];
                    }

                    type = pair_typeHy[0][ir][is];
                    typeI2 = pair_typeHy[0][jr][js];
                    if (type==NO_PAIR || typeI2==NO_PAIR)
                        continue;
    
                    if (ir==jr && is==js) {
                        Pinter[jr][js] += PBond[4][irjr][isjs]+PBond[5][irjr][isjs]
                            +PBond[6][irjr][isjs]+PBond[7][irjr][isjs];
                        continue;
                    }

                    for (k1=ir; k1<jr; k1++)
                        for (k2=is; k2<js; k2++) {
                            typeI = pair_typeHy[0][k1][k2];
                            if (typeI == NO_PAIR)
                                continue;

                            G = 0;
                            for (k=1; k<=num_align; k++) {
                                type1 = pair_typeHy[k][k1][k2];
                                type2 = pair_typeHy[k][jr][js];

                                if (type1 == 0)
                                    type1 = 7;
                                if (type2 == 0)
                                    type2 = 7;
                                G += calc_interior_energy(jr-k1-1, js-k2-1, type1, rtype[type2],
                                                          aSR[k][k1+1], aSS[k][k2+1], aSR[k][jr-1], aSS[k][js-1]);
                            }
            
                            if (Bond[0][irjr][isjs] != 0.0) {
                                Perc = PBond[4][irjr][isjs]/Bond[0][irjr][isjs];
                                if (k1==ir && k2==is)
                                    Qpro = Perc*EXP(SIGMAE*((double) G)/num_align);
                                else
                                    Qpro = Perc*Bond[0][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMAE*((double) G)/num_align);
                                Pinter[jr][js] += Qpro;
                                PBond[4][indxR[k1]+ir][indxS[k2]+is] += Qpro;
                            }
            
                            if (Bond[1][irjr][isjs] != 0.0) {
                                Perc = PBond[5][irjr][isjs]/Bond[1][irjr][isjs];
                                if (k1==ir && k2==is)
                                    Qpro = Perc*EXP(SIGMA*((double) G)/num_align);
                                else
                                    Qpro = Perc*Bond[1][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA*((double) G)/num_align);
                                Pinter[jr][js] += Qpro;
                                PBond[5][indxR[k1]+ir][indxS[k2]+is] += Qpro;
                            }
            
                            if (Bond[2][irjr][isjs] != 0.0) {
                                Perc = PBond[6][irjr][isjs]/Bond[2][irjr][isjs];
                                if (k1==ir && k2==is)
                                    Qpro = Perc*EXP(SIGMA*((double) G)/num_align);
                                else
                                    Qpro = Perc*Bond[2][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA*((double) G)/num_align);
                                Pinter[jr][js] += Qpro;
                                PBond[6][indxR[k1]+ir][indxS[k2]+is] += Qpro;
                            }
            
                            if (Bond[3][irjr][isjs] != 0.0) {
                                Perc = PBond[7][irjr][isjs]/Bond[3][irjr][isjs];
                                if (k1==ir && k2==is)
                                    Qpro = Perc*EXP(SIGMA*((double) G)/num_align);
                                else
                                    Qpro = Perc*Bond[3][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA*((double) G)/num_align);
                                Pinter[jr][js] += Qpro;
                                PBond[7][indxR[k1]+ir][indxS[k2]+is] += Qpro;
                            }
                        }
                }
            }

    return;
}

void calc_Tsu_prob(int h, int l, int r, int s, double **QTu, double **QTsu, double **QDTm, double **QDTk1, 
                   double **QDTk2, double **PTu, double **PTsu, double **PDTm, double **PDTk1, double **PDTk2)
{
    int type1, type2;
	int hl, rs, k1, k2, k;
	double Qpro, Qpro1, Qpro2;
	int G;

	hl = indxR[l]+h;
	rs = indxS[s]+r;
 
	if (QTsu[hl][rs] != 0.0) {
        for (k1=h+1; k1<l-1; k1++)
            for (k2=k1+1; k2<l; k2++) {
                if (QTu[indxR[k2]+k1][rs]!=0.0 && (k1!=h+1 || k2!=l-1)) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        type1 = pair_typeR[k][hl];
                        type2 = pair_typeR[k][indxR[k2]+k1];
                        
                        if (type1 == 0)
                            type1 = 7;
                        if (type2 == 0)
                            type2 = 7;
                        G += calc_interior_energy(k1-h-1, l-k2-1, type1, rtype[type2],
                                                  aSR[k][h+1], aSR[k][l-1], aSR[k][k1-1], aSR[k][k2+1]);
                    }
                    Qpro = QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PTu[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                }

                if (k1>h+1 && k2<l-1) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]]
                            + P->MLintern[pair_typeR[k][indxR[k2]+k1]];
                    }
                    
                    Qpro = (QmR[indxR[k1-1]+h+1]*QmR[indxR[l-1]+k2+1]
                            + QmR[indxR[k1-1]+h+1]*EXP((l-k2-1)*P->MLbase)
                            + EXP((k1-h-1)*P->MLbase)*QmR[indxR[l-1]+k2+1])
                        * QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+1]*(QmR[indxR[l-1]+k2+1]+EXP((l-k2-1)*P->MLbase))
                        *QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    Qpro2 = (QmR[indxR[k1-1]+h+1]+EXP((k1-h-1)*P->MLbase))
                        *QmR[indxR[l-1]+k2+1]*QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    
                    PTu[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                    PmR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro2/QTsu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]];
                    
                    Qpro = (QmR[indxR[k1-1]+h+1]+EXP((k1-h-1)*P->MLbase))
                        *(EXP((l-k2-1)*P->MLbase)+QmR[indxR[l-1]+k2+1])*QDTm[indxR[k2]+k1][rs]
                        *EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+1]*(QmR[indxR[l-1]+k2+1]+EXP((l-k2-1)*P->MLbase))
                        *QDTm[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    Qpro2 = (QmR[indxR[k1-1]+h+1]+EXP((k1-h-1)*P->MLbase))
                        *QmR[indxR[l-1]+k2+1]*QDTm[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);

                    PDTm[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                    PmR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro2/QTsu[hl][rs];
                    
                    //kissing-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))
                            *(EXP((l-k2-1)*BETA3)+QfR[indxR[l-1]+k2+1])*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))
                            *(EXP((l-k2-1)*BETA3)+QfR[indxR[l-1]+k2+1])*QDTk2[indxR[k2]+k1][rs]*EXP(G);
                        PDTk2[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        
                        Qpro1 = QfR[indxR[k1-1]+h+1]*(QfR[indxR[l-1]+k2+1]+EXP((l-k2-1)*BETA3))
                            *(QDTk1[indxR[k2]+k1][rs]+QDTk2[indxR[k2]+k1][rs])*EXP(G);
                        Qpro2 = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))
                            *QfR[indxR[l-1]+k2+1]*(QDTk1[indxR[k2]+k1][rs]+QDTk2[indxR[k2]+k1][rs])*EXP(G);
                    }
                    else {
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))
                            *(EXP((l-k2-1)*BETA3)+QfR[indxR[l-1]+k2+1])*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+1]*(QfR[indxR[l-1]+k2+1]+EXP((l-k2-1)*BETA3))
                            *QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        Qpro2 = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))
                            *QfR[indxR[l-1]+k2+1]*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                    }
                    
                    PfR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                    PfR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro2/QTsu[hl][rs];
                }
                else if (k1>h+1 && k2==l-1) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]]
                            + P->MLintern[pair_typeR[k][indxR[k2]+k1]];
                    }
                    Qpro = QmR[indxR[k1-1]+h+1]*QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PTu[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]];
                    Qpro = (QmR[indxR[k1-1]+h+1]+EXP((k1-h-1)*P->MLbase))*QDTm[indxR[k2]+k1][rs]
                        *EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+1]*QDTm[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PDTm[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                    
                    //kissing-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))*QDTk2[indxR[k2]+k1][rs]*EXP(G);
                        PDTk2[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+1]*(QDTk1[indxR[k2]+k1][rs]+QDTk2[indxR[k2]+k1][rs])*EXP(G);
                    }
                    else {
                        Qpro = (QfR[indxR[k1-1]+h+1]+EXP((k1-h-1)*BETA3))*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+1]*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                    }
                    PfR[indxR[k1-1]+h+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                }
                else if (k1==h+1 && k2<l-1) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G = P->MLclosing+P->MLintern[pair_typeR[k][hl]]
                            + P->MLintern[pair_typeR[k][indxR[k2]+k1]];
                    }
                    Qpro = QmR[indxR[l-1]+k2+1]*QTu[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PTu[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]];
                    Qpro = (QmR[indxR[l-1]+k2+1]+EXP((l-k2-1)*P->MLbase))*QDTm[indxR[k2]+k1][rs]
                        *EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[l-1]+k2+1]*QDTm[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PDTm[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    PmR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                    
                    //kissing-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[l-1]+k2+1]+EXP((l-k2-1)*BETA3))*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro = (QfR[indxR[l-1]+k2+1]+EXP((l-k2-1)*BETA3))*QDTk2[indxR[k2]+k1][rs]*EXP(G);
                        PDTk2[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro1 = QfR[indxR[l-1]+k2+1]*(QDTk1[indxR[k2]+k1][rs]+QDTk2[indxR[k2]+k1][rs])*EXP(G);
                    }
                    else {
                        Qpro = (QfR[indxR[l-1]+k2+1]+EXP((l-k2-1)*BETA3))*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro1 = QfR[indxR[l-1]+k2+1]*QDTk1[indxR[k2]+k1][rs]*EXP(G);
                    }
                    PfR[indxR[l-1]+k2+1] += PTsu[hl][rs]*Qpro1/QTsu[hl][rs];
                }
                else if (k1==h+1 && k2==l-1) {
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl]];
                    Qpro = QDTm[indxR[k2]+k1][rs]*EXP(((double) G)/num_align);
                    PDTm[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    //multi-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                        Qpro = QDTk2[indxR[k2]+k1][rs]*EXP(G);
                        PDTk2[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    }
                    else {
                        Qpro = QDTk1[indxR[k2]+k1][rs]*EXP(G);
                        PDTk1[indxR[k2]+k1][rs] += PTsu[hl][rs]*Qpro/QTsu[hl][rs];
                    }
                }
            }
	}

    return;
}

void calc_Tu_prob(int h, int l, int r, int s, double **QTu, double **QTsu, double **QDTm, double **QDTk1, 
                  double **QDTk2, double **PTu, double **PTsu, double **PDTm, double **PDTk1, double **PDTk2)
{
    int type1, type2;
	int hl, rs, hl_i;
    int k1, k2, k, k1k2;
	double Qpro, Qpro1, Qpro2;
	int G, *stack_G;

	hl = indxR[l]+h;
	rs = indxS[s]+r;
    hl_i = indxR[l-1]+h+1;

    stack_G = (int *) space(sizeof(int)*(num_align+1));
    
	if (QTu[hl][rs] != 0.0) {
        for (k=1; k<=num_align; k++) {
            type1 = pair_typeR[k][hl];
            type2 = pair_typeR[k][hl_i];

            if (type1 == 0)
                type1 = 7;
            if (type2 == 0)
                type2 = 7;
            stack_G[k] = P->stack[type1][rtype[type2]];
        }

        //QTsu
        if (QTsu[indxR[l-2]+h+2][rs] != 0.0) {
            G = 0;
            for (k=1; k<=num_align; k++) {
                type1 = pair_typeR[k][hl_i];
                type2 = pair_typeR[k][indxR[l-2]+h+2];
                
                if (type1 == 0)
                    type1 = 7;
                if (type2 == 0)
                    type2 = 7;
                G += stack_G[k]+P->stack[type1][rtype[type2]];
            }
            Qpro = QTsu[indxR[l-2]+h+2][rs]*EXP(((double) G)/num_align);
            PTsu[indxR[l-2]+h+2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
        }
        
        for (k1=h+2; k1<l-2; k1++)
            for (k2=k1+1; k2<l-1; k2++) {
                k1k2 = indxR[k2]+k1;

                //interior loop
                if (QTu[k1k2][rs] != 0.0) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        type1 = pair_typeR[k][hl_i];
                        type2 = pair_typeR[k][k1k2];
                        
                        if (type1 == 0)
                            type1 = 7;
                        if (type2 == 0)
                            type2 = 7;
                        G += calc_interior_energy(k1-h-2, l-k2-2, type1, rtype[type2],
                                                  aSR[k][h+2], aSR[k][l-2], aSR[k][k1-1], aSR[k][k2+1])+stack_G[k];
                    }
                    Qpro = QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    PTu[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                }

                if (k1>h+2 && k2<l-2) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]
                            + P->MLintern[pair_typeR[k][k1k2]]+stack_G[k];
                    }
                    Qpro = (QmR[indxR[k1-1]+h+2]*QmR[indxR[l-2]+k2+1]
                            +QmR[indxR[k1-1]+h+2]*EXP((l-k2-2)*P->MLbase)
                            +EXP((k1-h-2)*P->MLbase)*QmR[indxR[l-2]+k2+1])*QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+2]*(QmR[indxR[l-2]+k2+1]+EXP((l-k2-2)*P->MLbase))
                        *QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro2 = (QmR[indxR[k1-1]+h+2]+EXP((k1-h-2)*P->MLbase))
                        *QmR[indxR[l-2]+k2+1]*QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    PTu[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                    PmR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro2/QTu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]+stack_G[k];
                    Qpro = (QmR[indxR[k1-1]+h+2]+EXP((k1-h-2)*P->MLbase))
                        *(EXP((l-k2-2)*P->MLbase)+QmR[indxR[l-2]+k2+1])*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+2]*(QmR[indxR[l-2]+k2+1]+EXP((l-k2-2)*P->MLbase))
                        *QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro2 = (QmR[indxR[k1-1]+h+2]+EXP((k1-h-2)*P->MLbase))
                        *QmR[indxR[l-2]+k2+1]*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    PDTm[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                    PmR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro2/QTu[hl][rs];
                    
                    //kissing-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))
                            *(EXP((l-k2-2)*BETA3)+QfR[indxR[l-2]+k2+1])*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))
                            *(EXP((l-k2-2)*BETA3)+QfR[indxR[l-2]+k2+1])*QDTk2[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk2[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        
                        Qpro1 = QfR[indxR[k1-1]+h+2]*(QfR[indxR[l-2]+k2+1]+EXP((l-k2-2)*BETA3))
                            *(QDTk1[k1k2][rs]+QDTk2[k1k2][rs])*EXP(((double) G)/num_align);
                        Qpro2 = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))
                            *QfR[indxR[l-2]+k2+1]*(QDTk1[k1k2][rs]+QDTk2[k1k2][rs])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))
                            *(EXP((l-k2-2)*BETA3)+QfR[indxR[l-2]+k2+1])*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+2]*(QfR[indxR[l-2]+k2+1]+EXP((l-k2-2)*BETA3))
                            *QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        Qpro2 = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))
                            *QfR[indxR[l-2]+k2+1]*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                    }
                    
                    PfR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                    PfR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro2/QTu[hl][rs];
                }
                else if (k1>h+2 && k2==l-2) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]
                            + P->MLintern[pair_typeR[k][k1k2]]+stack_G[k];
                    }
                    Qpro = QmR[indxR[k1-1]+h+2]*QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    PTu[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]+stack_G[k];
                    Qpro = (QmR[indxR[k1-1]+h+2]+EXP((k1-h-2)*P->MLbase))*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[k1-1]+h+2]*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    PDTm[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                    
                    //kissing-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))*QDTk2[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk2[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+2]*(QDTk1[k1k2][rs]+QDTk2[k1k2][rs])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfR[indxR[k1-1]+h+2]+EXP((k1-h-2)*BETA3))*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro1 = QfR[indxR[k1-1]+h+2]*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                    }
                    PfR[indxR[k1-1]+h+2] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                }
                else if (k1==h+2 && k2<l-2) {
                    //multi-QTu
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]
                            + P->MLintern[pair_typeR[k][k1k2]]+stack_G[k];
                    }
                    Qpro = QmR[indxR[l-2]+k2+1]*QTu[k1k2][rs]*EXP(((double) G)/num_align);
                    PTu[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]+stack_G[k];
                    Qpro = (QmR[indxR[l-2]+k2+1]+EXP((l-k2-2)*P->MLbase))*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    Qpro1 = QmR[indxR[l-2]+k2+1]*QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    PDTm[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    PmR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                    
                    //kissing-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfR[indxR[l-2]+k2+1]+EXP((l-k2-2)*BETA3))*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro = (QfR[indxR[l-2]+k2+1]+EXP((l-k2-2)*BETA3))*QDTk2[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk2[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro1 = QfR[indxR[l-2]+k2+1]*(QDTk1[k1k2][rs]+QDTk2[k1k2][rs])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfR[indxR[l-2]+k2+1]+EXP((l-k2-2)*BETA3))*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro1 = QfR[indxR[l-2]+k2+1]*QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                    }
                    PfR[indxR[l-2]+k2+1] += PTu[hl][rs]*Qpro1/QTu[hl][rs];
                }
                else if (k1==h+2 && k2==l-2) {
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[pair_typeR[k][hl_i]]+stack_G[k];
                    Qpro = QDTm[k1k2][rs]*EXP(((double) G)/num_align);
                    PDTm[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                        Qpro = QDTk2[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk2[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    }
                    else {
                        Qpro = QDTk1[k1k2][rs]*EXP(((double) G)/num_align);
                        PDTk1[k1k2][rs] += PTu[hl][rs]*Qpro/QTu[hl][rs];
                    }
                }
            }
	}

    free(stack_G);
}

void calc_Tsd_prob(int h, int l, int r, int s, double **QTd, double **QTsd, double **QDTm, double **QDTk1, 
                   double **QDTk2, double **PTd, double **PTsd, double **PDTm, double **PDTk1, double **PDTk2)
{
    int type1, type2;
	int hl, rs, k1, k2, k1k2, k;
	double Qpro, Qpro1, Qpro2;
	int G;

	hl = indxR[l]+h;
	rs = indxS[s]+r;
 
	if (QTsd[hl][rs] != 0.0) {
        for (k1=r+1; k1<s-1; k1++)
            for (k2=k1+1; k2<s; k2++) {
                k1k2 = indxS[k2]+k1;

                //interior loop
                if (QTd[hl][k1k2]!=0.0 && (k1!=r+1 || k2!=s-1)) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        type1 = pair_typeS[k][rs];
                        type2 = pair_typeS[k][k1k2];
                        
                        if (type1 == 0)
                            type1 = 7;
                        if (type2 == 0)
                            type2 = 7;
                        G += calc_interior_energy(s-k2-1, k1-r-1, rtype[type1], type2,
                                                  aSS[k][s-1], aSS[k][r+1], aSS[k][k2+1], aSS[k][k1-1]);
                    }
                    
                    Qpro = QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                }
                
                if (k1>r+1 && k2<s-1) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]]
                            +P->MLintern[rtype[pair_typeS[k][k1k2]]];
                    }
                    Qpro = (QmS[indxS[k1-1]+r+1]*QmS[indxS[s-1]+k2+1]
                          + QmS[indxS[k1-1]+r+1]*EXP((s-k2-1)*P->MLbase)
                          + EXP((k1-r-1)*P->MLbase)*QmS[indxS[s-1]+k2+1])*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+1]*(QmS[indxS[s-1]+k2+1]+EXP((s-k2-1)*P->MLbase))
                        *QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro2 = (QmS[indxS[k1-1]+r+1]+EXP((k1-r-1)*P->MLbase))
                        *QmS[indxS[s-1]+k2+1]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro2/QTsd[hl][rs];
                    
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]];
                    Qpro = (QmS[indxS[k1-1]+r+1]+EXP((k1-r-1)*P->MLbase))
                        *(EXP((s-k2-1)*P->MLbase)+QmS[indxS[s-1]+k2+1])*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+1]*(QmS[indxS[s-1]+k2+1]+EXP((s-k2-1)*P->MLbase))
                        *QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro2 = (QmS[indxS[k1-1]+r+1]+EXP((k1-r-1)*P->MLbase))
                        *QmS[indxS[s-1]+k2+1]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro2/QTsd[hl][rs];
                    
                    //kissing-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))
                            *(EXP((s-k2-1)*BETA3)+QfS[indxS[s-1]+k2+1])*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))
                            *(EXP((s-k2-1)*BETA3)+QfS[indxS[s-1]+k2+1])*QDTk2[hl][k1k2]*EXP(G);
                        PDTk2[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+1]*(QfS[indxS[s-1]+k2+1]+EXP((s-k2-1)*BETA3))
                            *(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(G);
                        Qpro2 = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))
                            *QfS[indxS[s-1]+k2+1]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(G);
                    }
                    else {
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))
                            *(EXP((s-k2-1)*BETA3)+QfS[indxS[s-1]+k2+1])*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+1]*(QfS[indxS[s-1]+k2+1]+EXP((s-k2-1)*BETA3))
                            *QDTk1[hl][k1k2]*EXP(G);
                        Qpro2 = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))
                            *QfS[indxS[s-1]+k2+1]*QDTk1[hl][k1k2]*EXP(G);
                    }
                    

                    #pragma omp atomic
                    PfS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                    #pragma omp atomic
                    PfS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro2/QTsd[hl][rs];
                }
                else if (k1>r+1 && k2==s-1) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]]
                            + P->MLintern[rtype[pair_typeS[k][k1k2]]];
                    }
                    Qpro = QmS[indxS[k1-1]+r+1]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]];
                    Qpro = (QmS[indxS[k1-1]+r+1]+EXP((k1-r-1)*P->MLbase))*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+1]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                    
                    //multi-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))*QDTk2[hl][k1k2]*EXP(G);
                        PDTk2[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+1]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(G);
                    }
                    else {
                        Qpro = (QfS[indxS[k1-1]+r+1]+EXP((k1-r-1)*BETA3))*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+1]*QDTk1[hl][k1k2]*EXP(G);
                    } 

                    #pragma omp atomic
                    PfS[indxS[k1-1]+r+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                }
                else if (k1==r+1 && k2<s-1) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]]
                            + P->MLintern[rtype[pair_typeS[k][k1k2]]];
                    }
                    Qpro = QmS[indxS[s-1]+k2+1]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]];
                    Qpro = (QmS[indxS[s-1]+k2+1]+EXP((s-k2-1)*P->MLbase))*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[s-1]+k2+1]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                    
                    //multi-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[s-1]+k2+1]+EXP((s-k2-1)*BETA3))*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro = (QfS[indxS[s-1]+k2+1]+EXP((s-k2-1)*BETA3))*QDTk2[hl][k1k2]*EXP(G);
                        PDTk2[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[s-1]+k2+1]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(G);
                    }
                    else {
                        Qpro = (QfS[indxS[s-1]+k2+1]+EXP((s-k2-1)*BETA3))*QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro1 = QfS[indxS[s-1]+k2+1]*QDTk1[hl][k1k2]*EXP(G);
                    }

                    #pragma omp atomic
                    PfS[indxS[s-1]+k2+1] += PTsd[hl][rs]*Qpro1/QTsd[hl][rs];
                }
                else if (k1==r+1 && k2==s-1) {
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs]]];
                    Qpro = QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    
                    //multi-QDT
                    G = BETA1+BETA2;
                    if (QDTk2 != NULL) {
                        Qpro = QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                        Qpro = QDTk2[hl][k1k2]*EXP(G);
                        PDTk2[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    }
                    else {
                        Qpro = QDTk1[hl][k1k2]*EXP(G);
                        PDTk1[hl][k1k2] += PTsd[hl][rs]*Qpro/QTsd[hl][rs];
                    }
                }
            }
	}
    
    return;
}

void calc_Td_prob(int h, int l, int r, int s, double **QTd, double **QTsd, double **QDTm, double **QDTk1, 
                  double **QDTk2, double **PTd, double **PTsd, double **PDTm, double **PDTk1, double **PDTk2)
{
    int type1, type2;
	int hl,rs, rs_i, k1,k2, k1k2, k;
	double Qpro,Qpro1,Qpro2;
	int G, *stack_G;

	hl = indxR[l]+h;
	rs = indxS[s]+r;
    rs_i = indxS[s-1]+r+1;

    stack_G = (int *) space(sizeof(int)*(num_align+1));
 
	if (QTd[hl][rs] != 0.0) {
        for (k=1; k<=num_align; k++) {
            type1 = pair_typeS[k][rs];
            type2 = pair_typeS[k][rs_i];

            if (type1 == 0)
                type1 = 7;
            if (type2 == 0)
                type2 = 7;
            stack_G[k] = P->stack[rtype[type1]][type2];
        }

        //QTsd
        if (QTsd[hl][indxS[s-2]+r+2] != 0.0) {
            G = 0;
            for (k=1; k<=num_align; k++) {
                type1 = pair_typeS[k][rs_i];
                type2 = pair_typeS[k][indxS[s-2]+r+2];
                
                if (type1 == 0)
                    type1 = 7;
                if (type2 == 0)
                    type2 = 7;
                G += stack_G[k]+P->stack[rtype[type1]][type2];
            }
            Qpro = QTsd[hl][indxS[s-2]+r+2]*EXP(((double) G)/num_align);
            PTsd[hl][indxS[s-2]+r+2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
        }
        
        for (k1=r+2; k1<s-2; k1++)
            for (k2=k1+1; k2<s-1; k2++) {
                k1k2 = indxS[k2]+k1;

                //interior loop
                if (QTd[hl][k1k2] != 0.0) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        type1 = pair_typeS[k][rs_i];
                        type2 = pair_typeS[k][k1k2];

                        if (type1 == 0)
                            type1 = 7;
                        if (type2 == 0)
                            type2 = 7;
                        G += calc_interior_energy(s-k2-2, k1-r-2, rtype[type1], type2,
                                                  aSS[k][s-2], aSS[k][r+2], aSS[k][k2+1], aSS[k][k1-1])+stack_G[k];
                    }
                    Qpro = QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                }
                
                if (k1>r+2 && k2<s-2) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]
                            + P->MLintern[rtype[pair_typeS[k][k1k2]]]+stack_G[k];
                    }
                    Qpro = (QmS[indxS[k1-1]+r+2]*QmS[indxS[s-2]+k2+1]
                          + QmS[indxS[k1-1]+r+2]*EXP((s-k2-2)*P->MLbase)
                          +EXP((k1-r-2)*P->MLbase)*QmS[indxS[s-2]+k2+1])*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+2]*(QmS[indxS[s-2]+k2+1]+EXP((s-k2-2)*P->MLbase))
                        *QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro2 = (QmS[indxS[k1-1]+r+2]+EXP((k1-r-2)*P->MLbase))
                        *QmS[indxS[s-2]+k2+1]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro2/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]+stack_G[k];
                    Qpro = (QmS[indxS[k1-1]+r+2]+EXP((k1-r-2)*P->MLbase))
                        *(EXP((s-k2-2)*P->MLbase)+QmS[indxS[s-2]+k2+1])*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+2]*(QmS[indxS[s-2]+k2+1]+EXP((s-k2-2)*P->MLbase))
                        *QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro2 = (QmS[indxS[k1-1]+r+2]+EXP((k1-r-2)*P->MLbase))
                        *QmS[indxS[s-2]+k2+1]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    {
                        PmS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                        PmS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro2/QTd[hl][rs];
                    }
                    
                    //kissing-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))
                            *(EXP((s-k2-2)*BETA3)+QfS[indxS[s-2]+k2+1])*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))
                            *(EXP((s-k2-2)*BETA3)+QfS[indxS[s-2]+k2+1])*QDTk2[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk2[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+2]*(QfS[indxS[s-2]+k2+1]+EXP((s-k2-2)*BETA3))
                            *(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(((double) G)/num_align);
                        Qpro2 = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))
                            *QfS[indxS[s-2]+k2+1]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))
                            *(EXP((s-k2-2)*BETA3)+QfS[indxS[s-2]+k2+1])*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+2]*(QfS[indxS[s-2]+k2+1]+EXP((s-k2-2)*BETA3))
                            *QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        Qpro2 = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))
                            *QfS[indxS[s-2]+k2+1]*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                    }

                    #pragma omp atomic
                    PfS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                    #pragma omp atomic
                    PfS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro2/QTd[hl][rs];
                }
                else if (k1>r+2 && k2==s-2) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]
                            + P->MLintern[rtype[pair_typeS[k][k1k2]]]+stack_G[k];
                    }
                    Qpro = QmS[indxS[k1-1]+r+2]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]+stack_G[k];
                    Qpro = (QmS[indxS[k1-1]+r+2]+EXP((k1-r-2)*P->MLbase))*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[k1-1]+r+2]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))*QDTk2[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk2[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+2]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfS[indxS[k1-1]+r+2]+EXP((k1-r-2)*BETA3))*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[k1-1]+r+2]*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                    } 

                    #pragma omp atomic
                    PfS[indxS[k1-1]+r+2] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                }
                else if (k1==r+2 && k2<s-2) {
                    //multi-QTd
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]
                            + P->MLintern[rtype[pair_typeS[k][k1k2]]]+stack_G[k];
                    }
                    Qpro = QmS[indxS[s-2]+k2+1]*QTd[hl][k1k2]*EXP(((double) G)/num_align);
                    PTd[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]+stack_G[k];
                    Qpro = (QmS[indxS[s-2]+k2+1]+EXP((s-k2-2)*P->MLbase))*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    Qpro1 = QmS[indxS[s-2]+k2+1]*QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    #pragma omp atomic
                    PmS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = (QfS[indxS[s-2]+k2+1]+EXP((s-k2-2)*BETA3))*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro = (QfS[indxS[s-2]+k2+1]+EXP((s-k2-2)*BETA3))*QDTk2[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk2[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[s-2]+k2+1]*(QDTk1[hl][k1k2]+QDTk2[hl][k1k2])*EXP(((double) G)/num_align);
                    }
                    else {
                        Qpro = (QfS[indxS[s-2]+k2+1]+EXP((s-k2-2)*BETA3))*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro1 = QfS[indxS[s-2]+k2+1]*QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                    }

                    #pragma omp atomic
                    PfS[indxS[s-2]+k2+1] += PTd[hl][rs]*Qpro1/QTd[hl][rs];
                }
                else if (k1==r+2 && k2==s-2) {
                    //multi-QDT
                    G = 0;
                    for (k = 1; k<=num_align; k++)
                        G += P->MLclosing+P->MLintern[rtype[pair_typeS[k][rs_i]]]+stack_G[k];
                    Qpro = QDTm[hl][k1k2]*EXP(((double) G)/num_align);
                    PDTm[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    
                    //multi-QDT
                    G = 0;
                    for (k=1; k<=num_align; k++)
                        G += BETA1+BETA2+stack_G[k];
                    if (QDTk2 != NULL) {
                        Qpro = QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                        Qpro = QDTk2[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk2[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    }
                    else {
                        Qpro = QDTk1[hl][k1k2]*EXP(((double) G)/num_align);
                        PDTk1[hl][k1k2] += PTd[hl][rs]*Qpro/QTd[hl][rs];
                    }
                }
            }
	}

    free(stack_G);
}

/**
 * calculate probabilities of tight structures
 * 
 */
void calc_TS_prob() 
{
    int i, j, r, s;
    int ir, jr, is, js;
	double Qpro, Perc, Qpro1, Qpro2, Qpro3;
    double d1, d2, d3, d4, Tight, Right;
	int ml_r_G, ml_s_G;
	int k, k1, k2;
    int type_kR, type_kS;
	int irjr, isjs, GMR, GMS;

    for (j=len_r-1; j>=0; j--)
        #pragma omp parallel default (shared) private (i,r,s,ir,jr,is,js,irjr,isjs,k,k1,k2,d1,d2,d3,d4, \
                                                       Qpro,Perc,Qpro1,Qpro2,Qpro3,Tight,Right,GMR,GMS, \
                                                       ml_r_G,ml_s_G,type_kR,type_kS)
        #pragma omp for schedule (static)
        for (i=1; i<=len_r-j; i++) 
            for (s=len_s-1; s>=0; s--) {
                for (r=1; r<=len_s-s; r++) {
                    ir = i; jr = i+j;
                    is = r; js = r+s;
                    
                    irjr = indxR[jr]+ir;
                    isjs = indxS[js]+is;
                    
                    ml_r_G = 0;
                    for (k=1; k<=num_align; k++)
                        ml_r_G += P->MLintern[pair_typeR[k][irjr]];
                    ml_s_G = 0;
                    for (k=1; k<=num_align; k++)
                        ml_s_G += P->MLintern[rtype[pair_typeS[k][isjs]]];

    
                    /* QRT */
                    /*eea*/
                    if (QRT[0][irjr][isjs] != 0.0) {
                        Perc = PRT[0][irjr][isjs]/QRT[0][irjr][isjs];
        
                        PTu[0][irjr][isjs] += Perc*QTu[0][irjr][isjs];
                        PTd[0][irjr][isjs] += Perc*QTd[0][irjr][isjs];
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs];
                        PDT[0][irjr][isjs] += Perc*QDT[0][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*QR[indxR[k1]+ir]*QS[indxS[k2]+is];
                                d1 = Qpro*QTu[0][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QTd[0][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1];
                                d4 = Qpro*QDT[0][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;
                
                                PR[indxR[k1]+ir] += d1+d2+d3+d4;
                                #pragma omp atomic
                                PS[indxS[k2]+is] += d1+d2+d3+d4;
                
                                Qpro = ((QR[indxR[k1]+ir]-1)*QS[indxS[k2]+is]+1*(QS[indxS[k2]+is]-1))
                                    * QDT[1][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PDT[1][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                
                                Qpro = QR[indxR[k1]+ir]*QS[indxS[k2]+is]*QDT[1][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PR[indxR[k1]+ir] += Perc*Qpro;
                                #pragma omp atomic
                                PS[indxS[k2]+is] += Perc*Qpro;
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*QR[indxR[k1]+ir];
                            d1 = Qpro*QTu[0][indxR[jr]+k1+1][isjs];
                            d2 = Qpro*QTd[0][indxR[jr]+k1+1][isjs];
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs];
                            d4 = Qpro*QDT[0][indxR[jr]+k1+1][isjs];
            
                            PTu[0][indxR[jr]+k1+1][isjs] += d1;
                            PTd[0][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[0][indxR[jr]+k1+1][isjs] += d4;
            
                            PR[indxR[k1]+ir] += d1+d2+d3+d4;
            
                            Qpro = (QR[indxR[k1]+ir]-1)*QDT[1][indxR[jr]+k1+1][isjs];
                            PDT[1][indxR[jr]+k1+1][isjs] += Perc*Qpro;
                            Qpro = QR[indxR[k1]+ir]*QDT[1][indxR[jr]+k1+1][isjs];
                            PR[indxR[k1]+ir] += Perc*Qpro;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*QS[indxS[k2]+is];
                            d1 = Qpro*QTu[0][irjr][indxS[js]+k2+1];
                            d2 = Qpro*QTd[0][irjr][indxS[js]+k2+1];
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1];
                            d4 = Qpro*QDT[0][irjr][indxS[js]+k2+1];
            
                            PTu[0][irjr][indxS[js]+k2+1] += d1;
                            PTd[0][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[0][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PS[indxS[k2]+is] += d1+d2+d3+d4;
            
                            Qpro = (QS[indxS[k2]+is]-1)*QDT[1][irjr][indxS[js]+k2+1];
                            PDT[1][irjr][indxS[js]+k2+1] += Perc*Qpro;
                            Qpro = QS[indxS[k2]+is]*QDT[1][irjr][indxS[js]+k2+1];
                            #pragma omp atomic
                            PS[indxS[k2]+is] += Perc*Qpro;
                        }
                    }

                    /*eeb*/
                    if (QRT[1][irjr][isjs] != 0.0) {
                        Perc = PRT[1][irjr][isjs]/QRT[1][irjr][isjs];
        
                        for (k1=ir; k1<jr; k1++)
                            for (k2=is; k2<js; k2++) {
                                Qpro = Perc*QDT[1][indxR[jr]+k1][indxS[js]+k2];
                                PDT[1][indxR[jr]+k1][indxS[js]+k2] += Qpro;
                            }
                    }
    
                    /*me*/
                    if (QRT[2][irjr][isjs] != 0.0) {
                        Perc = PRT[2][irjr][isjs]/QRT[2][irjr][isjs];
        
                        PTu[0][irjr][isjs] += Perc*QTu[0][irjr][isjs]*EXP(((double) ml_r_G)/num_align);
                        PTd[1][irjr][isjs] += Perc*QTd[1][irjr][isjs];
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(((double) ml_r_G)/num_align);
                        PDT[2][irjr][isjs] += Perc*QDT[2][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMR = 0;
                                for (k=1; k<=num_align; k++)
                                    GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
                
                                Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase))*QS[indxS[k2]+is];
                                d1 = Qpro*QTu[0][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align);
                                d2 = Qpro*QTd[1][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align);
                                d4 = Qpro*QDT[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;
                
                                PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                                #pragma omp atomic
                                PS[indxS[k2]+is] += d1+d2+d3+d4;
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            GMR = 0;
                            for (k=1; k<=num_align; k++)
                                GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
            
                            Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                            d1 = Qpro*QTu[0][indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align);
                            d2 = Qpro*QTd[1][indxR[jr]+k1+1][isjs];
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align);
                            d4 = Qpro*QDT[2][indxR[jr]+k1+1][isjs];
            
                            PTu[0][indxR[jr]+k1+1][isjs] += d1;
                            PTd[1][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[2][indxR[jr]+k1+1][isjs] += d4;
            
                            PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*QS[indxS[k2]+is];
            
                            d1 = Qpro*QTu[0][irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align);
                            d2 = Qpro*QTd[1][irjr][indxS[js]+k2+1];
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align);
                            d4 = Qpro*QDT[2][irjr][indxS[js]+k2+1];
            
                            PTu[0][irjr][indxS[js]+k2+1] += d1;
                            PTd[1][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[2][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PS[indxS[k2]+is] += d1+d2+d3+d4;
                        }
                    }

                    /*em*/
                    if (QRT[3][irjr][isjs] != 0.0) {
                        Perc = PRT[3][irjr][isjs]/QRT[3][irjr][isjs];
        
                        PTu[1][irjr][isjs] += Perc*QTu[1][irjr][isjs];
                        PTd[0][irjr][isjs] += Perc*QTd[0][irjr][isjs]*EXP(((double) ml_s_G)/num_align);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(((double) ml_s_G)/num_align);
                        PDT[3][irjr][isjs] += Perc*QDT[3][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMS = 0;
                                for (k=1; k<=num_align; k++)
                                    GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
                
                                Qpro = Perc*QR[indxR[k1]+ir]*(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                                d1 = Qpro*QTu[1][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QTd[0][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                                d4 = Qpro*QDT[3][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PTu[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;

                                PR[indxR[k1]+ir] += d1+d2+d3+d4;
                                #pragma omp atomic
                                PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*QR[indxR[k1]+ir];
                            d1 = Qpro*QTu[1][indxR[jr]+k1+1][isjs];
                            d2 = Qpro*QTd[0][indxR[jr]+k1+1][isjs]*EXP(((double) ml_s_G)/num_align);
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(((double) ml_s_G)/num_align);
                            d4 = Qpro*QDT[3][indxR[jr]+k1+1][isjs];

                            PTu[1][indxR[jr]+k1+1][isjs] += d1;
                            PTd[0][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[3][indxR[jr]+k1+1][isjs] += d4;

                            PR[indxR[k1]+ir] += d1+d2+d3+d4;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            GMS = 0;
                            for (k=1; k<=num_align; k++)
                                GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
            
                            Qpro = Perc*(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            d1 = Qpro*QTu[1][irjr][indxS[js]+k2+1];
                            d2 = Qpro*QTd[0][irjr][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                            d4 = Qpro*QDT[3][irjr][indxS[js]+k2+1];

                            PTu[1][irjr][indxS[js]+k2+1] += d1;
                            PTd[0][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[3][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                        }
                    }

                    /*fe*/
                    if (QRT[4][irjr][isjs] != 0.0) {
                        Perc = PRT[4][irjr][isjs]/QRT[4][irjr][isjs];

                        PTu[0][irjr][isjs] += Perc*QTu[0][irjr][isjs]*EXP(BETA2);
                        PTd[2][irjr][isjs] += Perc*QTd[2][irjr][isjs];
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(BETA2);
                        PDT[4][irjr][isjs] += Perc*QDT[4][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))*QS[indxS[k2]+is];
                                d1 = Qpro*QTu[0][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d2 = Qpro*QTd[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d4 = Qpro*QDT[4][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PTu[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[4][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;

                                PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PS[indxS[k2]+is] += d1+d2+d3+d4;
                            }
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTu[0][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d2 = Qpro*QTd[2][indxR[jr]+k1+1][isjs];
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d4 = Qpro*QDT[4][indxR[jr]+k1+1][isjs];

                            PTu[0][indxR[jr]+k1+1][isjs] += d1;
                            PTd[2][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[4][indxR[jr]+k1+1][isjs] += d4;

                            PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*QS[indxS[k2]+is];
                            d1 = Qpro*QTu[0][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d2 = Qpro*QTd[2][irjr][indxS[js]+k2+1];
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d4 = Qpro*QDT[4][irjr][indxS[js]+k2+1];

                            PTu[0][irjr][indxS[js]+k2+1] += d1;
                            PTd[2][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[4][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PS[indxS[k2]+is] += d1+d2+d3+d4;
                        }
                    }

                    /*ef*/
                    if (QRT[5][irjr][isjs] != 0.0) {
                        Perc = PRT[5][irjr][isjs]/QRT[5][irjr][isjs];

                        PTu[2][irjr][isjs] += Perc*QTu[2][irjr][isjs];
                        PTd[0][irjr][isjs] += Perc*QTd[0][irjr][isjs]*EXP(BETA2);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(BETA2);
                        PDT[5][irjr][isjs] += Perc*QDT[5][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*QR[indxR[k1]+ir]*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QTd[0][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d4 = Qpro*QDT[5][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PTu[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[0][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[5][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;

                                PR[indxR[k1]+ir] += d1+d2+d3+d4;
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*QR[indxR[k1]+ir];
                            d1 = Qpro*QTu[2][indxR[jr]+k1+1][isjs];
                            d2 = Qpro*QTd[0][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d4 = Qpro*QDT[5][indxR[jr]+k1+1][isjs];

                            PTu[2][indxR[jr]+k1+1][isjs] += d1;
                            PTd[0][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[5][indxR[jr]+k1+1][isjs] += d4;

                            PR[indxR[k1]+ir] += d1+d2+d3+d4;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[2][irjr][indxS[js]+k2+1];
                            d2 = Qpro*QTd[0][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d4 = Qpro*QDT[5][irjr][indxS[js]+k2+1];

                            PTu[2][irjr][indxS[js]+k2+1] += d1;
                            PTd[0][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[5][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }

                    /*mm*/
                    if (QRT[6][irjr][isjs] != 0.0) {
                        Perc = PRT[6][irjr][isjs]/QRT[6][irjr][isjs];

                        PTu[1][irjr][isjs] += Perc*QTu[1][irjr][isjs]*EXP(((double) ml_r_G)/num_align);
                        PTd[1][irjr][isjs] += Perc*QTd[1][irjr][isjs]*EXP(((double) ml_s_G)/num_align);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP((ml_r_G+ml_s_G));
                        PDT[6][irjr][isjs] += Perc*QDT[6][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMR = GMS = 0;
                                for (k=1; k<=num_align; k++) {
                                    GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
                                    GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
                                }
          
                                Qpro=Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase))
                                    *(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                                d1 = Qpro*QTu[1][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align);
                                d2 = Qpro*QTd[1][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) (GMR+GMS))/num_align);
                                d4 = Qpro*QDT[6][indxR[jr]+k1+1][indxS[js]+k2+1];
	
                                PTu[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[6][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;

                                PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                                #pragma omp atomic
                                PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            GMR = 0;
                            for (k=1; k<=num_align; k++)
                                GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
            
                            Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                            d1 = Qpro*QTu[1][indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align);
                            d2 = Qpro*QTd[1][indxR[jr]+k1+1][isjs]*EXP(((double) ml_s_G)/num_align);
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(((double) (GMR+ml_s_G))/num_align);
                            d4 = Qpro*QDT[6][indxR[jr]+k1+1][isjs];

                            PTu[1][indxR[jr]+k1+1][isjs] += d1;
                            PTd[1][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[6][indxR[jr]+k1+1][isjs] += d4;

                            PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            GMS = 0;
                            for (k=1; k<=num_align; k++)
                                GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
            
                            Qpro = Perc*(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            d1 = Qpro*QTu[1][irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align);
                            d2 = Qpro*QTd[1][irjr][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(((double) (ml_r_G+GMS))/num_align);
                            d4 = Qpro*QDT[6][irjr][indxS[js]+k2+1];

                            PTu[1][irjr][indxS[js]+k2+1] += d1;
                            PTd[1][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[6][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                        }
                    }

                    /*mf*/
                    if (QRT[7][irjr][isjs] != 0.0) {
                        Perc = PRT[7][irjr][isjs]/QRT[7][irjr][isjs];

                        PTu[2][irjr][isjs] += Perc*QTu[2][irjr][isjs]*EXP(((double) ml_r_G)/num_align);
                        PTd[1][irjr][isjs] += Perc*QTd[1][irjr][isjs]*EXP(BETA2);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(((double) ml_r_G)/num_align)*EXP(BETA2);
                        PDT[7][irjr][isjs] += Perc*QDT[7][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMR = 0;
                                for (k=1; k<=num_align; k++)
                                    GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
                
                                Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[2][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align);
                                d2 = Qpro*QTd[1][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align+BETA2);
                                d4 = Qpro*QDT[7][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PTu[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[7][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;

                                PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            GMR = 0;
                            for (k=1; k<=num_align; k++)
                                GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
            
                            Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                            d1 = Qpro*QTu[2][indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align);
                            d2 = Qpro*QTd[1][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align+BETA2);
                            d4 = Qpro*QDT[7][indxR[jr]+k1+1][isjs];

                            PTu[2][indxR[jr]+k1+1][isjs] += d1;
                            PTd[1][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[7][indxR[jr]+k1+1][isjs] += d4;

                            PmR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[2][irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align);
                            d2 = Qpro*QTd[1][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align+BETA2);
                            d4 = Qpro*QDT[7][irjr][indxS[js]+k2+1];

                            PTu[2][irjr][indxS[js]+k2+1] += d1;
                            PTd[1][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[7][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }

                    /*fm*/
                    if (QRT[8][irjr][isjs] != 0.0) {
                        Perc = PRT[8][irjr][isjs]/QRT[8][irjr][isjs];

                        PTu[1][irjr][isjs] += Perc*QTu[1][irjr][isjs]*EXP(BETA2);
                        PTd[2][irjr][isjs] += Perc*QTd[2][irjr][isjs]*EXP(((double) ml_s_G)/num_align);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(BETA2)*EXP(((double) ml_s_G)/num_align);
                        PDT[8][irjr][isjs] += Perc*QDT[8][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMS = 0;
                                for (k=1; k<=num_align; k++)
                                    GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
                
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                                d1 = Qpro*QTu[1][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d2 = Qpro*QTd[2][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2+((double) GMS)/num_align);
                                d4 = Qpro*QDT[8][indxR[jr]+k1+1][indxS[js]+k2+1];
              
                                PTu[1][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[8][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;
              
                                PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            }
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro=Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1=Qpro*QTu[1][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d2=Qpro*QTd[2][indxR[jr]+k1+1][isjs]*EXP(((double) ml_s_G)/num_align);
                            d3=Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(BETA2+((double) ml_s_G)/num_align);
                            d4=Qpro*QDT[8][indxR[jr]+k1+1][isjs];
          
                            PTu[1][indxR[jr]+k1+1][isjs] += d1;
                            PTd[2][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[8][indxR[jr]+k1+1][isjs] += d4;
          
                            PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
                        for (k2=is; k2<js-1; k2++) {
                            GMS = 0;
                            for (k=1; k<=num_align; k++)
                                GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
            
                            Qpro = Perc*(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            d1 = Qpro*QTu[1][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d2 = Qpro*QTd[2][irjr][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(BETA2+((double) GMS)/num_align);
                            d4 = Qpro*QDT[8][irjr][indxS[js]+k2+1];
          
                            PTu[1][irjr][indxS[js]+k2+1] += d1;
                            PTd[2][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[8][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PmS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                        }
                    }

                    /*ff*/
                    if (QRT[9][irjr][isjs] != 0.0) {
                        Perc = PRT[9][irjr][isjs]/QRT[9][irjr][isjs];

                        PTu[2][irjr][isjs] += Perc*QTu[2][irjr][isjs]*EXP(BETA2);
                        PTd[2][irjr][isjs] += Perc*QTd[2][irjr][isjs]*EXP(BETA2);
                        PTe[irjr][isjs] += Perc*QTe[irjr][isjs]*EXP(BETA2)*EXP(BETA2);
                        PDT[9][irjr][isjs] += Perc*QDT[9][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[2][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d2 = Qpro*QTd[2][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d3 = Qpro*QTe[indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(2*BETA2);
                                d4 = Qpro*QDT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PTd[2][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PTe[indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PDT[9][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;
                
                                PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTu[2][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d2 = Qpro*QTd[2][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d3 = Qpro*QTe[indxR[jr]+k1+1][isjs]*EXP(2*BETA2);
                            d4 = Qpro*QDT[9][indxR[jr]+k1+1][isjs];
            
                            PTu[2][indxR[jr]+k1+1][isjs] += d1;
                            PTd[2][indxR[jr]+k1+1][isjs] += d2;
                            PTe[indxR[jr]+k1+1][isjs] += d3;
                            PDT[9][indxR[jr]+k1+1][isjs] += d4;
            
                            PfR[indxR[k1]+ir] += (d1+d2+d3+d4)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[2][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d2 = Qpro*QTd[2][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d3 = Qpro*QTe[irjr][indxS[js]+k2+1]*EXP(2*BETA2);
                            d4 = Qpro*QDT[9][irjr][indxS[js]+k2+1];
            
                            PTu[2][irjr][indxS[js]+k2+1] += d1;
                            PTd[2][irjr][indxS[js]+k2+1] += d2;
                            PTe[irjr][indxS[js]+k2+1] += d3;
                            PDT[9][irjr][indxS[js]+k2+1] += d4;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2+d3+d4)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }

                    /*eka*/
                    if (QRT[10][irjr][isjs] != 0.0) {
                        Perc = PRT[10][irjr][isjs]/QRT[10][irjr][isjs];
        
                        PTu[3][irjr][isjs] += Perc*QTu[3][irjr][isjs];
                        PDT[10][irjr][isjs] += Perc*QDT[10][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*QR[indxR[k1]+ir]*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[3][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QDT[10][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[10][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PR[indxR[k1]+ir] += d1+d2;
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                
                                Qpro = (QR[indxR[k1]+ir]*QfS[indxS[k2]+is]+(QR[indxR[k1]+ir]-1)*EXP((k2-is+1)*BETA3))
                                    *QDT[11][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PDT[11][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                                Qpro = QR[indxR[k1]+ir]*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3))
                                    *QDT[11][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PR[indxR[k1]+ir] += Perc*Qpro;
                                Qpro = QR[indxR[k1]+ir]*QfS[indxS[k2]+is]*QDT[11][indxR[jr]+k1+1][indxS[js]+k2+1];
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += Perc*Qpro;
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*QR[indxR[k1]+ir];
                            d1 = Qpro*QTu[3][indxR[jr]+k1+1][isjs];
                            d2 = Qpro*QDT[10][indxR[jr]+k1+1][isjs];
            
                            PTu[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[10][indxR[jr]+k1+1][isjs] += d2;
            
                            PR[indxR[k1]+ir] += d1+d2;
            
                            Qpro = (QR[indxR[k1]+ir]-1)*QDT[11][indxR[jr]+k1+1][isjs];
                            PDT[11][indxR[jr]+k1+1][isjs] += Perc*Qpro;
                            Qpro = QR[indxR[k1]+ir]*QDT[11][indxR[jr]+k1+1][isjs];
                            PR[indxR[k1]+ir] += Perc*Qpro;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[3][irjr][indxS[js]+k2+1];
                            d2 = Qpro*QDT[10][irjr][indxS[js]+k2+1];
            
                            PTu[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[10][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
            
                            Qpro = QfS[indxS[k2]+is]*QDT[11][irjr][indxS[js]+k2+1];
                            PDT[11][irjr][indxS[js]+k2+1] += Perc*Qpro;
                            #pragma omp atomic
                            PfS[indxS[k2]+is] += Perc*Qpro;
                        }
                    }
    
                    /*ekb*/
                    if (QRT[11][irjr][isjs] != 0.0) {
                        Perc = PRT[11][irjr][isjs]/QRT[11][irjr][isjs];
        
                        for (k1=ir; k1<jr; k1++)
                            for (k2=is; k2<js; k2++) {
                                PDT[11][indxR[jr]+k1][indxS[js]+k2] += Perc*QDT[11][indxR[jr]+k1][indxS[js]+k2]
                                    *EXP((k2-is)*BETA3);
                            }
                    }

                    /*mk*/
                    if (QRT[12][irjr][isjs] != 0.0) {
                        Perc = PRT[12][irjr][isjs]/QRT[12][irjr][isjs];
        
                        PTu[3][irjr][isjs] += Perc*QTu[3][irjr][isjs]*EXP(((double) ml_r_G)/num_align);
                        PDT[12][irjr][isjs] += Perc*QDT[12][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMR = 0;
                                for (k=1; k<=num_align; k++)
                                    GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
                
                                Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[3][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMR)/num_align);
                                d2 = Qpro*QDT[12][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[12][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PmR[indxR[k1]+ir] += (d1+d2)
                                    *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            GMR = 0;
                            for (k=1; k<=num_align; k++)
                                GMR += P->MLintern[pair_typeR[k][indxR[jr]+k1+1]];
            
                            Qpro = Perc*(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                            d1 = Qpro*QTu[3][indxR[jr]+k1+1][isjs]*EXP(((double) GMR)/num_align);
                            d2 = Qpro*QDT[12][indxR[jr]+k1+1][isjs];
            
                            PTu[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[12][indxR[jr]+k1+1][isjs] += d2;
            
                            PmR[indxR[k1]+ir] += (d1+d2)
                                *QmR[indxR[k1]+ir]/(QmR[indxR[k1]+ir]+EXP((k1-ir+1)*P->MLbase));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[3][irjr][indxS[js]+k2+1]*EXP(((double) ml_r_G)/num_align);
                            d2 = Qpro*QDT[12][irjr][indxS[js]+k2+1];
            
                            PTu[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[12][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }
    
                    /*fk*/
                    if (QRT[13][irjr][isjs] != 0.0) {
                        Perc = PRT[13][irjr][isjs]/QRT[13][irjr][isjs];
        
                        PTu[3][irjr][isjs] += Perc*QTu[3][irjr][isjs]*EXP(BETA2);
                        PDT[13][irjr][isjs] += Perc*QDT[13][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTu[3][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d2 = Qpro*QDT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[13][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PfR[indxR[k1]+ir] += (d1+d2)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTu[3][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d2 = Qpro*QDT[13][indxR[jr]+k1+1][isjs];
            
                            PTu[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[13][indxR[jr]+k1+1][isjs] += d2;
            
                            PfR[indxR[k1]+ir] += (d1+d2)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTu[3][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d2 = Qpro*QDT[13][irjr][indxS[js]+k2+1];
            
                            PTu[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[13][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2)
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }
    
                    /*kea*/
                    if (QRT[14][irjr][isjs] != 0.0) {
                        Perc = PRT[14][irjr][isjs]/QRT[14][irjr][isjs];
        
                        PTd[3][irjr][isjs] += Perc*QTd[3][irjr][isjs];
                        PDT[14][irjr][isjs] += Perc*QDT[14][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))*QS[indxS[k2]+is];
                                d1 = Qpro*QTd[3][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QDT[14][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[14][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PfR[indxR[k1]+ir] += (d1+d2)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PS[indxS[k2]+is] += (d1+d2);
                
                                Qpro = (QfR[indxR[k1]+ir]*QS[indxS[k2]+is]+EXP((k1-ir+1)*BETA3)*(QS[indxS[k2]+is]-1))
                                    *QDT[15][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PDT[15][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                                Qpro = (QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))*QS[indxS[k2]+is]
                                    *QDT[15][indxR[jr]+k1+1][indxS[js]+k2+1];
                                #pragma omp atomic
                                PS[indxS[k2]+is] += Perc*Qpro;
                                Qpro1 = (QfR[indxR[k1]+ir]*QS[indxS[k2]+is])*QDT[15][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PfR[indxR[k1]+ir] += Perc*Qpro1;
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTd[3][indxR[jr]+k1+1][isjs];
                            d2 = Qpro*QDT[14][indxR[jr]+k1+1][isjs];
            
                            PTd[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[14][indxR[jr]+k1+1][isjs] += d2;
            
                            PfR[indxR[k1]+ir] += (d1+d2)*QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
            
                            Qpro = QfR[indxR[k1]+ir]*QDT[15][indxR[jr]+k1+1][isjs];
                            PDT[15][indxR[jr]+k1+1][isjs] += Perc*Qpro;
                            PfR[indxR[k1]+ir] += Perc*Qpro;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*QS[indxS[k2]+is];
                            d1 = Qpro*QTd[3][irjr][indxS[js]+k2+1];
                            d2 = Qpro*QDT[14][irjr][indxS[js]+k2+1];
            
                            PTd[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[14][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PS[indxS[k2]+is] += (d1+d2);
            
                            Qpro = (QS[indxS[k2]+is]-1)*QDT[15][irjr][indxS[js]+k2+1];
                            PDT[15][irjr][indxS[js]+k2+1] += Perc*Qpro;
                            Qpro = QS[indxS[k2]+is]*QDT[15][irjr][indxS[js]+k2+1];
                            #pragma omp atomic
                            PS[indxS[k2]+is] += Perc*Qpro;
                        }
                    }
    
                    /*keb*/
                    if (QRT[15][irjr][isjs] != 0.0) {
                        Perc = PRT[15][irjr][isjs]/QRT[15][irjr][isjs];
        
                        for (k1=ir; k1<jr; k1++)
                            for (k2=is; k2<js; k2++) {
                                PDT[15][indxR[jr]+k1][indxS[js]+k2] += Perc*QDT[15][indxR[jr]+k1][indxS[js]+k2]
                                    *EXP((k1-ir)*BETA3);
                            }
                    }

                    /*km*/
                    if (QRT[16][irjr][isjs] != 0.0) {
                        Perc = PRT[16][irjr][isjs]/QRT[16][irjr][isjs];
        
                        PTd[3][irjr][isjs] += Perc*QTd[3][irjr][isjs]*EXP(((double) ml_s_G)/num_align);
                        PDT[16][irjr][isjs] += Perc*QDT[16][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                GMS = 0;
                                for (k=1; k<=num_align; k++)
                                    GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
                
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                                d1 = Qpro*QTd[3][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                                d2 = Qpro*QDT[16][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[16][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PfR[indxR[k1]+ir] += (d1+d2)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PmS[indxS[k2]+is] += (d1+d2)
                                    *QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTd[3][indxR[jr]+k1+1][isjs]*EXP(((double) ml_s_G)/num_align);
                            d2 = Qpro*QDT[16][indxR[jr]+k1+1][isjs];
            
                            PTd[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[16][indxR[jr]+k1+1][isjs] += d2;
            
                            PfR[indxR[k1]+ir] += (d1+d2)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
                        for (k2=is; k2<js-1; k2++) {
                            GMS = 0;
                            for (k=1; k<=num_align; k++)
                                GMS += P->MLintern[rtype[pair_typeS[k][indxS[js]+k2+1]]];
            
                            Qpro = Perc*(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                            d1 = Qpro*QTd[3][irjr][indxS[js]+k2+1]*EXP(((double) GMS)/num_align);
                            d2 = Qpro*QDT[16][irjr][indxS[js]+k2+1];
            
                            PTd[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[16][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PmS[indxS[k2]+is] += (d1+d2)*QmS[indxS[k2]+is]/(QmS[indxS[k2]+is]+EXP((k2-is+1)*P->MLbase));
                        }
                    }
    
                    /*kf*/
                    if (QRT[17][irjr][isjs] != 0.0) {
                        Perc = PRT[17][irjr][isjs]/QRT[17][irjr][isjs];
        
                        PTd[3][irjr][isjs] += Perc*QTd[3][irjr][isjs]*EXP(BETA2);
                        PDT[17][irjr][isjs] += Perc*QDT[17][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                                d1 = Qpro*QTd[3][indxR[jr]+k1+1][indxS[js]+k2+1]*EXP(BETA2);
                                d2 = Qpro*QDT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[3][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PDT[17][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                
                                PfR[indxR[k1]+ir] += (d1+d2)
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += (d1+d2)
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = Perc*(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                            d1 = Qpro*QTd[3][indxR[jr]+k1+1][isjs]*EXP(BETA2);
                            d2 = Qpro*QDT[17][indxR[jr]+k1+1][isjs];
            
                            PTd[3][indxR[jr]+k1+1][isjs] += d1;
                            PDT[17][indxR[jr]+k1+1][isjs] += d2;
            
                            PfR[indxR[k1]+ir] += (d1+d2)
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = Perc*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                            d1 = Qpro*QTd[3][irjr][indxS[js]+k2+1]*EXP(BETA2);
                            d2 = Qpro*QDT[17][irjr][indxS[js]+k2+1];
            
                            PTd[3][irjr][indxS[js]+k2+1] += d1;
                            PDT[17][irjr][indxS[js]+k2+1] += d2;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += (d1+d2)*QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                        }
                    }
    
                    /*kka*/
                    if (QRT[18][irjr][isjs] != 0.0) {
                        Perc = PRT[18][irjr][isjs]/QRT[18][irjr][isjs];
        
                        PDT[18][irjr][isjs] += Perc*QDT[18][irjr][isjs];
                        for (k1=ir; k1<jr-1; k1++) 
                            for (k2=is; k2<js-1; k2++) {
                                Qpro = (QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))
                                    *(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3))
                                    *QDT[18][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PDT[18][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                
                                PfR[indxR[k1]+ir] += Perc*Qpro
                                    *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += Perc*Qpro
                                    *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
                
                                Qpro = (QfR[indxR[k1]+ir]*QfS[indxS[k2]+is]
                                        +EXP((k1-ir+1)*BETA3)*QfS[indxS[k2]+is]+QfR[indxR[k1]+ir]*EXP((k2-is+1)*BETA3))
                                    *QDT[19][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PDT[19][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                                Qpro = (QfR[indxR[k1]+ir]*(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3)))
                                    *QDT[19][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PfR[indxR[k1]+ir] += Perc*Qpro;
                                Qpro = ((QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))*QfS[indxS[k2]+is])
                                    *QDT[19][indxR[jr]+k1+1][indxS[js]+k2+1];
                                #pragma omp atomic
                                PfS[indxS[k2]+is] += Perc*Qpro;
                            }
        
                        for (k1=ir; k1<jr-1; k1++) {
                            Qpro = (QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3))*QDT[18][indxR[jr]+k1+1][isjs];
                            PDT[18][indxR[jr]+k1+1][isjs] += Perc*Qpro;
            
                            PfR[indxR[k1]+ir] += Perc*Qpro
                                *QfR[indxR[k1]+ir]/(QfR[indxR[k1]+ir]+EXP((k1-ir+1)*BETA3));
            
                            Qpro = QfR[indxR[k1]+ir]*QDT[19][indxR[jr]+k1+1][isjs];
                            PDT[19][indxR[jr]+k1+1][isjs] += Perc*Qpro;
                            PfR[indxR[k1]+ir] += Perc*Qpro;
                        }
        
                        for (k2=is; k2<js-1; k2++) {
                            Qpro = (QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3))*QDT[18][irjr][indxS[js]+k2+1];
                            PDT[18][irjr][indxS[js]+k2+1] += Perc*Qpro;

                            #pragma omp atomic
                            PfS[indxS[k2]+is] += Perc*Qpro
                                *QfS[indxS[k2]+is]/(QfS[indxS[k2]+is]+EXP((k2-is+1)*BETA3));
            
                            Qpro = QfS[indxS[k2]+is]*QDT[19][irjr][indxS[js]+k2+1];
                            PDT[19][irjr][indxS[js]+k2+1] += Perc*Qpro;
                            #pragma omp atomic
                            PfS[indxS[k2]+is] += Perc*Qpro;
                        }
                    }
    
                    /*kkb*/
                    if (QRT[19][irjr][isjs] != 0.0) {
                        Perc = PRT[19][irjr][isjs]/QRT[19][irjr][isjs];
        
                        for (k1=ir; k1<jr; k1++)
                            for (k2=is; k2<js; k2++) {
                                PDT[19][indxR[jr]+k1][indxS[js]+k2] += Perc*QDT[19][indxR[jr]+k1][indxS[js]+k2]
                                    *EXP((k1-ir)*BETA3)*EXP((k2-is)*BETA3);
                            }
                    }

    
                    /* Tight Structures */
                    //Te
                    calc_Tu_prob(ir,jr,is,js,QTe,QTse,QTd[1],QTd[3],NULL,PTe,PTse,PTd[1],PTd[3],NULL);
                    //Tu
                    calc_Tu_prob(ir,jr,is,js,QTu[0],QTsu[0],QDT[2],QDT[14],QDT[15],PTu[0],PTsu[0],PDT[2],PDT[14],PDT[15]);
                    calc_Tu_prob(ir,jr,is,js,QTu[1],QTsu[1],QDT[6],QDT[16],NULL,PTu[1],PTsu[1],PDT[6],PDT[16],NULL);
                    calc_Tu_prob(ir,jr,is,js,QTu[2],QTsu[2],QDT[7],QDT[17],NULL,PTu[2],PTsu[2],PDT[7],PDT[17],NULL);
                    calc_Tu_prob(ir,jr,is,js,QTu[3],QTsu[3],QDT[12],QDT[18],QDT[19],PTu[3],PTsu[3],PDT[12],PDT[18],PDT[19]);
                    //Td
                    calc_Td_prob(ir,jr,is,js,QTd[0],QTsd[0],QDT[3],QDT[10],QDT[11],PTd[0],PTsd[0],PDT[3],PDT[10],PDT[11]);
                    calc_Td_prob(ir,jr,is,js,QTd[1],QTsd[1],QDT[6],QDT[12],NULL,PTd[1],PTsd[1],PDT[6],PDT[12],NULL);
                    calc_Td_prob(ir,jr,is,js,QTd[2],QTsd[2],QDT[8],QDT[13],NULL,PTd[2],PTsd[2],PDT[8],PDT[13],NULL);
                    calc_Td_prob(ir,jr,is,js,QTd[3],QTsd[3],QDT[16],QDT[18],QDT[19],PTd[3],PTsd[3],PDT[16],PDT[18],PDT[19]);

                    //Tse
                    calc_Tsu_prob(ir,jr,is,js,QTe,QTse,QTd[1],QTd[3],NULL,PTe,PTse,PTd[1],PTd[3],NULL);
                    //Tsu
                    calc_Tsu_prob(ir,jr,is,js,QTu[0],QTsu[0],QDT[2],QDT[14],QDT[15],PTu[0],PTsu[0],PDT[2],PDT[14],PDT[15]);
                    calc_Tsu_prob(ir,jr,is,js,QTu[1],QTsu[1],QDT[6],QDT[16],NULL,PTu[1],PTsu[1],PDT[6],PDT[16],NULL);
                    calc_Tsu_prob(ir,jr,is,js,QTu[2],QTsu[2],QDT[7],QDT[17],NULL,PTu[2],PTsu[2],PDT[7],PDT[17],NULL);
                    calc_Tsu_prob(ir,jr,is,js,QTu[3],QTsu[3],QDT[12],QDT[18],QDT[19],PTu[3],PTsu[3],PDT[12],PDT[18],PDT[19]);
                    //Tsd
                    calc_Tsd_prob(ir,jr,is,js,QTd[0],QTsd[0],QDT[3],QDT[10],QDT[11],PTd[0],PTsd[0],PDT[3],PDT[10],PDT[11]);
                    calc_Tsd_prob(ir,jr,is,js,QTd[1],QTsd[1],QDT[6],QDT[12],NULL,PTd[1],PTsd[1],PDT[6],PDT[12],NULL);
                    calc_Tsd_prob(ir,jr,is,js,QTd[2],QTsd[2],QDT[8],QDT[13],NULL,PTd[2],PTsd[2],PDT[8],PDT[13],NULL);
                    calc_Tsd_prob(ir,jr,is,js,QTd[3],QTsd[3],QDT[16],QDT[18],QDT[19],PTd[3],PTsd[3],PDT[16],PDT[18],PDT[19]);

    
                    /* Double Tight Strucures */
                    /*eea*/
                    if (QDT[0][irjr][isjs] != 0.0) {
                        Perc = PDT[0][irjr][isjs]/QDT[0][irjr][isjs];

                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Tight = QTu[0][indxR[k1]+ir][indxS[k2]+is]+QTd[0][indxR[k1]+ir][indxS[k2]+is]
                                    +QTe[indxR[k1]+ir][indxS[k2]+is];
                                Right = QRT[0][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[1][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PTu[0][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[0][indxR[k1]+ir][indxS[k2]+is]*Right;
                                PTd[0][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[0][indxR[k1]+ir][indxS[k2]+is]*Right;
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*QTe[indxR[k1]+ir][indxS[k2]+is]*Right;
                
                                PRT[0][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[0][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PRT[1][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[1][indxR[jr]+k1+1][indxS[js]+k2+1];
                            }
                    }

                    /*eeb*/
                    if (QDT[1][irjr][isjs] != 0.0) {
                        Perc = PDT[1][irjr][isjs]/QDT[1][irjr][isjs];
                        
                        PBond[0][irjr][isjs] += Perc*Bond[0][irjr][isjs]*EXP(SIGMAE0);
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Qpro = Bond[0][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMAE0)
                                    *QRT[0][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PBond[0][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro;
                
                                PRT[0][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Qpro;
                            }
                    }

                    /*me*/
                    if (QDT[2][irjr][isjs] != 0.0) {
                        Perc = PDT[2][irjr][isjs]/QDT[2][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kR = pair_typeR[0][indxR[k1]+ir];
                                GMR = 0;
                                if (type_kR == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMR += P->MLintern[pair_typeR[k][indxR[k1]+ir]];
                                }
                                else
                                    GMR = 0;
                
                                Qpro1 = QTu[0][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[0][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[1][indxR[k1]+ir][indxS[k2]+is]*QRT[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[2][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[2][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*em*/
                    if (QDT[3][irjr][isjs] != 0.0) {
                        Perc = PDT[3][irjr][isjs]/QDT[3][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kS = pair_typeS[0][indxS[k2]+is];
                                GMS = 0;
                                if (type_kS == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMS += P->MLintern[rtype[pair_typeS[k][indxS[k2]+is]]];
                                }
                                else
                                    GMS = 0;
                
                                Qpro1 = QTu[1][indxR[k1]+ir][indxS[k2]+is]*QRT[3][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[0][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[3][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[0][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;

                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[3][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[3][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*fe*/
                    if (QDT[4][irjr][isjs] != 0.0) {
                        Perc = PDT[4][irjr][isjs]/QDT[4][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Qpro1 = QTu[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[0][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[2][indxR[k1]+ir][indxS[k2]+is]*QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[4][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*ef*/
                    if (QDT[5][irjr][isjs] != 0.0) {
                        Perc = PDT[5][irjr][isjs]/QDT[5][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Qpro1 = QTu[2][indxR[k1]+ir][indxS[k2]+is]*QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[0][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[5][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*mm*/
                    if (QDT[6][irjr][isjs] != 0.0) {
                        Perc = PDT[6][irjr][isjs]/QDT[6][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kR = pair_typeR[0][indxR[k1]+ir];
                                type_kS = pair_typeS[0][indxS[k2]+is];

                                GMR = GMS = 0;
                                if (type_kR == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMR += P->MLintern[pair_typeR[k][indxR[k1]+ir]];
                                }
                                else
                                    GMR = 0;
                                if (type_kS == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMS += P->MLintern[rtype[pair_typeS[k][indxS[k2]+is]]];
                                }
                                else
                                    GMS = 0;

                                Qpro1 = QTu[1][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[6][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[1][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[6][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)*EXP(((double) GMS)/num_align)
                                    *QRT[6][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[6][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

/*mf*/
                    if (QDT[7][irjr][isjs] != 0.0) {
                        Perc = PDT[7][irjr][isjs]/QDT[7][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kR = pair_typeR[0][indxR[k1]+ir];
                                GMR = 0;
                                if (type_kR == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMR += P->MLintern[pair_typeR[k][indxR[k1]+ir]];
                                }
                                else
                                    GMR = 0;

                                Qpro1 = QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[7][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[7][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;

                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)*EXP(BETA2)
                                    *QRT[7][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[7][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*fm*/
                    if (QDT[8][irjr][isjs] != 0.0) {
                        Perc = PDT[8][irjr][isjs]/QDT[8][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kS = pair_typeS[0][indxS[k2]+is];
                                GMS = 0;
                                if (type_kS == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMS += P->MLintern[rtype[pair_typeS[k][indxS[k2]+is]]];
                                }
                                else
                                    GMS = 0;
                
                                Qpro1 = QTu[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[8][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[1][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[8][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(((double) GMS)/num_align)
                                    *QRT[8][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
          
                                PRT[8][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*ff*/
                    if (QDT[9][irjr][isjs] != 0.0) {
                        Perc = PDT[9][irjr][isjs]/QDT[9][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Qpro1 = QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro1;
                
                                Qpro2 = QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro2;
                
                                Qpro3 = QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(BETA2)
                                    *QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*Qpro3;
                
                                PRT[9][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*(Qpro1+Qpro2+Qpro3);
                            }
                    }

                    /*eka*/
                    if (QDT[10][irjr][isjs] != 0.0) {
                        Perc = PDT[10][irjr][isjs]/QDT[10][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Tight = QTu[3][indxR[k1]+ir][indxS[k2]+is]+QTu[2][indxR[k1]+ir][indxS[k2]+is]
                                    +QTd[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2);
                                Right = QRT[10][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[11][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[3][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[3][indxR[k1]+ir][indxS[k2]+is]
                                    *(Right+QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1]);
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[2][indxR[k1]+ir][indxS[k2]+is]*Right;
                                PTd[0][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                
                                PRT[10][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[10][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PRT[11][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[11][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PRT[5][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*QTu[3][indxR[k1]+ir][indxS[k2]+is]
                                    *QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1];
                            }
                    }

                    /*ekb*/
                    if (QDT[11][irjr][isjs] != 0.0) {
                        Perc = PDT[11][irjr][isjs]/QDT[11][irjr][isjs];
                        
                        PBond[2][irjr][isjs] += Perc*Bond[2][irjr][isjs]*EXP(SIGMA0);
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                PBond[2][indxR[k1]+ir][indxS[k2]+is] += Perc*Bond[2][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA0)
                                    *(QRT[10][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[10][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Bond[2][indxR[k1]+ir][indxS[k2]+is]
                                    *EXP(SIGMA0)*QRT[10][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[5][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Bond[2][indxR[k1]+ir][indxS[k2]+is]
                                    *EXP(SIGMA0)*QRT[5][indxR[jr]+k1+1][indxS[js]+k2+1];
                            }
                    }

                    /*mk*/
                    if (QDT[12][irjr][isjs] != 0.0) {
                        Perc = PDT[12][irjr][isjs]/QDT[12][irjr][isjs];

                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kR = pair_typeR[0][indxR[k1]+ir];
                                GMR = 0;
                                if (type_kR == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMR += P->MLintern[pair_typeR[k][indxR[k1]+ir]];
                                }
                                else
                                    GMR = 0;

                                PTu[3][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *(QRT[12][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[7][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[12][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *(QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                      +QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                      +QTd[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)*EXP(BETA2))
                                    *QRT[12][indxR[jr]+k1+1][indxS[js]+k2+1];

                                PRT[7][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[7][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)
                                    *QRT[12][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[1][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *QRT[12][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMR)/num_align)*EXP(BETA2)
                                    *QRT[12][indxR[jr]+k1+1][indxS[js]+k2+1];	
                            }
                    }

                    /*fk*/
                    if (QDT[13][irjr][isjs] != 0.0) {
                        Perc = PDT[13][irjr][isjs]/QDT[13][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                PTu[3][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *(QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[13][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *(QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(BETA2))
                                    *QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[9][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(BETA2)*QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];	
                            }
                    }
    
                    /*kea*/
                    if (QDT[14][irjr][isjs] != 0.0) {
                        Perc = PDT[14][irjr][isjs]/QDT[14][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Tight = QTd[3][indxR[k1]+ir][indxS[k2]+is]+QTu[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTd[2][indxR[k1]+ir][indxS[k2]+is]+QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2);
                                Right = QRT[14][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[15][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[3][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[3][indxR[k1]+ir][indxS[k2]+is]*(Right+QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1]);
                                PTu[0][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[0][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[2][indxR[k1]+ir][indxS[k2]+is]*Right;
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                
                                PRT[14][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[14][indxR[jr]+k1+1][indxS[js]+k2+1];
                                PRT[15][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[15][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[4][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*QTd[3][indxR[k1]+ir][indxS[k2]+is]
                                    *QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1];
                            }
                    }

                    /*keb*/
                    if (QDT[15][irjr][isjs] != 0.0) {
                        Perc = PDT[15][irjr][isjs]/QDT[15][irjr][isjs];
                        
                        PBond[1][irjr][isjs] += Perc*Bond[1][irjr][isjs]*EXP(SIGMA0);
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                PBond[1][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *Bond[1][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA0)
                                    *(QRT[14][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[14][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *Bond[1][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA0)*QRT[14][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[4][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *Bond[1][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA0)*QRT[4][indxR[jr]+k1+1][indxS[js]+k2+1];
                            }
                    }

                    /*km*/
                    if (QDT[16][irjr][isjs] != 0.0) {
                        Perc = PDT[16][irjr][isjs]/QDT[16][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                type_kS = pair_typeS[0][indxS[k2]+is];
                                GMS = 0;
                                if (type_kS == PAIR) {
                                    for (k=1; k<=num_align; k++)
                                        GMS += P->MLintern[rtype[pair_typeS[k][indxS[k2]+is]]];
                                }
                                else
                                    GMS = 0;

                                PTd[3][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *(QRT[16][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[8][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[16][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *(QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                      +QTu[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                      +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(((double) GMS)/num_align))
                                    *QRT[16][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[8][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[8][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[1][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[1][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[16][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(((double) GMS)/num_align)
                                    *QRT[16][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(((double) GMS)/num_align)
                                    *QRT[16][indxR[jr]+k1+1][indxS[js]+k2+1];	
                            }
                    }

                    /*kf*/
                    if (QDT[17][irjr][isjs] != 0.0) {
                        Perc = PDT[17][irjr][isjs]/QDT[17][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                PTd[3][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *(QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1]);
                
                                PRT[17][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc
                                    *(QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                      +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(BETA2))
                                    *QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[9][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc
                                    *QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*EXP(BETA2)*QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];	
                            }
                    }
    
/*kka*/
                    if (QDT[18][irjr][isjs] != 0.0) {
                        Perc = PDT[18][irjr][isjs]/QDT[18][irjr][isjs];
        
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Tight = QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    +QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(2*BETA2);
                                Right = QRT[18][indxR[jr]+k1+1][indxS[js]+k2+1]+QRT[19][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[3][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *(QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1]+Right);
                
                                PTd[3][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *(QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1]+Right);
                
                                PRT[18][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[18][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[19][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*Tight*QRT[19][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[13][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*QTd[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PRT[17][indxR[jr]+k1+1][indxS[js]+k2+1] += Perc*QTu[3][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)
                                    *QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                
                                PTu[2][indxR[k1]+ir][indxS[k2]+is] += Perc*QTu[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                
                                PTd[2][indxR[k1]+ir][indxS[k2]+is] += Perc*QTd[2][indxR[k1]+ir][indxS[k2]+is]*EXP(BETA2)*Right;
                
                                PTe[indxR[k1]+ir][indxS[k2]+is] += Perc*QTe[indxR[k1]+ir][indxS[k2]+is]*EXP(2*BETA2)*Right;
                            }
                    }

/*kkb*/
                    if (QDT[19][irjr][isjs] != 0.0) {
                        Perc = PDT[19][irjr][isjs]/QDT[19][irjr][isjs];
                        
                        PBond[3][irjr][isjs] += Perc*Bond[3][irjr][isjs]*EXP(SIGMA0);
                        for (k1=ir+1; k1<jr-1; k1++) 
                            for (k2=is+1; k2<js-1; k2++) {
                                Qpro = Perc*Bond[3][indxR[k1]+ir][indxS[k2]+is]*EXP(SIGMA0);
                                d1 = Qpro*QRT[18][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d2 = Qpro*QRT[13][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d3 = Qpro*QRT[17][indxR[jr]+k1+1][indxS[js]+k2+1];
                                d4 = Qpro*QRT[9][indxR[jr]+k1+1][indxS[js]+k2+1];
                                
                                PBond[3][indxR[k1]+ir][indxS[k2]+is] += d1+d2+d3+d4;
                
                                PRT[18][indxR[jr]+k1+1][indxS[js]+k2+1] += d1;
                                PRT[13][indxR[jr]+k1+1][indxS[js]+k2+1] += d2;
                                PRT[17][indxR[jr]+k1+1][indxS[js]+k2+1] += d3;
                                PRT[9][indxR[jr]+k1+1][indxS[js]+k2+1] += d4;
                            }
                    }
                }
            }

    return;
}

void generate_prob_profile(FILE *fp, int detail, struct plist *profile)
{
    double pro, tar;
    int i, j, r, s, k1, k2, t = 0;
      
    if (detail)
        fprintf(fp, "Profile: \n");
    if (detail)
        fprintf(fp, "R:\n");
     
    for (k1=1; k1<=len_r; k1++) {
        tar = 0.0;
        
        for (i=1; i<=k1; i++)
            for (j=k1; j<=len_r; j++)
                for (r=1; r<=len_s; r++)
                    for (s=r; s<=len_s; s++) {
                        pro = PBond[0][indxR[j]+i][indxS[s]+r]+PBond[1][indxR[j]+i][indxS[s]+r]
                            + PBond[2][indxR[j]+i][indxS[s]+r]+PBond[3][indxR[j]+i][indxS[s]+r];
                        tar += pro;
                    }
        if (tar != 0) {
            profile[t].i = k1;
            profile[t].j = k1;
            profile[t].p = tar;
            t++;
            
            if (detail)
                fprintf(fp, "%d  %e\n", k1, tar);
        }
    }
     
    if (detail)
        fprintf(fp, "S:\n");
    for (k2=1; k2<=len_s; k2++) {
        tar = 0.0;
        
        for (i=1; i<=len_r; i++)
            for (j=i; j<=len_r; j++)
                for (r=1; r<=k2; r++)
                    for (s=k2; s<=len_s; s++) {
                        pro = PBond[0][indxR[j]+i][indxS[s]+r]+PBond[1][indxR[j]+i][indxS[s]+r]
                            + PBond[2][indxR[j]+i][indxS[s]+r]+PBond[3][indxR[j]+i][indxS[s]+r];
                        tar += pro;
                    }
        if (tar != 0) {
            profile[t].i = len_r+len_s-k2+1;
            profile[t].j = len_r+len_s-k2+1;
            profile[t].p = tar;
            t++;
            
            if (detail)
                fprintf(fp, "%d  %e\n", k2, tar);
        }
    }
     
    if (detail)
        fprintf(fp, "R,S:\n");
    for (k1=1; k1<=len_r; k1++)
        for (k2=1; k2<=len_s; k2++) {
            tar = 0.0;
            
            for (i=1; i<=k1; i++)
                for (j=k1; j<=len_r; j++)
                    for (r=1; r<=k2; r++)
                        for (s=k2; s<=len_s; s++) {
                            pro = PBond[0][indxR[j]+i][indxS[s]+r]+PBond[1][indxR[j]+i][indxS[s]+r]
                                + PBond[2][indxR[j]+i][indxS[s]+r]+PBond[3][indxR[j]+i][indxS[s]+r];
                            tar += pro;
                        }
            if (tar != 0) {
                profile[t].i = k1;
                profile[t].j = len_r+len_s-k2+1;
                profile[t].p = tar;
                t++;
                
                if (detail)
                    fprintf(fp, "%d %d  %e\n", k1, k2, tar);
            }
        }

    return;
}

void print_prob()
{
    int i, j, r, s;
    double pro;

    /* print probabilities on R */
    for (i=1; i<=len_r; i++)
        for (j=i; j<=len_r; j++) {
            pro = PbR[indxR[j]+i];

            for (r=1; r<=len_s; r++)
                for (s=r; s<=len_s; s++) { 
                    pro += PTu[0][indxR[j]+i][indxS[s]+r]+PTu[1][indxR[j]+i][indxS[s]+r]
                        + PTu[2][indxR[j]+i][indxS[s]+r]+PTu[3][indxR[j]+i][indxS[s]+r]
                        + PTsu[0][indxR[j]+i][indxS[s]+r]+PTsu[1][indxR[j]+i][indxS[s]+r]
                        + PTsu[2][indxR[j]+i][indxS[s]+r]+PTsu[3][indxR[j]+i][indxS[s]+r]
                        + PTe[indxR[j]+i][indxS[s]+r]+PTse[indxR[j]+i][indxS[s]+r];
                }
            
            if (pro != 0.0)
                printf("%d %d %8.8e\n", i, j, pro);
        }
    printf("#\n");
    
    
    /* print base pair probabilities on S */
    for (i=1; i<=len_s; i++)
        for (j=i; j<=len_s; j++) {
            pro = PbS[indxS[j]+i];
            
            for (r=1; r<=len_r; r++)
                for (s=r; s<=len_r; s++) { 
                    pro += PTd[0][indxR[s]+r][indxS[j]+i]+PTd[1][indxR[s]+r][indxS[j]+i]
                        +PTd[2][indxR[s]+r][indxS[j]+i]+PTd[3][indxR[s]+r][indxS[j]+i]
                        +PTsd[0][indxR[s]+r][indxS[j]+i]+PTsd[1][indxR[s]+r][indxS[j]+i]
                        +PTsd[2][indxR[s]+r][indxS[j]+i]+PTsd[3][indxR[s]+r][indxS[j]+i];
                }
            if (pro != 0.0)
                printf("%d %d %8.8e\n", i, j, pro);
        }
    printf("#\n");
    
    /* print interaction probabilities */
    for (i=1; i<=len_r; i++)
        for (j=1; j<=len_s; j++) {
            pro = Pinter[i][j];
            if (pro != 0.0)
                printf("%d %d %8.8e\n", i, j, pro);
        }
    printf("#");
}

void print_block_prob()
{
    int i, j, r, s, t;

    //R
    for (j=len_r-1; j>=TURN+1; j--)
        for (i=1; i<=len_r-j; i++) {
            if (PR[indxR[i+j]+i] != 0)
                fprintf(stdout, "PR[%d,%d]=%8.8e\n", i, i+j, PR[indxR[i+j]+i]);

            if (PbR[indxR[i+j]+i] != 0)
                fprintf(stdout, "PbR[%d,%d]=%8.8e\n", i, i+j, PbR[indxR[i+j]+i]);

            if (PbsR[indxR[i+j]+i] != 0)
                fprintf(stdout, "PbsR[%d,%d]=%8.8e\n", i, i+j, PbsR[indxR[i+j]+i]);

            if (PmR[indxR[i+j]+i] != 0)
                fprintf(stdout, "PR[%d,%d]=%8.8e\n", i, i+j, PmR[indxR[i+j]+i]);

            if (PfR[indxR[i+j]+i] != 0)
                fprintf(stdout, "PfR[%d,%d]=%8.8e\n", i, i+j, PfR[indxR[i+j]+i]);
        }
    //S
    for (j=len_s-1; j>=TURN+1; j--)
        for (i=1; i<=len_s-j; i++) {
            if (PS[indxS[i+j]+i] != 0)
                fprintf(stdout, "PS[%d,%d]=%8.8e\n", i, i+j, PS[indxS[i+j]+i]);

            if (PbS[indxS[i+j]+i] != 0)
                fprintf(stdout, "PbS[%d,%d]=%8.8e\n", i, i+j, PbS[indxS[i+j]+i]);

            if (PbsS[indxS[i+j]+i] != 0)
                fprintf(stdout, "PbsS[%d,%d]=%8.8e\n", i, i+j, PbsS[indxS[i+j]+i]);

            if (PmS[indxS[i+j]+i] != 0)
                fprintf(stdout, "PS[%d,%d]=%8.8e\n", i, i+j, PmS[indxS[i+j]+i]);

            if (PfS[indxS[i+j]+i] != 0)
                fprintf(stdout, "PfS[%d,%d]=%8.8e\n", i, i+j, PfS[indxS[i+j]+i]);
        }

    /* RT & DT */
    for (j=len_r-1; j>=0; j--)
          for (i=1; i<=len_r-j; i++) 
              for (s=len_s-1; s>=0; s--)
                  for (r=1; r<=len_s-s; r++)
                      for (t=0; t<20; t++) {
                          if (PRT[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PRT[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PRT[t][indxR[i+j]+i][indxS[r+s]+r]);

                          if (PDT[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PDT[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PDT[t][indxR[i+j]+i][indxS[r+s]+r]);
                      }

    /* Tu & Td & Te*/
    for (j=len_r-1; j>=0; j--)
          for (i=1; i<=len_r-j; i++) 
              for (s=len_s-1; s>=0; s--)
                  for (r=1; r<=len_s-s; r++) {
                      for (t=0; t<4; t++) {
                          if (PTu[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTu[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PTu[t][indxR[i+j]+i][indxS[r+s]+r]);

                          if (PTsu[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTsu[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PTsu[t][indxR[i+j]+i][indxS[r+s]+r]);

                          if (PTd[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTd[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PTd[t][indxR[i+j]+i][indxS[r+s]+r]);

                          if (PTsd[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTsd[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PTsd[t][indxR[i+j]+i][indxS[r+s]+r]);
                      }

                      if (PTe[indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTe[%d,%d][%d,%d]= %8.8e\n", i, i+j, r, r+s,
                                      PTe[indxR[i+j]+i][indxS[r+s]+r]);

                      if (PTse[indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PTse[%d,%d][%d,%d]= %8.8e\n", i, i+j, r, r+s,
                                      PTse[indxR[i+j]+i][indxS[r+s]+r]);

                      for (t=0; t<8; t++) {
                          if (PBond[t][indxR[i+j]+i][indxS[r+s]+r] != 0)
                              fprintf(stdout, "PBond[%d][%d,%d][%d,%d]= %8.8e\n", t, i, i+j, r, r+s,
                                      PBond[t][indxR[i+j]+i][indxS[r+s]+r]);
                      }
                      
                  }

    for (i=1; i<=len_r; i++)
        for (j=1; j<=len_s; j++) {
            if (Pinter[i][j] != 0.0)
                printf("Pinter[%d,%d]= %8.8e\n", i, j, Pinter[i][j]);
        }

    return;
}

/**
 * calculate base pair probabilities
 * 
 */
void calc_bp_prob(FILE *fp, int detail, struct plist *pre)
{
	int i, j, r, s, t;
    int pos_i, pos_j, k1, k2;
	double cnt, pro, PMAX, PB, PHybrid;
	double Qpro1, Qpro2;

	if (len_s == 0) {
	  PR[indxR[len_r]+1] = 1;
      
      calc_sec_prob(len_r,QR,QbR,QbsR,QmR,QfR,indxR,PR,PbR,PbsR,PmR,PfR,pair_typeR,1);
      /*
 	  j = len_r-1;
	  while (j > TURN+1) {
          for (i=1; i+j<=len_r; i++)
              calc_sec_prob(i,i+j,QR,QbR,QbsR,QmR,QfR,indxR,PR,PbR,PbsR,PmR,PfR,pair_typeR,1);
          j--;
	  }
	  */
	}
    
	if (len_r == 0) {
	  PS[indxS[len_s]+1] = 1;
      
      calc_sec_prob(len_s,QS,QbS,QbsS,QmS,QfS,indxS,PS,PbS,PbsS,PmS,PfS,pair_typeS,2);
      /*
	  j = len_s-1;
	  while (j > TURN+1) {
          for (i=1; i+j<=len_s; i++)
              calc_sec_prob(i,i+j,QS,QbS,QbsS,QmS,QfS,indxS,PS,PbS,PbsS,PmS,PfS,pair_typeS,2);
          j--;
	  }
	  */
	}
    
	if (len_r!=0 && len_s!=0) {
	  PR[indxR[len_r]+1] += QR[indxR[len_r]+1]*QS[indxS[len_s]+1]/Qany;
	  PS[indxS[len_s]+1] += QR[indxR[len_r]+1]*QS[indxS[len_s]+1]/Qany;
	  PRT[0][indxR[len_r]+1][indxS[len_s]+1] += QRT[0][indxR[len_r]+1][indxS[len_s]+1]/Qany;
	  PRT[1][indxR[len_r]+1][indxS[len_s]+1] += QRT[1][indxR[len_r]+1][indxS[len_s]+1]/Qany;
      
	  for (k1=2; k1<len_r; k1++)
          for (k2=2; k2<len_s; k2++) {
              Qpro1 = QRT[0][indxR[k1]+1][indxS[k2]+1]*QR[indxR[len_r]+k1+1]*QS[indxS[len_s]+k2+1];
              PRT[0][indxR[k1]+1][indxS[k2]+1] += Qpro1/Qany;
              
              Qpro2 = QRT[1][indxR[k1]+1][indxS[k2]+1]*QR[indxR[len_r]+k1+1]*QS[indxS[len_s]+k2+1];
              PRT[1][indxR[k1]+1][indxS[k2]+1] += Qpro2/Qany;
              
              PR[indxR[len_r]+k1+1] += (Qpro1+Qpro2)/Qany;
              PS[indxS[len_s]+k2+1] += (Qpro1+Qpro2)/Qany;
          }
      
	  for (k1=2; k1<len_r; k1++) {
          Qpro1 = QRT[0][indxR[k1]+1][indxS[len_s]+1]*QR[indxR[len_r]+k1+1];
          PRT[0][indxR[k1]+1][indxS[len_s]+1] += Qpro1/Qany;
          
          Qpro2 = QRT[1][indxR[k1]+1][indxS[len_s]+1]*QR[indxR[len_r]+k1+1];
          PRT[1][indxR[k1]+1][indxS[len_s]+1] += Qpro2/Qany;
          
          PR[indxR[len_r]+k1+1] += (Qpro1+Qpro2)/Qany;
	  }
      
	  for (k2=2; k2<len_s; k2++) {
          Qpro1 = QRT[0][indxR[len_r]+1][indxS[k2]+1]*QS[indxS[len_s]+k2+1];
          PRT[0][indxR[len_r]+1][indxS[k2]+1] += Qpro1/Qany;
          
          Qpro2 = QRT[1][indxR[len_r]+1][indxS[k2]+1]*QS[indxS[len_s]+k2+1];
          PRT[1][indxR[len_r]+1][indxS[k2]+1] += Qpro2/Qany;
          
          PS[indxS[len_s]+k2+1] += (Qpro1+Qpro2)/Qany;
	  }

      calc_TS_prob();
      calc_hybrid_prob();

      /*
	  for (j=len_r-1; j>=0; j--)
          #pragma omp parallel default (shared) private (i,r,s)
          #pragma omp for schedule (static)
          for (i=1; i<=len_r-j; i++) 
              for (s=len_s-1; s>=0; s--) {
                  for (r=1; r<=len_s-s; r++) {
                      calc_TS_prob(i,i+j,r,r+s);
                      calc_hybrid_prob(i,i+j,r,r+s);
                  }
              }
      */

      #pragma omp parallel sections
      {
          #pragma omp section
              calc_sec_prob(len_r,QR,QbR,QbsR,QmR,QfR,indxR,PR,PbR,PbsR,PmR,PfR,pair_typeR,1);
          #pragma omp section
              calc_sec_prob(len_s,QS,QbS,QbsS,QmS,QfS,indxS,PS,PbS,PbsS,PmS,PfS,pair_typeS,2);
      }
      
	}   //end if (len_r!=0 && len_s!=0)

    #ifndef DEBUG
    print_block_prob();
    #endif

    /* output BPP of R */
	cnt = 0.0;
    t = 0;
	if (detail)
        fprintf(fp, "Base pairing probabilities: \nTable R: \n");
    
	for (i=1; i<=len_r; i++)
        for (j=i; j<=len_r; j++) {
            pro = PbR[indxR[j]+i];
            //pro=0.0;
            
            for (r=1; r<=len_s; r++)
                for (s=r; s<=len_s; s++) {
                    pro += PTu[0][indxR[j]+i][indxS[s]+r]+PTu[1][indxR[j]+i][indxS[s]+r]
                        + PTu[2][indxR[j]+i][indxS[s]+r]+PTu[3][indxR[j]+i][indxS[s]+r]
                        + PTsu[0][indxR[j]+i][indxS[s]+r]+PTsu[1][indxR[j]+i][indxS[s]+r]
                        + PTsu[2][indxR[j]+i][indxS[s]+r]+PTsu[3][indxR[j]+i][indxS[s]+r]
                        + PTe[indxR[j]+i][indxS[s]+r]+PTse[indxR[j]+i][indxS[s]+r];
                    
                    pre[t].i = i;
                    pre[t].j = j;
                    pre[t].p = pro;
                }
            
            if (pro != 0.0) {
                if (detail)
                    fprintf(fp, "%d %d %8.8e\n",  i, j, pro);
                //printf("%d %d %8.8e\n", len_r+1-j,len_r+1-i,pro);
                
                pre[t].i = i;
                pre[t].j = j;
                pre[t].p = pro;
                weightR[indxR[j]+i] = pro;
                cnt += pro;
                t++;
            }
        }
// 	fprintf(fp,"%8.8e\n", cnt);


    /* output BPP of S */
	cnt = 0.0;
	if (detail)
        fprintf(fp, "Table S: \n");
    
	for (i=1; i<=len_s; i++)
        for (j=i; j<=len_s; j++) {
            pro = PbS[indxS[j]+i];
            //pro=0.0;
            
            for (r=1; r<=len_r; r++)
                for (s=r; s<=len_r; s++) {
                    pro += PTd[0][indxR[s]+r][indxS[j]+i]+PTd[1][indxR[s]+r][indxS[j]+i]
                        +PTd[2][indxR[s]+r][indxS[j]+i]+PTd[3][indxR[s]+r][indxS[j]+i]
                        +PTsd[0][indxR[s]+r][indxS[j]+i]+PTsd[1][indxR[s]+r][indxS[j]+i]
                        +PTsd[2][indxR[s]+r][indxS[j]+i]+PTsd[3][indxR[s]+r][indxS[j]+i];
                }
            
            if (pro != 0.0) {
                if (detail) 
                    fprintf(fp, "%d %d %8.8e\n", i, j, pro);
                //printf("%d %d %8.8e\n", len_s+1-j,len_s+1-i,pro);
                
                cnt += pro;
                weightS[indxS[j]+i] = pro;
                pre[t].i = len_r+len_s+1-j;
                pre[t].j = len_r+len_s+1-i;
                pre[t].p = pro;
                t++;
            }
        }
// 	fprintf(fp,"%8.8e\n", cnt);
    

    /* output BPP of interactions */
	cnt = 0.0;
	if (detail)
        fprintf(fp, "Table I: \n");
	for (i=1; i<=len_r; i++)
        for (j=1; j<=len_s; j++) {
            pro = Pinter[i][j];
            
            if (pro != 0.0) {
                if (detail) 
                    fprintf(fp, "%d %d %8.8e\n", i, j, pro);
                //printf("%d %d %8.8e\n", len_s+1-j,len_r+1-i,pro);
                
                cnt += pro;
                pre[t].i = i;
                pre[t].j = len_r+len_s+1-j;
                pre[t].p = pro;
                t++;
            }
        }
    
    #ifndef  DEBUG
    print_prob();
    #endif


    /* output blocks and regions */
// 	fprintf(fp,"%8.8e\n", cnt);
	pos_i = 0;
    pos_j = 0;
	PMAX = 0;

    fprintf(fp, "\n---------- probabilities of blocks and regions ----------\n");
	for (i=1; i<=len_r; i++)
        for (j=i; j<=len_r; j++) {
            PHybrid = 0;
            
            for (r=1; r<=len_s; r++)
                for (s=r; s<=len_s; s++) {
                    PB = PBond[0][indxR[j]+i][indxS[s]+r]+PBond[1][indxR[j]+i][indxS[s]+r]
                        + PBond[2][indxR[j]+i][indxS[s]+r]+PBond[3][indxR[j]+i][indxS[s]+r];
                    
                    PHybrid += PB;
                    if (PB>0.1 && detail)
                        fprintf(fp, "Blocks: %d %d %d %d %e\n",  i, j, r, s, PB);
                }
            
            if (PHybrid > PMAX) {
                PMAX = PHybrid;
                pos_i = i;
                pos_j = j;
            }
            
            if (PHybrid>0.1 && detail)
                fprintf(fp, "Regions: %d %d %e\n\n", i, j, PHybrid);
        }
    
	fprintf(fp, "\nmax_hybrid: %e\n", PMAX);
	fprintf(fp, "pos: %d, %d \n", pos_i, pos_j);
}
