#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "eps.h"


int *r, *s, *hybrid;
region hyb[200];
int n;


int main(int argc, char *argv[])
{
    FILE *fp;
    int i, k = 1;
    int len_r, len_s;
    char name_r[100], name_s[100];
    char **seqs_r, **seqs_s, *pos, line[MAXLENGTH];
    char seqs[MAXLENGTH][MAXLENGTH], struc[MAXLENGTH];

    fp = fopen("./rip.in", "r");
    if (!fp) {
        fprintf(stderr, "Failure to open file \"./rip.in\"\n");
        exit(EXIT_FAILURE);
    }
    fgets(line, MAXLENGTH, fp);
    sscanf(line, "%s %s\n", name_r, name_s);

    /* read structure of alignments */
    fgets(line, MAXLENGTH, fp);
    sscanf(line, "%s\n", struc);

    /* read hybrid regions */
    fgets(line, MAXLENGTH, fp);
    while (strcmp(line, "Alignments:\n") != 0) {
        sscanf(line, "%d %d %lf\n", &hyb[n].i, &hyb[n].j, &hyb[n].pro);
        n++;
        fgets(line, MAXLENGTH, fp);
    }

    while (fgets(line, MAXLENGTH, fp) != NULL) {
        if ((strlen(line)-1) != strlen(struc)) {
            fprintf(stderr, "The length of sequence and structure is not equal.\n");
            exit(EXIT_FAILURE);
        }
        sscanf(line, "%s\n", seqs[k++]);
    }

    /*
    fprintf(stdout, "Please input the two sequences, splitted by '|':\n#");
    fscanf(stdin, "%s", seq);
    fprintf(stdout, "OK. Please input the structure of the sequences, splitted by '|':\n#");
    fscanf(stdin, "%s", struc);
    */

    pos = strchr(struc, '|');
    if (pos == NULL) {
        fprintf(stderr, "The structure you have inputed is invalid, missing \'|\'\n");
        exit(EXIT_FAILURE);
    }

    seqs_r = (char **) malloc(sizeof(char *)*k);
    seqs_s = (char **) malloc(sizeof(char *)*k);
    for (i=1; i<k; i++) {
        pos = strchr(seqs[i], '|');
        if (pos == NULL) {
            fprintf(stderr, "The sequences you have inputed are invalid, missing \'|\'\n");
            exit(EXIT_FAILURE);
        }
        seqs_r[i] = seqs[i];
        *pos = '\0';
        seqs_s[i] = pos+1;
    }
    
    len_r = strlen(seqs_r[1]);
    len_s = strlen(seqs_s[1]);
    
    r = (int *) malloc((len_r+1)*sizeof(int));
    s = (int *) malloc((len_s+1)*sizeof(int));
    hybrid = (int *) malloc((MAX(len_r, len_s)+1)*sizeof(int));
    r[0] = len_r;
    s[0] = len_s;
    hybrid[0] = MAX(len_r, len_s);

    make_pair_table(struc);

    generate_eps(k-1, seqs_r, seqs_s, name_r, name_s);

    fprintf(stdout, "The EPS file is generated successfully, written in \"%s\".\n", "./rip.eps");

    free(r); free(s);
    free(hybrid);
    free(seqs_r); free(seqs_s);
    
    return EXIT_SUCCESS;
}
