#ifndef     ALIGN_H
#define     ALIGN_H


#include "inc.h"

#define  DEBUG   //for debug
#define  TEST
#define  NONE       -10000      // score for forbidden pairs
#define  UNIT       100
#define  MINPSCORE  -1          //the threshold score

/* varables declaration */
extern int do_shrink;
extern int constraint;
extern paramT *P;
extern int *BP;

extern int num_align, len_r, len_s;
extern int *indxR, *indxS;
extern int **aSR, **aSS;
extern int **pair_typeR, **pair_typeS, ***pair_typeHy;

extern double *QbR, *QbsR, *QR, *QmR, *QbS, *QbsS, *QS, *QmS;
extern double *QfR, *QfS;
/**
 *  0: eea   1: eeb   2: me   3: em   4:  fe   5: ef   6: mm   7: mf   8: fm    9: ff
 * 10: eka  11: ekb  12: mk  13: fk  14: kea  15: keb 16: km  17: kf  18: kka  19: kkb
 */
extern double **QRT[20];
extern double **QDT[20];
/**
 * tight structure
 * 0: ee  1: em/me  2: ef/fe  3: ek/ke
 */
extern double **QTu[4], **QTsu[4];
extern double **QTd[4], **QTsd[4];
extern double **QTe, **QTse;
extern double **Bond[4];
extern double Qany;

extern double cv_fact;
extern double nc_fact;

/* functions declaration */
extern void encode_align(char **seqs_r, char **seqs_s);
extern void read_align(char ***ptr_seqs_r, char ***ptr_seqs_s, const char *file_name_r, const char *file_name_s);
extern char *read_align_constraint(const char *file_name);
extern void initialize_params();
extern void initialize_matrix();
extern void clean_matrix();
extern void free_matrix();
extern void calc_align_pfunc(FILE *fp, char **seqs_r, char **seqs_s_53, char *cons_stru);


#endif

