#include <stdio.h>    
#include <stdlib.h>
#include <string.h>
#include "energy.h"
#include "pfunc.h"
#include "sample.h"


block *Bstack;
ana *ana_head;
int *Sample;
int *indxSample;
double *P_sample;
int_block *inter_head, *top_block;
struc_list *struc_head;


block *initialize_block(void)
{
	block *new_block;

	new_block = (block *) space(sizeof(block));
	new_block->i = 0;
    new_block->j = 0;
	new_block->r = 0;
    new_block->s = 0;
	new_block->type = -1;
	new_block->status = -1;
	new_block->next = NULL;
    
	return new_block;
}

inline void push_block(int i, int j, int r, int s, int type, int status)
{
	block *T;

	T = initialize_block();
	T->i = i; T->j = j;
	T->r = r; T->s = s;
	T->type = type;
	T->status = status;
	T->next = Bstack;
	Bstack = T;
    
	return;
}

inline block* pop_block()
{
	block *T;
    
	T = Bstack;
	Bstack = Bstack->next;
	T->next = NULL;
    
	return T;
}

void decompose_RT(block *T)
{
    int G;
    int i, j, r, s;
	int k1, k2, irjr, isjs, flag_R, flag_S, st, k;
	double seed;
	double Qpro, Qi, Pr, Ps, Qr_e, Qr_n, Qr_b, Qs_b, Qs_n, Qs_e;
	int i_tu, i_td;

	seed = 1-drand48();

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	irjr = indxR[j] + i;
	isjs = indxS[s] + r;

	st = T->status;

	Qi = 0;
	Qpro = seed * QRT[st][irjr][isjs];

// 	printf("seed:%f\n", seed);
// 	printf("Qpro:%lf\n", Qpro);

	for (k1=i-1; k1<j-1; k1++)
        for (k2=r-1; k2<s-1; k2++) {
            if (st==0 || st==2 || st==4 || st==14) {
                i_tu = 0;
                Ps = 1;
                
                if (k2 >= r) {
                    Qs_e = QS[indxS[k2]+r];
                    Qs_n = Qs_e-1;
                    flag_S = 1;
                }
                else {
                    Qs_e = 1;
                    Qs_n = 0;
                    flag_S = 0;
                }
                
                Qs_b = 1;
            }
            else if (st==3 || st==6 || st==8 || st==16) {
                i_tu = 1;

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[rtype[pair_typeS[k][indxS[s]+k2+1]]];
                Ps = EXP(((double) G)/num_align);
                
                if (k2 >= r) {
                    Qs_n = QmS[indxS[k2]+r];
                    Qs_e = Qs_n + EXP((k2-r+1)*P->MLbase);
                    flag_S = 1;
                }
                else {
                    Qs_e = 1;
                    Qs_n = 0;
                    flag_S = 0;
                }
                
                Qs_b = EXP((k2-r+1)*P->MLbase);
            }
            else if (st==5 || st==7 || st==9 || st==17) {
                i_tu = 2;
                Ps = EXP(BETA2);
                
                if (k2 >= r) {
                    Qs_n = QfS[indxS[k2]+r];
                    Qs_e = Qs_n + EXP((k2-r+1)*BETA3);
                    flag_S = 1;
                }
                else {
                    Qs_e = 1;
                    Qs_n = 0;
                    flag_S = 0;
                }
                
                Qs_b = EXP((k2-r+1)*BETA3);
            }
            else if (st==10 || st==12 || st==13 || st==18) {
                i_tu = 3;
                Ps = EXP(BETA2);
                
                if (k2 >= r) {
                    Qs_n = QfS[indxS[k2]+r];
                    Qs_e = Qs_n + EXP((k2-r+1)*BETA3);
                    flag_S = 1;
                }
                else {
                    Qs_e = 1;
                    Qs_n = 0;
                    flag_S = 0;
                }
                
                Qs_b = EXP((k2-r+1)*BETA3);
            }
            
            if (st==0 || st==3 || st==5 || st==10) {
                i_td = 0;
                Pr = 1;
                
                if (k1 >= i) {
                    Qr_e = QR[indxR[k1]+i];
                    Qr_n = Qr_e-1;
                    flag_R = 1;
                }
                else {
                    Qr_e = 1;
                    Qr_n=0;
                    flag_R = 0;
                }
                
                Qr_b = 1;
            }
            else if (st==2 || st==6 || st==7 || st==12) {
                i_td = 1;

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[pair_typeR[k][indxR[j]+k1+1]];
                Pr = EXP(((double) G)/num_align);
                
                if (k1 >= i) {
                    Qr_n = QmR[indxR[k1]+i];
                    Qr_e = Qr_n + EXP((k1-i+1)*P->MLbase);
                    flag_R = 1;
                }
                else {
                    Qr_e = 1;
                    Qr_n = 0;
                    flag_R = 0;
                }
                
                Qr_b = EXP((k1-i+1)*P->MLbase);
            }
            else if (st==4 || st==8 || st==9 || st==13) {
                i_td = 2;
                Pr = EXP(BETA2);
                
                if (k1 >= i) {
                    Qr_n = QfR[indxR[k1]+i];
                    Qr_e = Qr_n + EXP((k1-i+1)*BETA3);
                    flag_R = 1;
                }
                else {
                    Qr_e = 1;
                    Qr_n = 0;
                    flag_R = 0;
                }
                
                Qr_b = EXP((k1-i+1)*BETA3);
            }
            else if (st==14 || st==16 || st==17 || st==18) {
                i_td = 3;
                Pr = EXP(BETA2);
                
                if (k1 >= i) {
                    Qr_n = QfR[indxR[k1]+i];
                    Qr_e = Qr_n + EXP((k1-i+1)*BETA3);
                    flag_R = 1;
                }
                else {
                    Qr_e = 1;
                    Qr_n = 0;
                    flag_R = 0;
                }
                
                Qr_b = EXP((k1-i+1)*BETA3);
            }
// 	printf("Qi:%lf (%lf %lf)\n", Qi,Qr_e, Qs_e);
            
            if (st!=1 && st!=11 && st!=15 && st!=19) {
                if (st!=14 && st!=15 && st!=16 && st!=17 && st!=18 && st!=19) {
                    Qi += Qr_e * Qs_e * QTu[i_tu][indxR[j]+k1+1][indxS[s]+k2+1] * Pr;
                    if (Qi >= Qpro) {
                        push_block(k1+1, j, k2+1, s, 4, i_tu);
                        if (flag_R)
                            push_block(i, k1, 0, 0, 7, i_td);
                        if (flag_S)
                            push_block(0, 0, r, k2, 7, i_tu);
                        
                        return;
                    }
                }
                
                if (st!=10 && st!=11 && st!=12 && st!=13 && st!=18 && st!=19) {
                    Qi += Qr_e * Qs_e * QTd[i_td][indxR[j]+k1+1][indxS[s]+k2+1] * Ps;
                    if (Qi >= Qpro) {
                        push_block(k1+1, j, k2+1, s, 5, i_td);
                        if (flag_R)
                            push_block(i, k1, 0, 0, 7, i_td);
                        if (flag_S)
                            push_block(0, 0, r, k2, 7, i_tu);
                        
                        return;
                    }
                }
                
                if (st < 10) {
                    Qi += Qr_e*Qs_e*QTe[indxR[j]+k1+1][indxS[s]+k2+1]*Pr*Ps;
                    if (Qi >= Qpro) {
                        push_block(k1+1,j,k2+1,s,6,0);
                        if (flag_R)
                            push_block(i,k1,0,0,7,i_td);
                        if (flag_S)
                            push_block(0,0,r,k2,7,i_tu);
                        
                        return;
                    }
                }
                
                Qi += Qr_e * Qs_e * QDT[st][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(k1+1, j, k2+1, s, 2, st);
                    if (flag_R)
                        push_block(i, k1, 0, 0, 7, i_td);
                    if (flag_S)
                        push_block(0, 0, r, k2, 7, i_tu);
                    
                    return;
                }
                
                if (st==0 || st==10 || st==14 || st==18) {
                    if (flag_R && flag_S) {
                        Qi += Qr_n * Qs_n * QDT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                        if (Qi >= Qpro) {
                            push_block(k1+1, j, k2+1, s, 2, st+1);
                            push_block(i, k1, 0, 0, 7, i_td+4);
                            push_block(0, 0, r, k2, 7, i_tu+4);
                            
                            return;
                        }
                    }
                    
                    Qi += Qr_n * Qs_b * QDT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(k1+1, j, k2+1, s, 2, st+1);
                        push_block(i, k1, 0, 0, 7, i_td+4);
                        
                        return;
                    }
                    
                    Qi += Qr_b * Qs_n * QDT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(k1+1, j, k2+1, s, 2, st+1);
                        push_block(0, 0, r, k2, 7, i_tu+4);
                        
                        return;
                    }
                }
            }
            else if (st == 1) {
                Qi += QDT[1][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(k1+1, j, k2+1, s, 2, 1);
                    return;
                }
            }
            else if (st == 11) {
                Qi += QDT[11][indxR[j]+k1+1][indxS[s]+k2+1] * EXP((k2-r+1)*BETA3);
                if (Qi >= Qpro) {
                    push_block(k1+1, j, k2+1, s, 2, 11);
                    return;
                }
            }
            else if (st == 15) {
                Qi += QDT[15][indxR[j]+k1+1][indxS[s]+k2+1] * EXP((k1-i+1)*BETA3);
                if (Qi >= Qpro) {
                    push_block(k1+1, j, k2+1, s, 2, 15);
                    return;
                }
            }
            else if (st == 19) {
                Qi += QDT[19][indxR[j]+k1+1][indxS[s]+k2+1]
                    * EXP((k1-i+1)*BETA3) * EXP((k2-r+1)*BETA3);
                if (Qi >= Qpro) {
                    push_block(k1+1, j, k2+1, s, 2, 11);
                    return;
                }
            }
        }
    
    printf("\nRT[%d,%d;%d,%d]: invalid place!!\n", i, j, r, s);
}

void decompose_DT(block *T)
{
    int k;
    int G;
    int i, j, r, s;
	int k1, k2, st;
	double seed;
	double Qpro, Qi, Pr, Ps;
	int i_tu, i_td;

	seed = 1 - drand48();

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	st = T->status;

	Qi = 0;
	Qpro = seed * QDT[st][indxR[j]+i][indxS[s]+r];

	if (st == 1) {      //eeb
		Qi += Bond[0][indxR[j]+i][indxS[s]+r] * EXP(SIGMAE0);
		if (Qi >= Qpro) {
            push_block(i, j, r, s, 3, 0);
            return;
		}
    }
	if (st == 11) {     //ekb
		Qi += Bond[2][indxR[j]+i][indxS[s]+r] * EXP(SIGMA0);
		if (Qi >= Qpro) {
            push_block(i, j, r, s, 13, 2);
            return;
		}
    }
	if (st == 15) {     //keb
		Qi += Bond[1][indxR[j]+i][indxS[s]+r] * EXP(SIGMA0);
		if (Qi >= Qpro) {
            push_block(i, j, r, s, 13, 1);
            return;
		}
    }
	if (st == 19) {     //kkb
		Qi += Bond[3][indxR[j]+i][indxS[s]+r] * EXP(SIGMA0);
		if (Qi >= Qpro) {
            push_block(i, j, r, s, 13, 3);
            return;
		}
    }

	for (k1=i+1; k1<j-1; k1++)
        for (k2=r+1; k2<s-1; k2++) {
            if (st==0 || st==2 || st==4 || st==14) {
                i_tu = 0;
                Ps = 1;
            }
            else if (st==3 || st==6 || st==8 || st==16) {
                i_tu = 1;

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[rtype[pair_typeS[k][indxS[k2]+r]]];
                Ps = EXP(((double) G)/num_align);
            }
            else if (st==5 || st==7 || st==9 || st==17) {
                i_tu = 2;
                Ps = EXP(BETA2);
            }
            else if (st==10 || st==12 || st==13 || st==18) {
                i_tu = 2;
                Ps = EXP(BETA2);
            }

            if (st==0 || st==3 || st==5 || st==10) {
                i_td = 0;
                Pr = 1;
            }
            else if (st==2 || st==6 || st==7 || st==12) {
                i_td = 1;
          
                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[pair_typeR[k][indxR[k1]+i]];
                Pr = EXP(((double) G)/num_align);
            }
            else if (st==4 || st==8 || st==9 || st==13) {
                i_td = 2;
                Pr = EXP(BETA2);
            }
            else if (st==14 || st==16 || st==17 || st==18) {
                i_td = 2;
                Pr = EXP(BETA2);
            }

            if (st!=1 && st!=11 && st!=15 && st!=19) {
                Qi += Pr * QTu[i_tu][indxR[k1]+i][indxS[k2]+r] * QRT[st][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 4, i_tu);
                    push_block(k1+1, j, k2+1, s, 1, st);
                    
                    return;
                }
                
                Qi += Ps * QTd[i_td][indxR[k1]+i][indxS[k2]+r] * QRT[st][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 5, i_td);
                    push_block(k1+1, j, k2+1, s, 1, st);
                    
                    return;
                }
                
                Qi += Pr * Ps * QTe[indxR[k1]+i][indxS[k2]+r] * QRT[st][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 6, 0);
                    push_block(k1+1, j, k2+1, s, 1, st);
                    
                    return;
                }
                
                if (st==0 || st==10 || st==14 || st==18) {
                    Qi += Pr * QTu[i_tu][indxR[k1]+i][indxS[k2]+r]
                        * QRT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, i_tu);
                        push_block(k1+1, j, k2+1, s, 1, st+1);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[i_td][indxR[k1]+i][indxS[k2]+r]
                        *QRT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, i_td);
                        push_block(k1+1, j, k2+1, s, 1, st+1);
                        
                        return;
                    }
                    
                    Qi += Pr * Ps * QTe[indxR[k1]+i][indxS[k2]+r]
                        * QRT[st+1][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 6, 0);
                        push_block(k1+1, j, k2+1, s, 1, st+1);
                        
                        return;
                    }
                }
                
                if (st == 10) {
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[10][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 10);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[11][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 11);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[5][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 5);
                        
                        return;
                    }
                }
                
                if (st == 12) {
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[12][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 12);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[7][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 7);
                        
                        return;
                    }
                }
                if (st == 13) {
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[13][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 13);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[9][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 9);
                        
                        return;
                    }
                }
                if (st == 14) {
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[14][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 14);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[15][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 15);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[4][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 4);
                        
                        return;
                    }
                }
                
                if (st == 16) {
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[16][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 16);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[8][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 8);
                        
                        return;
                    }
                }
                
                if (st == 17) {
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[17][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 17);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[9][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 9);
                        
                        return;
                    }
                }
                
                if (st == 18) {
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[17][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 17);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[18][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 18);
                        
                        return;
                    }
                    
                    Qi += Pr * QTu[3][indxR[k1]+i][indxS[k2]+r] * QRT[19][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 4, 3);
                        push_block(k1+1, j, k2+1, s, 1, 19);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[13][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 13);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[18][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 18);
                        
                        return;
                    }
                    
                    Qi += Ps * QTd[3][indxR[k1]+i][indxS[k2]+r] * QRT[19][indxR[j]+k1+1][indxS[s]+k2+1];
                    if (Qi >= Qpro) {
                        push_block(i, k1, r, k2, 5, 3);
                        push_block(k1+1, j, k2+1, s, 1, 19);
                        
                        return;
                    }
                }
            }
            else if (st == 1) {		//eeb
                Qi += Bond[0][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMAE0)
                    * QRT[0][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 3, 0);
                    push_block(k1+1, j, k2+1, s, 1, 0);
                    
                    return;
                }
            }
            else if (st == 11) {	//ekb
                Qi += Bond[2][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[10][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 2);
                    push_block(k1+1, j, k2+1, s, 1, 10);
                    
                    return;
                }  

                Qi += Bond[2][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[5][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 2);
                    push_block(k1+1, j, k2+1, s, 1, 5);
                    
                    return;
                }
            }
            else if (st == 15) {	//keb
                Qi += Bond[1][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[14][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 1);
                    push_block(k1+1, j, k2+1, s, 1, 14);
                    
                    return;
                }
                
                Qi += Bond[1][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[4][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 1);
                    push_block(k1+1, j, k2+1, s, 1, 4);
                    
                    return;
                }
            }
            else if (st == 19) {	//kkb
                Qi += Bond[3][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[18][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 3);
                    push_block(k1+1, j, k2+1, s, 1, 18);
                    
                    return;
                }
                
                Qi += Bond[3][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[13][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 3);
                    push_block(k1+1, j, k2+1, s, 1, 13);
                    
                    return;
                }
                
                Qi += Bond[3][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[17][indxR[j]+k1+1][indxS[s]+k2+1];
                if (Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 3);
                    push_block(k1+1, j, k2+1, s, 1, 17);
                    
                    return;
                }
                
                Qi += Bond[3][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA0)
                    * QRT[9][indxR[j]+k1+1][indxS[s]+k2+1];
                if(Qi >= Qpro) {
                    push_block(i, k1, r, k2, 13, 3);
                    push_block(k1+1, j, k2+1, s, 1, 9);
                    
                    return;
                } 
            }
        }

	printf("\nDT[%d,%d;%d,%d] with status %d: invalid place!!\n", i, j, r, s, st);
}

void decompose_sec_struc(block *T)
{
    int k;
    int i, j, r, s;
	int st, status, d, e, type_2, type_2i;
    int up = 1;   //up=1 R   up=0 S
	double seed;
	double Qi, Qpro;
	int G;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	status = st = T->status;

	if (i==0 && j==0)  //S
        up = 0;   
	else if (r==0 && s==0)  //R
        up = 1;      

	seed = 1 - drand48();
	Qi = 0;

    //empty structures
	if (st == 0) {    //e
        Qi += 1.0;
	}
    else if (st == 1) {   //m
        if (up) 
            Qi += (j-i+1)*P->MLbase;
        else 
            Qi += (s-r+1)*P->MLbase;
	}
    else if (st==2 || st==3) {  //f and k
        if (up)
            Qi += (j-i+1)*BETA3;
        else 
            Qi += (s-r+1)*BETA3;
	}
	if (st >= 4)
        st -= 4; 
	  
	if (up && st==0) {
        if (status == 0)
            Qpro = seed*QR[indxR[j]+i];
        else if (status == 4)
            Qpro = seed*(QR[indxR[j]+i]-1.0);
        if (Qi >= Qpro)     //empty structures are not pushed into stack
            return;
      
        for (d=i; d<j-TURN-2; d++)
            for (e=d+TURN+3; e<=j; e++) {
                type_2 = pair_typeR[0][indxR[e]+d];
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;
            
                if (d == i)
                    Qi += QbR[indxR[e]+d];
                else
                    Qi += QR[indxR[d-1]+i] * QbR[indxR[e]+d];
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);        //Qb
                    if (d != i)
                        push_block(i, d-1, 0, 0, 7, 0);   //Sec
                
                    return;
                }
            }
	}
    else if (up && st==1) {     //contained in a multi-loop
        if (status == 1)
            Qpro = seed*(QmR[indxR[j]+i]+(j-i+1)*P->MLbase);
        else if (status == 5)
            Qpro = seed*QmR[indxR[j]+i];
        if (Qi >= Qpro)
            return;
     
        for (d=i; d<j-TURN-2; d++)
            for (e=d+TURN+3; e<=j; e++) {
                type_2 = pair_typeR[0][indxR[e]+d];
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;
                
                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[pair_typeR[k][indxR[e]+d]] + (d-i+j-e)*P->MLbase;
                Qi += QbR[indxR[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);
                    return;
                }

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[pair_typeR[k][indxR[e]+d]] + (j-e)*P->MLbase;
                if (d != i)
                    Qi += QmR[indxR[d-1]+i]*QbR[indxR[e]+d]*EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);       //Qb
                    push_block(i, d-1, 0, 0, 7, 1);     //Sec contained in a multi-loop
                  
                    return;
                }
            }
	}
    else if (up && (st==2 || st==3)) {      //contained in a kissing loop
        if (status==2 || status==3)
            Qpro = seed*(QfR[indxR[j]+i]+(j-i+1)*BETA3);
        else if (status==6 || status==7)
            Qpro = seed*QfR[indxR[j]+i];
        if (Qi >= Qpro)
            return;
       
        for (d=i; d<j-TURN-2; d++) 
            for (e=d+TURN+3; e<=j; e++) {
                type_2 = pair_typeR[0][indxR[e]+d];
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;
              
                G = BETA2+(d-i+j-e)*BETA3;
                Qi += QbR[indxR[e]+d] * EXP(G);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);
                    return;
                }

                G = BETA2+(j-e)*BETA3;
                if (d != i)
                    Qi += QfR[indxR[d-1]+i]*QbR[indxR[e]+d]*EXP(G);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);       //Qb
                    push_block(i, d-1, 0, 0, 7, 2);     //Sec contained in a kissing loop
                    
                    return;
                }
            }
	}
    else if (!up && st==0) {
        if (status == 0)
            Qpro = seed*QS[indxS[s]+r];
        else if (status == 4)
            Qpro = seed*(QS[indxS[s]+r]-1.0);
        if (Qi >= Qpro)
            return;

        for (d=r; d<s-TURN-2; d++)
            for (e=d+TURN+3; e<=s; e++) {
                type_2 = pair_typeS[0][indxS[e]+d];
                type_2i = pair_typeS[0][indxS[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;
              
                if (e == s)
                    Qi += QbS[indxS[e]+d];
                else
                    Qi += QbS[indxS[e]+d] * QS[indxS[s]+e+1];
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);
                    if (e != s)
                        push_block(0, 0, e+1, s, 7, 0);
                  
                    return;
                }
            }
	}
    else if (!up && st==1) {
        if (status == 1)
            Qpro = seed*(QmS[indxS[s]+r]+(s-r+1)*P->MLbase);
        else if (status == 5)
            Qpro = seed*QmS[indxS[s]+r];
        if (Qi >= Qpro)
            return;
     
        for (d=r; d<s-TURN-2; d++)
            for (e=d+TURN+3; e<=s; e++) {
                type_2 = pair_typeS[0][indxS[e]+d];
                type_2i = pair_typeS[0][indxS[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + (d-r+s-e)*P->MLbase;
                Qi += QbS[indxS[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);
                    return;
                }

                G = 0;
                for (k=1; k<=num_align; k++)
                    G += P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]]+(d-r)*P->MLbase;
                if (e != s)
                    Qi += QmS[indxS[s]+e+1]*QbS[indxS[e]+d]*EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);
                    push_block(0, 0, e+1, s, 7, 1);
                  
                    return;
                }
            }
	}
    else if (!up && (st==2 || st==3)) {
        if (status==2 || status==3)
            Qpro = seed*(QfS[indxS[s]+r]+(s-r+1)*BETA3);
        else if (status==6 || status==7)
            Qpro = seed*QfS[indxS[s]+r];
        if (Qi >= Qpro)
            return;
     
        for (d=r; d<s-TURN-2; d++)
            for (e=d+TURN+3; e<=s; e++) {
                type_2 = pair_typeS[0][indxS[e]+d];
                type_2i = pair_typeS[0][indxS[e-1]+d+1];
                if (type_2==NO_PAIR || type_2i==NO_PAIR)
                    continue;
            
                G = BETA2+(d-r+s-e)*BETA3;
                Qi += QbS[indxS[e]+d]*EXP(G);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);
                    return;
                }

                G = BETA2+(d-r)*BETA3;
                if (e != s)
                    Qi += QbS[indxS[e]+d]*QfS[indxS[s]+e+1]*EXP(G);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);
                    push_block(0, 0, e+1, s, 7, 2);
                
                    return;
                }
            }
	}

    if (up)
        printf("\nQR[%d,%d] of status %d with %f: invalid place!!\n", i, j, st, Qi);
    else
        printf("\nQS[%d,%d] of status %d with %f: invalid place!!\n", r, s, st, Qi);
} 

/** 
 * decompose block Qb, in which (i,j) and (i+1,j-1)
 * are both base pairs
 * 
 * @param stringR: sequence R
 * @param stringS: sequence S
 * @param T: block to be decomposed
 */
void decompose_Qb(char **seqs_r, char **seqs_s_53, block *T)
{
    //R and S are both from 5' to 3'
    int i, j, r, s;
	int d, e, up, k;
    int tmp_type, tmp_type_2;
    int type2, type2i;
	double seed;
	double Qi, Qpro;
	int G, *stack_G;
    int bonus = 0;
	char **string;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	if (i==0 && j==0)
        up = 0;       // S
	else if (r==0 && s==0)
        up = 1;  // R

	seed = 1-drand48();

	Qi = 0;
	if (up) {
        string = seqs_r;
        
        Sample[j] = i;
        Sample[i] = j;
        Sample[j-1] = i+1;
        Sample[i+1] = j-1;

        if (constraint) {
            if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
                bonus -= PF_BONUS;
            if (BP[j]==-1 || BP[j]==-3)
                bonus -= PF_BONUS;
            if (BP[i+1]==j-1 || BP[i+1]==-1 || BP[i+1]==-4)
                bonus -= PF_BONUS;
            if (BP[j-1]==-1 || BP[j-1]==-3)
                bonus -= PF_BONUS;
        }
        
        Qpro = (QbR[indxR[j]+i]/EXP(bonus))*seed;
	}
    else {
        string = seqs_s_53;
        Sample[len_r+len_s-s+1] = len_r+len_s-r+1;
        Sample[len_r+len_s-r+1] = len_r+len_s-s+1;
        Sample[len_r+len_s-s+2] = len_r+len_s-r;
        Sample[len_r+len_s-r] = len_r+len_s-s+2;

        if (constraint) {
            if (BP[BP[0]+r+1]==s || BP[BP[0]+r+1]==-1 || BP[BP[0]+r+1]==-3)
                bonus -= PF_BONUS;
            if (BP[BP[0]+s+1]==-1 || BP[BP[0]+s+1]==-4)
                bonus -= PF_BONUS;
            if (BP[BP[0]+r+2]==s-1 || BP[BP[0]+r+2]==-1 || BP[BP[0]+r+2]==-3)
                bonus -= PF_BONUS;
            if (BP[BP[0]+s]==-1 || BP[BP[0]+s]==-4)
                bonus -= PF_BONUS;
        }
        
        Qpro = (QbS[indxS[s]+r]/EXP(bonus))*seed;
	}

    stack_G = (int *) space(sizeof(int)*(num_align+1));

	if (up) {
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeR[k][indxR[j]+i];
            tmp_type_2 = pair_typeR[k][indxR[j-1]+i+1];
            
            if (tmp_type == 0)
                tmp_type = 7;
            if (tmp_type_2 == 0)
                tmp_type_2 = 7;
            stack_G[k] = P->stack[tmp_type][rtype[tmp_type_2]];
        }
        
        // hairpin loop
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeR[k][indxR[j-1]+i+1];
            
            if (tmp_type == 0)
                tmp_type = 7;
            G += calc_hairpin_energy(string[k]+i, j-i-3, tmp_type, aSR[k][i+2], aSR[k][j-2])+stack_G[k];
        }
        Qi += EXP(((double) G)/num_align);
        if (Qi >= Qpro) {
            free(stack_G);
            return;
        }
        
        //QbsR is embedded in QbR
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeR[k][indxR[j-1]+i+1];
            tmp_type_2 = pair_typeR[k][indxR[j-2]+i+2];
            
            if (tmp_type == 0)
                tmp_type = 7;
            if (tmp_type_2 == 0)
                tmp_type_2 = 7;
            G += stack_G[k] + P->stack[tmp_type][rtype[tmp_type_2]];
        }
        Qi += QbsR[indxR[j-2]+i+2] * EXP(((double) G)/num_align);
        if (Qi >= Qpro) {
            push_block(i+2, j-2, 0, 0, 9, 0);     //QbsR
            free(stack_G);
            return;
        }
        
        //interior loop
        for (d=i+2; d<j-TURN-4; d++)	
            for (e=d+TURN+3; e<j-1; e++) {
                type2 = pair_typeR[0][indxR[e]+d];
                type2i = pair_typeR[0][indxR[e-1]+d+1];
                if (type2==NO_PAIR || type2i==NO_PAIR)
                    continue;

                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    tmp_type = pair_typeR[k][indxR[j-1]+i+1];
                    tmp_type_2 = pair_typeR[k][indxR[e]+d];
                    
                    if (tmp_type == 0)
                        tmp_type = 7;
                    if (tmp_type_2 == 0)
                        tmp_type_2 = 7;
                    G += calc_interior_energy(d-i-2, j-e-2, tmp_type, rtype[tmp_type_2],
                                              aSR[k][i+2], aSR[k][j-2], aSR[k][d-1], aSR[k][e+1])+stack_G[k];
                }
                Qi += QbR[indxR[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);   //QbR
                    free(stack_G);
                    return;
                }
                
                //multi-loop
                if ((d-i-3) >= (TURN+3)) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                            + P->MLintern[pair_typeR[k][indxR[e]+d]] + (j-e-2)*P->MLbase+stack_G[k];
                    }
                    Qi += QmR[indxR[d-1]+i+2] * QbR[indxR[e]+d] * EXP(((double) G)/num_align);
                    if (Qi >= Qpro) {
                        push_block(d, e, 0, 0, 8, 0);       //QbR
                        push_block(i+2, d-1, 0, 0, 7, 5);   //Sec contained in a multi-loop
                        free(stack_G);
                        return;
                    }
                }
            }
	}
    else {
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeS[k][indxS[s]+r];
            tmp_type_2 = pair_typeS[k][indxS[s-1]+r+1];
            
            if (tmp_type == 0)
                tmp_type = 7;
            if (tmp_type_2 == 0)
                tmp_type_2 = 7;
            stack_G[k] = P->stack[rtype[tmp_type]][tmp_type_2];
        }
        
        //hairpin loop
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeS[k][indxS[s-1]+r+1];
            
            if (tmp_type == 0)
                tmp_type = 7;
            G += calc_hairpin_energy(string[k]+len_s-s+1, s-r-3, rtype[tmp_type], aSS[k][s-2], aSS[k][r+2])
                + stack_G[k];
        }
        Qi += EXP(((double) G)/num_align);
        if (Qi >= Qpro) {
            free(stack_G);
            return;
        }
        
        //QbsS is embedded in QbS
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeS[k][indxS[s-1]+r+1];
            tmp_type_2 = pair_typeS[k][indxS[s-2]+r+2];
            
            if (tmp_type == 0)
                tmp_type = 7;
            if (tmp_type_2 == 0)
                tmp_type_2 = 7;
            G += stack_G[k] + P->stack[rtype[tmp_type]][tmp_type_2];
        }
        Qi += QbsS[indxS[s-2]+r+2] * EXP(((double) G)/num_align);   //fix the index of QbsS
        if (Qi >= Qpro) {
            push_block(0, 0, r+2, s-2, 9, 0);     //QbsS
            free(stack_G);
            return;
        }
        
        for (d=r+2; d<s-TURN-4; d++)	
            for (e=d+TURN+3; e<s-1; e++) {
                type2 = pair_typeS[0][indxS[e]+d];
                type2i = pair_typeS[0][indxS[e-1]+d+1];
                if (type2==NO_PAIR || type2i==NO_PAIR)
                    continue;
                
                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    tmp_type = pair_typeS[k][indxS[s-1]+r+1];
                    tmp_type_2 = pair_typeS[k][indxS[e]+d];
                    
                    if (tmp_type == 0)
                        tmp_type = 7;
                    if (tmp_type_2 == 0)
                        tmp_type_2 = 7;
                    G += calc_interior_energy(s-e-2, d-r-2, rtype[tmp_type], tmp_type_2,
                                              aSS[k][s-2], aSS[k][r+2], aSS[k][e+1], aSS[k][d-1])+stack_G[k];
                }
                Qi += QbS[indxS[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);   //QbS
                    free(stack_G);
                    return;
                }
                
                //multi-loop
                if ((s-e-3) >= (TURN+3)) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s-1]+r+1]]]
                            + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + (d-r-2)*P->MLbase+stack_G[k];
                    }
                    Qi += QbS[indxS[e]+d] * QmS[indxS[s-2]+e+1] * EXP(((double) G)/num_align);
                    if (Qi >= Qpro) {
                        push_block(0, 0, d, e, 8, 0);           //Qbs
                        push_block(0, 0, e+1, s-2, 7, 5);       //Sec contained in a multi-loop
                        free(stack_G);
                        return;
                    }
                }
            }
	}

    if (up)
        printf("\nQbR[%d,%d]: invalid place!!\n", i, j);
    else
        printf("\nQbS[%d,%d]: invalid place!!\n", r, s);
}

/** 
 * decompose block Qbs, in which i and j are paired, i+1 and j-1
 * are not paired with each other
 * 
 * @param stringR: sequence R
 * @param stringS: sequence S
 * @param T: block to be decomposed
 */
void decompose_Qbs(char **seqs_r, char **seqs_s_53, block *T)
{
    //R and S are both from 5' to 3'
    int i, j, r, s;
    int tmp_type, tmp_type_2;
    int d, e, up, type2, type2i, k;
	double seed;
	double Qi, Qpro;
	int G;
    int bonus = 0;
	char **string;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	if (i==0 && j==0)     //S
        up = 0;
	else if (r==0 && s==0)    //R
        up = 1;

	seed = 1 - drand48();
	Qi = 0;
    
	if (up) {
        string = seqs_r;
        Sample[j] = i;
        Sample[i] = j;

        if (constraint) {
            if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
                bonus -= PF_BONUS;
            if (BP[j]==-1 || BP[j]==-3)
                bonus -= PF_BONUS;
        }
        
        Qpro = (QbsR[indxR[j]+i]/EXP(bonus))*seed;
	}
    else {
        string = seqs_s_53;
        Sample[len_r+len_s-s+1] = len_r+len_s-r+1;
        Sample[len_r+len_s-r+1] = len_r+len_s-s+1;

        if (constraint) {
            if (BP[BP[0]+r+1]==s || BP[BP[0]+r+1]==-1 || BP[BP[0]+r+1]==-3)
                bonus -= PF_BONUS;
            if (BP[BP[0]+s+1]==-1 || BP[BP[0]+s+1]==-4)
                bonus -= PF_BONUS;
        }
        
        Qpro = (QbsS[indxS[s]+r]/EXP(bonus))*seed;
	}

	if (up) {       //R
        //hairpin loop
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeR[k][indxR[j]+i];
            
            if (tmp_type == 0)
                tmp_type = 7;
            G += calc_hairpin_energy(string[k]+i-1, j-i-1, tmp_type, aSR[k][i+1], aSR[k][j-1]);
        }
        Qi += EXP(((double) G)/num_align);
        if (Qi >= Qpro)
            return;
        
        for (d=i+1; d<j-TURN-3; d++)	
            for (e=d+TURN+3; e<j; e++) {
                type2 = pair_typeR[0][indxR[e]+d];
                type2i = pair_typeR[0][indxR[e-1]+d+1];
                if (type2==NO_PAIR || type2i==NO_PAIR)
                    continue;
                if (d==i+1 && e==j-1)
                    continue;
                
                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    tmp_type = pair_typeR[k][indxR[j]+i];
                    tmp_type_2 = pair_typeR[k][indxR[e]+d];
                    
                    if (tmp_type == 0)
                        tmp_type = 7;
                    if (tmp_type_2 == 0)
                        tmp_type_2 = 7;
                    G += calc_interior_energy(d-i-1, j-e-1, tmp_type, rtype[tmp_type_2],      
                                              aSR[k][i+1], aSR[k][j-1], aSR[k][d-1], aSR[k][e+1]);
                }
                Qi += QbR[indxR[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, 0, 0, 8, 0);   //QbR
                    return;
                }
                
                //multi-loop
                if ((d-i-2) >= (TURN+3)) {
                    G = 0;
                    for (k=1; k<=num_align; k++) {
                        G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                            + P->MLintern[pair_typeR[k][indxR[e]+d]] + (j-e-1)*P->MLbase;
                    }
                    Qi += QmR[indxR[d-1]+i+1] * QbR[indxR[e]+d] * EXP(((double) G)/num_align);
                    if (Qi >= Qpro) {
                        push_block(d, e, 0, 0, 8, 0);   //QbR
                        push_block(i+1, d-1, 0, 0, 7, 5);     //Sec contained in a multi-loop
                        
                        return;
                    }
                }
            }
	}
    else {      //S
        //hairpin loop
        G = 0;
        for (k=1; k<=num_align; k++) {
            tmp_type = pair_typeS[k][indxS[s]+r];

            if (tmp_type == 0)
                tmp_type = 7;
            G += calc_hairpin_energy(string[k]+len_s-s, s-r-1, rtype[tmp_type], aSS[k][s-1], aSS[k][r+1]);
        }
        Qi += EXP(((double) G)/num_align);
        if (Qi >= Qpro)
            return;
        
        for (d=r+1; d<s-TURN-3; d++)	
            for (e=d+TURN+3; e<s; e++) {
                type2 = pair_typeS[0][indxS[e]+d];
                type2i = pair_typeS[0][indxS[e-1]+d+1];
                if (type2==NO_PAIR || type2i==NO_PAIR)
                    continue;
                if (d==r+1 && e==s-1)
                    continue;
                
                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    tmp_type = pair_typeS[k][indxS[s]+r];
                    tmp_type_2 = pair_typeS[k][indxS[e]+d];
                    
                    if (tmp_type == 0)
                        tmp_type = 7;
                    if (tmp_type_2 == 0)
                        tmp_type_2 = 7;
                    G += calc_interior_energy(s-e-1, d-r-1, rtype[tmp_type], tmp_type_2,
                                              aSS[k][s-1], aSS[k][r+1], aSS[k][e+1], aSS[k][d-1]);
                }
                Qi += QbS[indxS[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(0, 0, d, e, 8, 0);   //QbS
                    return;
                }
                
                //multi-loop
                if ((s-e-2) >= (TURN+3)) {
                    G = 0;
                    for (k=1; k<=num_align; k++)  {
                        G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s]+r]]]
                            + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + (d-r-1)*P->MLbase;
                    }
                    Qi += QbS[indxS[e]+d] * QmS[indxS[s-1]+e+1] * EXP(((double) G)/num_align);
                    if (Qi >= Qpro) {
                        push_block(0, 0, d, e, 8, 0);           //QbS
                        push_block(0, 0, e+1, s-1, 7, 5);       //Sec contained in a multi-loop
                        
                        return;
                    }
                }
            }
	}

    if (up)
        printf("\nQbsR[%d,%d]: invalid place!!\n", i, j);
    else
        printf("\nQbsS[%d,%d]: invalid place!!\n", r, s);
}


void decompose_hybrid_EE (block *T)
{
	int k1, k2, m, typek, k;
    int type1, type2;
    int i, j, r, s;
	double seed;
	double Qi, Qpro;
	int G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	seed = 1 - drand48();
	m = Sample[0];
	Qi = 0;

    /*
    Sample[i] = m-r+1;
    Sample[m-r+1] = i;
    Sample[j] = m-s+1;
    Sample[m-s+1] = j;
    */

    if (constraint) {
        if (BP[i]==BP[0]+r+1 || BP[i]==-2)
            bonus -= PF_BONUS;
        if (BP[j]==BP[0]+s+1 || BP[j]==-2)
            bonus -= PF_BONUS;
        if (BP[BP[0]+r+1]==-2)
            bonus -= PF_BONUS;
        if (BP[BP[0]+s+1]==-2)
            bonus -= PF_BONUS;
    }
    
    Qpro = (Bond[0][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
    
    //only two interactions
    G = 0;
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeHy[k][i][r];
        type2 = pair_typeHy[k][j][s];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        G += calc_interior_energy(j-i-1, s-r-1, type1, rtype[type2],
                                  aSR[k][i+1], aSS[k][r+1], aSR[k][j-1], aSS[k][s-1]);
    }
    Qi += EXP(SIGMAE*((double) G)/num_align);
    if (Qi >= Qpro) {
        Sample[i] = m-r+1;
        Sample[m-r+1] = i;
        Sample[j] = m-s+1;
        Sample[m-s+1] = j;
        
        return;
    }
    
    //more than two interactions
    for (k1=i+1; k1<j; k1++)
        for (k2=r+1; k2<s; k2++) {
            typek = pair_typeHy[0][k1][k2];
            if (typek == NO_PAIR)
                continue;

            G = 0;
            for (k=1; k<=num_align; k++) {
                type1 = pair_typeHy[k][k1][k2];
                type2 = pair_typeHy[k][j][s];
                
                if (type1 == 0)
                    type1 = 7;
                if (type2 == 0)
                    type2 = 7;
                G += calc_interior_energy(j-k1-1, s-k2-1, type1, rtype[type2],
                                          aSR[k][k1+1], aSS[k][k2+1], aSR[k][j-1], aSS[k][s-1]);
            }
            Qi += Bond[0][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMAE*((double) G)/num_align);
            if (Qi >= Qpro) {
                Sample[j] = m-s+1;
                Sample[m-s+1] = j;
                push_block(i, k1, r, k2, 3, 0); //(i,k1,r,k2) forms a smaller pseudo-hybrid
                
                return;
            }
        }

    printf("\nHybrid[%d,%d;%d,%d]: invalid place!!\n", i, j, r, s);
}

void decompose_hybrid (block *T)
{
	int k1, k2, m, typek, k;
    int type1, type2;
    int i, j, r, s;
	double seed;
	double Qi, Qpro;
	int G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	seed = 1 - drand48();
	m = Sample[0];
	Qi = 0;

    /*
    Sample[i] = m-r+1;
    Sample[m-r+1] = i;
    Sample[j] = m-s+1;
    Sample[m-s+1] = j;
    */

    if (constraint) {
        if (BP[i]==BP[0]+r+1 || BP[i]==-2)
            bonus -= PF_BONUS;
        if (BP[j]==BP[0]+s+1 || BP[j]==-2)
            bonus -= PF_BONUS;
        if (BP[BP[0]+r+1]==-2)
            bonus -= PF_BONUS;
        if (BP[BP[0]+s+1]==-2)
            bonus -= PF_BONUS;
    }
    
    Qpro = (Bond[1][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
    
    //only two interactions
    G = 0;
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeHy[k][i][r];
        type2 = pair_typeHy[k][j][s];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        G += calc_interior_energy(j-i-1, s-r-1, type1, rtype[type2],
                                  aSR[k][i+1], aSS[k][r+1], aSR[k][j-1], aSS[k][s-1]);
    }
    Qi += EXP(SIGMA*((double) G)/num_align);
    if (Qi >= Qpro) {
        Sample[i] = m-r+1;
        Sample[m-r+1] = i;
        Sample[j] = m-s+1;
        Sample[m-s+1] = j;
        
        return;
    }
    
    //more than two interactions
    for (k1=i+1; k1<j; k1++)
        for (k2=r+1; k2<s; k2++) {
            typek = pair_typeHy[0][k1][k2];
            if (typek == NO_PAIR)
                continue;

            G = 0;
            for (k=1; k<=num_align; k++) {
                type1 = pair_typeHy[k][k1][k2];
                type2 = pair_typeHy[k][j][s];
                
                if (type1 == 0)
                    type1 = 7;
                if (type2 == 0)
                    type2 = 7;
                G += calc_interior_energy(j-k1-1, s-k2-1, type1, rtype[type2],
                                          aSR[k][k1+1], aSS[k][k2+1], aSR[k][j-1], aSS[k][s-1]);
            }
            Qi += Bond[1][indxR[k1]+i][indxS[k2]+r] * EXP(SIGMA*((double) G)/num_align);
            if (Qi >= Qpro) {
                Sample[j] = m-s+1;
                Sample[m-s+1] = j;
                push_block(i, k1, r, k2, 3, 0); //(i,k1,r,k2) forms a smaller pseudo-hybrid
                
                return;
            }
        }

    printf("\nHybrid[%d,%d;%d,%d]: invalid place!!\n", i, j, r, s);
}

/** 
 * decompose Tsu, in which (i,j) is base pair and i+1,
 * j-1 can not be paired with each other
 * 
 * @param T: block Tsu
 */
void decompose_Tsu(block *T)
{
    int i, j, r, s;
    int d, e, st, i_m, i_d, i_e, k;
    int type1, type2;
    int type_2, type_2i;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	st = T->status;
	seed = 1 - drand48();
	Qi = 0;

	Sample[i] = j;
	Sample[j] = i;
    
    if (constraint) {
        if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
            bonus -= PF_BONUS;
        if (BP[j]==-1 || BP[j]==-3)
            bonus -= PF_BONUS;
    }
    
    Qpro = (QTsu[st][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
	/* type = pair_typeR[0][indxR[j]+i]; */
  
	if (st == 0) {          //e
        i_m = 2;
        i_d = 14;
        i_e = 15 ;
	}
    else if (st == 1) {     //m
        i_m = 6;
        i_d = 16;
        i_e = -1;
	}
    else if (st == 2) {     //f
        i_m = 7; 
        i_d = 17;
        i_e = -1;
    }
    else if (st == 3) {     //k
        i_m = 12;
        i_d = 18;
        i_e = 19;
	}
    
    for (d=i+1; d<j-1; d++)
        for (e=d+1; e<j; e++) {
            type_2 = pair_typeR[0][indxR[e]+d];
            if ((e-d-2) >= TURN+1)
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
            else
                type_2i = NO_PAIR;
            
            if (type_2==PAIR && type_2i==PAIR && (d!=i+1 || e!=j-1)) {
                //I
                G = 0;
                for (k=1; k<=num_align; k++) {
                    type1 = pair_typeR[k][indxR[j]+i];
                    type2 = pair_typeR[k][indxR[e]+d];

                    if (type1 == 0)
                        type1 = 7;
                    if (type2 == 0)
                        type2 = 7;
                    G += calc_interior_energy(d-i-1, j-e-1, type1, rtype[type2], 
                                              aSR[k][i+1], aSR[k][j-1], aSR[k][d-1], aSR[k][e+1]);
                }
                Qi += QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 4, st);  //Tu
                    return;
                }
                
                //Tu-M
                if (!(d-i-1<TURN+4 && j-e-1<TURN+4)) {
                    if (d-i-1 >= TURN+4) {
                        left = QmR[indxR[d-1]+i+1];
                        right = EXP((j-e-1)*P->MLbase);
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += left * right * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);  //Tu
                            push_block(i+1, d-1, 0, 0, 7, 5);  //Sec not empty contained in a multi-loop
                            
                            return;
                        }
                    }
                    
                    if (j-e-1>=TURN+4) {
                        left = EXP((d-i-1)*P->MLbase);
                        right = QmR[indxR[j-1]+e+1];
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += left * right * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);  
                            push_block(e+1, j-1, 0, 0, 7, 5);
                            
                            return;
                        }
                    }
                    
                    if (d-i-1>=TURN+4 && j-e-1>=TURN+4) {
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += QmR[indxR[d-1]+i+1] * QmR[indxR[j-1]+e+1]
                            * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);
                            push_block(i+1, d-1, 0, 0, 7, 5);
                            push_block(e+1, j-1, 0, 0, 7, 5);
                            
                            return;
                        }
                    }
                }
            }
            
            //DT-M
            if (d-i-1 < TURN+4) { 
                left = EXP((d-i-1)*P->MLbase);
                flag_L = 0;
            }
            else { 
                left = QmR[indxR[d-1]+i+1] + EXP((d-i-1)*P->MLbase);
                flag_L = 1;
            }
            if (j-e-1 < TURN+4) {
                right = EXP((j-e-1)*P->MLbase);
                flag_R = 0;
            }
            else { 
                right = QmR[indxR[j-1]+e+1] + EXP((j-e-1)*P->MLbase);
                flag_R = 1;
            }
            
            G = 0;
            for (k=1; k<=num_align; k++)
                G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]];
            Qi += left * right * QDT[i_m][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 2, i_m); //DT
                if (flag_L)
                    push_block(i+1, d-1, 0, 0, 7, 1);  //Sec
                if (flag_R)
                    push_block(e+1, j-1, 0, 0, 7, 1);  //Sec
                
                return;
            }
            
            //DT-K
            if (d-i-1 < TURN+4) { 
                left = EXP((d-i-1)*BETA3);
                flag_L = 0;
            }
            else { 
                left = QfR[indxR[d-1]+i+1] + EXP((d-i-1)*BETA3);
                flag_L = 1;
            }
            if (j-e-1 < TURN+4) {
                right = EXP((j-e-1)*BETA3);
                flag_R = 0;
            }
            else { 
                right = QfR[indxR[j-1]+e+1] + EXP((j-e-1)*BETA3);
                flag_R = 1;
            }
            
            G = BETA1+BETA2;
            Qi += left * right * QDT[i_d][indxR[e]+d][indxS[s]+r] * EXP(G);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 2, i_d);     //DT
                if (flag_L)
                    push_block(i+1, d-1, 0, 0, 7, 2);  //Sec in a kissing loop
                if (flag_R)
                    push_block(e+1, j-1, 0, 0, 7, 2);
                
                return;
            }
            //DT-K  of type B
            if (i_e != -1) {
                Qi += left * right * QDT[i_e][indxR[e]+d][indxS[s]+r] * EXP(G);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 2, i_e);
                    if (flag_L)
                        push_block(i+1, d-1, 0, 0, 7, 2);
                    if (flag_R)
                        push_block(e+1, j-1, 0, 0, 7, 2);
                    
                    return;
                }
            }
        }
    
	printf("\nTsu[%d,%d;%d,%d] with status %d: invalid place!!\n", i, j, r, s, st);
}

/** 
 * decompose Tu, in which (i,j) and (i+1,j-1) are both
 * base pairs
 * 
 * @param T: block Tu
 */
void decompose_Tu(block *T)
{
    int i, j, r, s;
	int d, e, st, i_m, i_d, i_e, k;
    int type1, type2;
    int type_2, type_2i;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G, *stack_G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;

	st = T->status;
	seed = 1 - drand48();
	Qi = 0;

	Sample[i] = j;
	Sample[j] = i;
    Sample[i+1] = j-1;
    Sample[j-1] = i+1;

    if (constraint) {
        if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
            bonus -= PF_BONUS;
        if (BP[j]==-1 || BP[j]==-3)
            bonus -= PF_BONUS;
        if (BP[i+1]==j-1 || BP[i+1]==-1 || BP[i+1]==-4)
            bonus -= PF_BONUS;
        if (BP[j-1]==-1 || BP[j-1]==-3)
            bonus -= PF_BONUS;
    }
    
    Qpro = (QTu[st][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
    stack_G = (int *) space(sizeof(int)*(num_align+1));
	
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeR[k][indxR[j]+i];
        type2 = pair_typeR[k][indxR[j-1]+i+1];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        stack_G[k] = P->stack[type1][rtype[type2]];
    }

	if (st == 0) {            //e
        i_m = 2;
        i_d = 14;
        i_e = 15 ;
	}
    else if (st == 1) {     //m
        i_m = 6;
        i_d = 16;
        i_e = -1;
	}
    else if (st == 2) {     //f
        i_m = 7; 
        i_d = 17;
        i_e = -1;
	}
    else if (st == 3) {     //k
        i_m = 12;
        i_d = 18;
        i_e = 19;
	}

    //Tsu is contained
    G = 0;
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeR[k][indxR[j-1]+i+1];
        type2 = pair_typeR[k][indxR[j-2]+i+2];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        G += stack_G[k] + P->stack[type1][rtype[type2]];
    }
    Qi += QTsu[st][indxR[j-2]+i+2][indxS[s]+r] * EXP(((double) G)/num_align);
    if (Qi >= Qpro) {
        push_block(i+2, j-2, r, s, 10, st);   //Tsu
        free(stack_G);
        return;
    }
    
    for (d=i+2; d<j-2; d++)
        for (e=d+1; e<j-1; e++) {
            type_2 = pair_typeR[0][indxR[e]+d];
            if ((e-d-2) >= TURN+1)
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
            else
                type_2i = NO_PAIR;

            if (type_2==PAIR && type_2i==PAIR) {
                //I
                G = 0;
                for (k=1; k<=num_align; k++) {
                    type1 = pair_typeR[k][indxR[j-1]+i+1];
                    type2 = pair_typeR[k][indxR[e]+d];

                    if (type1 == 0)
                        type1 = 7;
                    if (type2 == 0)
                        type2 = 7;
                    G += calc_interior_energy(d-i-2, j-e-2, type1, rtype[type2], 
                                              aSR[k][i+2], aSR[k][j-2], aSR[k][d-1], aSR[k][e+1])+stack_G[k];
                }
                Qi += QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 4, st);  //Tu
                    free(stack_G);
                    return;
                }
                
                //Tu-M
                if (!(d-i-2<TURN+4 && j-e-2<TURN+4)) {
                    if (d-i-2 >= TURN+4) {
                        left = QmR[indxR[d-1]+i+2];
                        right = EXP((j-e-2)*P->MLbase);
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += left * right * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);  //Tu
                            push_block(i+2, d-1, 0, 0, 7, 5);  //Sec not empty contained in a multi-loop
                            free(stack_G);
                            return;
                        }
                    }
                
                    if (j-e-2 >= TURN+4) {
                        left = EXP((d-i-2)*P->MLbase);
                        right = QmR[indxR[j-2]+e+1];
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += left * right * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);  
                            push_block(e+1, j-2, 0, 0, 7, 5);
                            free(stack_G);
                            return;
                        }
                    }
                
                    if (d-i-2>=TURN+4 && j-e-2>=TURN+4) {
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += QmR[indxR[d-1]+i+2] * QmR[indxR[j-2]+e+1]
                            * QTu[st][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 4, st);
                            push_block(i+2, d-1, 0, 0, 7, 5);
                            push_block(e+1, j-2, 0, 0, 7, 5);
                            free(stack_G);
                            return;
                        }
                    }
                }
            }
            //DT-M
            if (d-i-2 < TURN+4) { 
                left = EXP((d-i-2)*P->MLbase);
                flag_L = 0;
            }
            else { 
                left = QmR[indxR[d-1]+i+2] + EXP((d-i-2)*P->MLbase);
                flag_L = 1;
            }
            if (j-e-2 < TURN+4) {
                right = EXP((j-e-2)*P->MLbase);
                flag_R = 0;
            }
            else { 
                right = QmR[indxR[j-2]+e+1] + EXP((j-e-2)*P->MLbase);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]] + stack_G[k];
            Qi += left * right * QDT[i_m][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 2, i_m); //DT
                if (flag_L)
                    push_block(i+2, d-1, 0, 0, 7, 1);  //Sec
                if (flag_R)
                    push_block(e+1, j-2, 0, 0, 7, 1);  //Sec
                
                free(stack_G);
                return;
            }
            
            //DT-K
            if (d-i-2 < TURN+4) { 
                left = EXP((d-i-2)*BETA3);
                flag_L = 0;
            }
            else { 
                left = QfR[indxR[d-1]+i+2] + EXP((d-i-2)*BETA3);
                flag_L = 1;
            }
            if (j-e-2 < TURN+4) {
                right = EXP((j-e-2)*BETA3);
                flag_R = 0;
            }
            else { 
                right = QfR[indxR[j-2]+e+1] + EXP((j-e-2)*BETA3);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += BETA1 + BETA2 + stack_G[k];
            Qi += left * right * QDT[i_d][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 2, i_d);     //DT
                if (flag_L)
                    push_block(i+2, d-1, 0, 0, 7, 2);  //Sec in a kissing loop
                if (flag_R)
                    push_block(e+1, j-2, 0, 0, 7, 2);

                free(stack_G);
                return;
            }
            //DT-K  of type B
            if (i_e != -1) {
                Qi += left * right * QDT[i_e][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 2, i_e);
                    if (flag_L)
                        push_block(i+2, d-1, 0, 0, 7, 2);
                    if (flag_R)
                        push_block(e+1, j-2, 0, 0, 7, 2);

                    free(stack_G);
                    return;
                }
            }
        }

    printf("\nTu[%d,%d;%d,%d] with status %d: invalid place!!\n", i, j, r, s, st);
}

/** 
 * decompose Tse, in which (i,j), (r,s) and (r+1,s-1) are
 * all base pairs, but (i+1,j-1) can not be paired with
 * each other
 * 
 * @param T: block Tse
 */
void decompose_Tse(block *T)
{
    int i, j, r, s;
    int type1, type2;
    int d, e, type_2, type_2i, k;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	seed = 1 - drand48();
	Qi = 0;
	
	Sample[i] = j;
	Sample[j] = i;

    if (constraint) {
        if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
            bonus -= PF_BONUS;
        if (BP[j]==-1 || BP[j]==-3)
            bonus -= PF_BONUS;
    }
    
    Qpro = (QTse[indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
	/* type = pair_typeR[0][indxR[j]+i]; */
    
    for (d=i+1; d<j-1; d++)
        for (e=d+1; e<j; e++) {
            type_2 = pair_typeR[0][indxR[e]+d];
            if ((e-d-2) >= TURN+1)
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
            else
                type_2i = NO_PAIR;

            //Te-I
            if (type_2==PAIR && type_2i==PAIR && (d!=i+1 || e!=j-1)) {
                G = 0;
                for (k=1; k<=num_align; k++) {
                    type1 = pair_typeR[k][indxR[j]+i];
                    type2 = pair_typeR[k][indxR[e]+d];
                    
                    if (type1 == 0)
                        type1 = 7;
                    if (type2 == 0)
                        type2 = 7;
                    G += calc_interior_energy(d-i-1, j-e-1, type1, rtype[type2], 
                                              aSR[k][i+1], aSR[k][j-1], aSR[k][d-1], aSR[k][e+1]);
                }
                Qi += QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 6, 0);   //Te
                    return;
                }
                
                //Te-M
                if (!(d-i-1<TURN+4 && j-e-1<TURN+4)) {
                    if (d-i-1 >= TURN+4) {
                        left = QmR[indxR[d-1]+i+1];
                        right = EXP((j-e-1)*P->MLbase);
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += left * right * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(i+1, d-1, 0, 0, 7, 5);  //Sec
                            
                            return;
                        }
                    }
                
                    if (j-e-1 >= TURN+4) {
                        left = EXP((d-i-1)*P->MLbase);
                        right = QmR[indxR[j-1]+e+1];
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += left * right * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(e+1, j-1, 0, 0, 7, 5);  //Sec
                            
                            return;
                        }
                    }
                    
                    if (d-i-1>=TURN+4 && j-e-1>=TURN+4) {
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]];
                        }
                        Qi += QmR[indxR[d-1]+i+1] * QmR[indxR[j-1]+e+1]
                            * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(i+1, d-1, 0, 0, 7, 5);  //Sec
                            push_block(e+1, j-1, 0, 0, 7, 5);  //Sec
                            
                            return;
                        }
                    }
                }
            }
            
            //Td-M
            if (d-i-1 < TURN+4) { 
                left = EXP((d-i-1)*P->MLbase);
                flag_L = 0;
            }
            else { 
                left = QmR[indxR[d-1]+i+1] + EXP((d-i-1)*P->MLbase);
                flag_L = 1;
            }
            if (j-e-1 < TURN+4) {
                right = EXP((j-e-1)*P->MLbase);
                flag_R = 0;
            }
            else { 
                right = QmR[indxR[j-1]+e+1] + EXP((j-e-1)*P->MLbase);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j]+i]];
            Qi += left * right * QTd[1][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 5, 1);   //Td
                if (flag_L)
                    push_block(i+1, d-1, 0, 0, 7, 1);  //Sec-M
                if (flag_R)
                    push_block(e+1, j-1, 0, 0, 7, 1);  //Sec-M
                return;
            }
            
            //Td-K
            if (d-i-1 < TURN+4) { 
                left = EXP((d-i-1)*BETA3);
                flag_L = 0;
            }
            else { 
                left = QfR[indxR[d-1]+i+1] + EXP((d-i-1)*BETA3);
                flag_L = 1;
            }
            if (j-e-1 < TURN+4) {
                right = EXP((j-e-1)*BETA3);
                flag_R = 0;
            }
            else { 
                right = QfR[indxR[j-1]+e+1] + EXP((j-e-1)*BETA3);
                flag_R = 1;
            }
            
            G = BETA1+BETA2;
            Qi += left * right * QTd[3][indxR[e]+d][indxS[s]+r] * EXP(G);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 5, 3);
                if (flag_L)
                    push_block(i+1, d-1, 0, 0, 7, 2);  //Sec-K
                if (flag_R)
                    push_block(e+1, j-1, 0, 0, 7, 2);  //Sec-K
                
                return;
            }
        }
    
	printf("\nTse[%d,%d;%d,%d]: invalid place!!\n", i, j, r, s);
}

/** 
 * decompose Te, in which (i,j), (i+1,j-1), (r,s) and (r+1,s-1)
 * are all base pairs
 * 
 * @param T: block Te
 */
void decompose_Te(block *T)
{
    int i, j, r, s;
    int type1, type2;
	int d, e, type_2, type_2i, k;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G, *stack_G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	seed = 1 - drand48();
	Qi = 0;
	
	Sample[i] = j;
	Sample[j] = i;
    Sample[i+1] = j-1;
    Sample[j-1] = i+1;

    if (constraint) {
        if (BP[i]==j || BP[i]==-1 || BP[i]==-4)
            bonus -= PF_BONUS;
        if (BP[j]==-1 || BP[j]==-3)
            bonus -= PF_BONUS;
        if (BP[i+1]==j-1 || BP[i+1]==-1 || BP[i+1]==-4)
            bonus -= PF_BONUS;
        if (BP[j-1]==-1 || BP[j-1]==-3)
            bonus -= PF_BONUS;
    }
    
    Qpro = (QTe[indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
    stack_G = (int *) space(sizeof(int)*(num_align+1));
    
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeR[k][indxR[j]+i];
        type2 = pair_typeR[k][indxR[j-1]+i+1];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        stack_G[k] = P->stack[type1][rtype[type2]];
    }
    
    //Tse is contained
    G = 0;
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeR[k][indxR[j-1]+i+1];
        type2 = pair_typeR[k][indxR[j-2]+i+2];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        G += stack_G[k] + P->stack[type1][rtype[type2]];
    }
    Qi += QTse[indxR[j-2]+i+2][indxS[s]+r] * EXP(((double) G)/num_align);
    if (Qi >= Qpro) {
        push_block(i+2, j-2, r, s, 12, 0);  //Tse
        free(stack_G);
        return;
    }
                
    for (d=i+2; d<j-2; d++)
        for (e=d+1; e<j-1; e++) {
            type_2 = pair_typeR[0][indxR[e]+d];
            if ((e-d-2) >= TURN+1)
                type_2i = pair_typeR[0][indxR[e-1]+d+1];
            else
                type_2i = NO_PAIR;

            if (type_2==PAIR && type_2i==PAIR) {
                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    type1 = pair_typeR[k][indxR[j-1]+i+1];
                    type2 = pair_typeR[k][indxR[e]+d];
                    
                    if (type1 == 0)
                        type1 = 7;
                    if (type2 == 0)
                        type2 = 7;
                    G += calc_interior_energy(d-i-2, j-e-2, type1, rtype[type2], 
                                              aSR[k][i+2], aSR[k][j-2], aSR[k][d-1], aSR[k][e+1])+stack_G[k];
                }
                Qi += QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(d, e, r, s, 6, 0);   //Te
                    free(stack_G);
                    return;
                }
                
                //Te-M
                if (!(d-i-2<TURN+4 && j-e-2<TURN+4)) {
                    if (d-i-2 >= TURN+4) {
                        left = QmR[indxR[d-1]+i+2];
                        right = EXP((j-e-2)*P->MLbase);
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += left * right * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(i+2, d-1, 0, 0, 7, 5);  //Sec-M-not empty
                            
                            free(stack_G);
                            return;
                        }
                    }
                    
                    if (j-e-2 >= TURN+4) {
                        left = EXP((d-i-2)*P->MLbase);
                        right = QmR[indxR[j-2]+e+1];
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += left * right * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(e+1, j-2, 0, 0, 7, 5);  //Sec-M-not empty

                            free(stack_G);
                            return;
                        }
                    }
                    
                    if (d-i-2>=TURN+4 && j-e-2>=TURN+4) {
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]]
                                + P->MLintern[pair_typeR[k][indxR[e]+d]] + stack_G[k];
                        }
                        Qi += QmR[indxR[d-1]+i+2] * QmR[indxR[j-2]+e+1]
                            * QTe[indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(d, e, r, s, 6, 0);   //Te
                            push_block(i+2, d-1, 0, 0, 7, 5);  //Sec-M-not empty
                            push_block(e+1, j-2, 0, 0, 7, 5);  //Sec-M-not empty

                            free(stack_G);
                            return;
                        }
                    }
                }
            }
            
            //Td-M
            if (d-i-2 < TURN+4) { 
                left = EXP((d-i-2)*P->MLbase);
                flag_L = 0;
            }
            else { 
                left = QmR[indxR[d-1]+i+2] + EXP((d-i-2)*P->MLbase);
                flag_L = 1;
            }
            if (j-e-2 < TURN+4) {
                right = EXP((j-e-2)*P->MLbase);
                flag_R = 0;
            }
            else { 
                right = QmR[indxR[j-2]+e+1] + EXP((j-e-2)*P->MLbase);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += P->MLclosing + P->MLintern[pair_typeR[k][indxR[j-1]+i+1]] + stack_G[k];
            Qi += left * right * QTd[1][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 5, 1);   //Td-M
                if (flag_L)
                    push_block(i+1, d-1, 0, 0, 7, 1);  //Sec-M
                if (flag_R)
                    push_block(e+1, j-1, 0, 0, 7, 1);  //Sec-M

                free(stack_G);
                return;
            }
            
            //Td-K
            if (d-i-2 < TURN+4) { 
                left = EXP((d-i-2)*BETA3);
                flag_L = 0;
            }
            else { 
                left = QfR[indxR[d-1]+i+2] + EXP((d-i-2)*BETA3);
                flag_L = 1;
            }
            if (j-e-2 < TURN+4) {
                right = EXP((j-e-2)*BETA3);
                flag_R = 0;
            }
            else { 
                right = QfR[indxR[j-2]+e+1] + EXP((j-e-2)*BETA3);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += BETA1 + BETA2 + stack_G[k];
            Qi += left * right * QTd[3][indxR[e]+d][indxS[s]+r] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(d, e, r, s, 5, 3);   //Td-K
                if (flag_L)
                    push_block(i+2, d-1, 0, 0, 7, 2);  //Sec-F
                if (flag_R)
                    push_block(e+1, j-2, 0, 0, 7, 2);  //Sec-F

                free(stack_G);
                return;
            }
        }

    printf("\nTe[%d,%d;%d,%d]: invalid place!!\n", i, j, r, s);
}

/** 
 * decompse Td, in which (r,s) and (r+1,s-1) are both
 * base pairs
 * 
 * @param T: block Td
 */
void decompose_Td(block *T)
{
    int i, j, r, s;
    int d, e, st, i_m, i_k1, i_k2, m, k;
    int type1, type2;
    int type_2, type_2i;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G, *stack_G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;
    
	st = T->status;
	seed = 1-drand48();
	Qi = 0;

    m = Sample[0];
	Sample[m-r+1] = m-s+1;
	Sample[m-s+1] = m-r+1;
    Sample[m-r] = m-s+2;
    Sample[m-s+2] = m-r;

    if (constraint) {
        if (BP[BP[0]+r+1]==s || BP[BP[0]+r+1]==-1 || BP[BP[0]+r+1]==-3)
            bonus -= PF_BONUS;
        if (BP[BP[0]+s+1]==-1 || BP[BP[0]+s+1]==-4)
            bonus -= PF_BONUS;
        if (BP[BP[0]+r+2]==s-1 || BP[BP[0]+r+2]==-1 || BP[BP[0]+r+2]==-3)
            bonus -= PF_BONUS;
        if (BP[BP[0]+s]==-1 || BP[BP[0]+s]==-4)
            bonus -= PF_BONUS;
    }
    
    Qpro = (QTd[st][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;
    stack_G = (int *) space(sizeof(int)*(num_align+1));
    
	/* type = pair_typeS[0][indxS[s]+r]; */
    /* type_i = pair_typeS[0][indxS[s-1]+r+1]; */
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeS[k][indxS[s]+r];
        type2 = pair_typeS[k][indxS[s-1]+r+1];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        stack_G[k] = P->stack[rtype[type1]][type2];
    }

	if (st == 0) {    //e
        i_m = 3;
        i_k1 = 10;
        i_k2 = 11 ;
	}
    else if (st == 1) { //m
        i_m = 6;
        i_k1 = 12;
        i_k2 = -1;
	}
    else if (st == 2) { //f
        i_m = 8; 
        i_k1 = 13;
        i_k2 = -1;
	}
    else if (st == 3) { //k
        i_m = 16;
        i_k1 = 18;
        i_k2 = 19;
	}

    //Tsd is contained
    G = 0;
    for (k=1; k<=num_align; k++) {
        type1 = pair_typeS[k][indxS[s-1]+r+1];
        type2 = pair_typeS[k][indxS[s-2]+r+2];

        if (type1 == 0)
            type1 = 7;
        if (type2 == 0)
            type2 = 7;
        G += stack_G[k] + P->stack[rtype[type1]][type2];
    }
    Qi += QTsd[st][indxR[j]+i][indxS[s-2]+r+2] * EXP(((double) G)/num_align);
    if (Qi >= Qpro) {
        push_block(i, j, r+2, s-2, 11, st);
        free(stack_G);
        return;
    }

    for (d=r+2; d<s-2; d++)
        for (e=d+1; e<s-1; e++) {
            type_2 = pair_typeS[0][indxS[e]+d];
            if ((e-d-2) >= TURN+1)
                type_2i = pair_typeS[0][indxS[e-1]+d+1];
            else
                type_2i = NO_PAIR;
            
            if (type_2==PAIR && type_2i==PAIR) {
                //interior loop
                G = 0;
                for (k=1; k<=num_align; k++) {
                    type1 = pair_typeS[k][indxS[s-1]+r+1];
                    type2 = pair_typeS[k][indxS[e]+d];
                    
                    if (type1 == 0)
                        type1 = 7;
                    if (type2 == 0)
                        type2 = 7;
                    G += calc_interior_energy(s-e-2, d-r-2,rtype[type1], type2, 
                                              aSS[k][s-2], aSS[k][r+2], aSS[k][e+1], aSS[k][d-1])+stack_G[k];
                }
                Qi += QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(i, j, d, e, 5, st);    //Td
                    free(stack_G);
                    return;
                }
                
                //Td-M
                if (!(d-r-2<TURN+4 && s-e-2<TURN+4)) {
                    if (d-r-2 >= TURN+4) {
                        left = QmS[indxS[d-1]+r+2];
                        right = EXP((s-e-2)*P->MLbase);
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s-1]+r+1]]]
                                + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + stack_G[k];
                        }
                        Qi += left * right * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(i, j, d, e, 5, st);    //Td
                            push_block(0, 0, r+2, d-1, 7, 5);     //Sec-M-not empty

                            free(stack_G);
                            return;
                        }
                    }
                    
                    if (s-e-2 >= TURN+4) {
                        left = EXP((d-r-2)*P->MLbase);
                        right = QmS[indxS[s-2]+e+1];
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s-1]+r+1]]]
                                + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + stack_G[k];
                        }
                        Qi += left * right * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(i, j, d, e, 5, st);    //Td
                            push_block(0, 0, e+1, s-2, 7, 5);     //Sec-M-not empty

                            free(stack_G);
                            return;
                        }
                    }
                    
                    if (d-r-2>=TURN+4 && s-e-2>=TURN+4) {
                        G = 0;
                        for (k=1; k<=num_align; k++) {
                            G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s-1]+r+1]]]
                                + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]] + stack_G[k];
                        }
                        Qi += QmS[indxS[d-1]+r+2] * QmS[indxS[s-2]+e+1]
                            * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                        if (Qi >= Qpro) {
                            push_block(i, j, d, e, 5, st);        //Td
                            push_block(0, 0, r+2, d-1, 7, 5);     //Sec-M-not empty
                            push_block(0, 0, e+1, s-2, 7, 5);     //Sec-M-not empty

                            free(stack_G);
                            return;
                        }
                    }
                }
            }
            
            //DT-M
            if (d-r-2 < TURN+4) { 
                left = EXP((d-r-2)*P->MLbase);
                flag_L = 0;
            }
            else { 
                left = QmS[indxS[d-1]+r+2] + EXP((d-r-2)*P->MLbase);
                flag_L = 1;
            }
            if (s-e-2 < TURN+4) {
                right = EXP((s-e-2)*P->MLbase);
                flag_R = 0;
            }
            else { 
                right = QmS[indxS[s-2]+e+1] + EXP((s-e-2)*P->MLbase);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s-1]+r+1]]] + stack_G[k];
            Qi += left * right * QDT[i_m][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(i, j, d, e, 2, i_m);   //DT-i_m
                if (flag_L)
                    push_block(0, 0, r+2, d-1, 7, 1); //Sec-M
                if (flag_R)
                    push_block(0, 0, e+1, s-2, 7, 1); //Sec-M

                free(stack_G);
                return;
            }
            
            //DT-K
            if (d-r-2 < TURN+4) { 
                left = EXP((d-r-2)*BETA3);
                flag_L = 0;
            }
            else { 
                left = QfS[indxS[d-1]+r+2] + EXP((d-r-2)*BETA3);
                flag_L = 1;
            }
            if (s-e-2 < TURN+4) {
                right = EXP((s-e-2)*BETA3);
                flag_R = 0;
            }
            else { 
                right = QfS[indxS[s-2]+e+1] + EXP((s-e-2)*BETA3);
                flag_R = 1;
            }

            G = 0;
            for (k=1; k<=num_align; k++)
                G += BETA1 + BETA2 + stack_G[k];
            Qi += left * right * QDT[i_k1][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
            if (Qi >= Qpro) {
                push_block(i, j, d, e, 2, i_k1);      //DT-i_m
                if (flag_L)
                    push_block(0, 0, r+2, d-1, 7, 2);     //Sec-F
                if (flag_R)
                    push_block(0, 0, e+1, s-2, 7, 2);     //Sec-F

                free(stack_G);
                return;
            }
            //DT-K of type B
            if (i_k2 != -1) {
                Qi += left * right * QDT[i_k2][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                if (Qi >= Qpro) {
                    push_block(i, j, d, e, 2, i_k2);  //DT-i_k2
                    if (flag_L)
                        push_block(0, 0, r+2, d-1, 7, 2); //Sec-F
                    if (flag_R)
                        push_block(0, 0, e+1, s-2, 7, 2); //Sec-F

                    free(stack_G);
                    return;
                }
            }
        }
    
    printf("\nTd[%d,%d;%d,%d] with status %d: invalid place!!\n", i, j, r, s, st);
}

/** 
 * decompse Tsd, in which r and s are paired, but r+1 and
 * s-1 can not be paired with each other
 * 
 * @param T: block Tsd
 */
void decompose_Tsd(block *T)
{
    int i, j, r, s;
    int type1, type2;
	int d, e, st, i_m, i_k1, i_k2, type_2, type_2i, m, k;
	double seed;
	double Qi, Qpro, left, right, flag_L, flag_R;
	int G;
    int bonus = 0;

    i = T->i; j = T->j;
    r = T->r; s = T->s;

	st = T->status;
	seed = 1-drand48();
	Qi = 0;
	
	/* type = pair_typeS[0][indxS[s]+r]; */

	m = Sample[0];
	Sample[m-r+1] = m-s+1;
	Sample[m-s+1] = m-r+1;

    if (constraint) {
         if (BP[BP[0]+r+1]==s || BP[BP[0]+r+1]==-1 || BP[BP[0]+r+1]==-3)
             bonus -= PF_BONUS;
         if (BP[BP[0]+s+1]==-1 || BP[BP[0]+s+1]==-4)
             bonus -= PF_BONUS;    
    }
    
    Qpro = (QTsd[st][indxR[j]+i][indxS[s]+r]/EXP(bonus))*seed;

	if (st == 0) {    //e
        i_m = 3;
        i_k1 = 10;
        i_k2 = 11 ;
	}
    else if (st == 1) { //m
        i_m = 6;
        i_k1 = 12;
        i_k2 = -1;
	}
    else if (st == 2) { //f
        i_m = 8; 
        i_k1 = 13;
        i_k2 = -1;
	}
    else if (st == 3) { //k
        i_m = 16;
        i_k1 = 18;
        i_k2 = 19;
    }
    
    for (d=r+1; d<s-1; d++)
          for (e=d+1; e<s; e++) {
              type_2 = pair_typeS[0][indxS[e]+d];
              if ((e-d-2) >= TURN+1)
                  type_2i = pair_typeS[0][indxS[e-1]+d+1];
              else
                  type_2i = NO_PAIR;

              if (type_2==PAIR && type_2i==PAIR && (d!=r+1 || e!=s-1)) {
                  //interior loop
                  G = 0;
                  for (k=1; k<=num_align; k++) {
                      type1 = pair_typeS[k][indxS[s]+r];
                      type2 = pair_typeS[k][indxS[e]+d];
                      
                      if (type1 == 0)
                          type1 = 7;
                      if (type2 == 0)
                          type2 = 7;
                      G += calc_interior_energy(s-e-1, d-r-1, rtype[type1], type2, 
                                                aSS[k][s-1], aSS[k][r+1], aSS[k][e+1], aSS[k][d-1]);
                  }
                  Qi += QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                  if (Qi >= Qpro) {
                      push_block(i, j, d, e, 5, st);
                      return;
                  }
                  
                  //Td-M
                  if (!(d-r-1<TURN+4 && s-e-1<TURN+4)) {
                      if (d-r-1 >= TURN+4) {
                          left = QmS[indxS[d-1]+r+1];
                          right = EXP((s-e-1)*P->MLbase);
                          G = 0;
                          for (k=1; k<=num_align; k++) {
                              G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s]+r]]]
                                  + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]];
                          }
                          Qi += left * right * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                          if (Qi >= Qpro) {
                              push_block(i, j, d, e, 5, st);    //Td
                              push_block(0, 0, r+1, d-1, 7, 5);    //Sec-M-not empty
                              
                              return;
                          }
                      }
                      
                      if (s-e-1 >= TURN+4) {
                          left = EXP((d-r-1)*P->MLbase);
                          right = QmS[indxS[s-1]+e+1];
                          G = 0;
                          for (k=1; k<=num_align; k++) {
                              G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s]+r]]]
                                  + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]];
                          }
                          Qi += left * right * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                          if (Qi >= Qpro) {
                              push_block(i, j, d, e, 5, st);    //Td
                              push_block(0, 0, e+1, s-1, 7, 5);    //Sec-M-not empty
                              
                              return;
                          }
                      }
                      
                      if (d-r-1>=TURN+4 && s-e-1>=TURN+4) {
                          G = 0;
                          for (k=1; k<=num_align; k++) {
                              G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s]+r]]]
                                  + P->MLintern[rtype[pair_typeS[k][indxS[e]+d]]];
                          }
                          Qi += QmS[indxS[d-1]+r+1] * QmS[indxS[s-1]+e+1]
                              * QTd[st][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
                          if (Qi >= Qpro) {
                              push_block(i, j, d, e, 5, st);        //Td
                              push_block(0, 0, r+1, d-1, 7, 5);     //Sec-M-not empty
                              push_block(0, 0, e+1, s-1, 7, 5);     //Sec-M-not empty
                              
                              return;
                          }
                      }
                  }
              }
              
              //DT-M
              if (d-r-1 < TURN+4) { 
                  left = EXP((d-r-1)*P->MLbase);
                  flag_L = 0;
              }
              else { 
                  left = QmS[indxS[d-1]+r+1] + EXP((d-r-1)*P->MLbase);
                  flag_L = 1;
              }
              if (s-e-1 < TURN+4) {
                  right = EXP((s-e-1)*P->MLbase);
                  flag_R = 0;
              }
              else { 
                  right = QmS[indxS[s-1]+e+1] + EXP((s-e-1)*P->MLbase);
                  flag_R = 1;
              }

              G = 0;
              for (k=1; k<=num_align; k++)
                  G += P->MLclosing + P->MLintern[rtype[pair_typeS[k][indxS[s]+r]]];
              Qi += left * right * QDT[i_m][indxR[j]+i][indxS[e]+d] * EXP(((double) G)/num_align);
              if (Qi >= Qpro) {
                  push_block(i, j, d, e, 2, i_m);   //DT-i_m
                  if (flag_L)
                      push_block(0, 0, r+1, d-1, 7, 1);    //Sec-M
                  if (flag_R)
                      push_block(0, 0, e+1, s-1, 7, 1);    //Sec-M
                  
                  return;
              }
              
              //DT-K
              if (d-r-1 < TURN+4) { 
                  left = EXP((d-r-1)*BETA3);
                  flag_L = 0;
              }
              else { 
                  left = QfS[indxS[d-1]+r+1] + EXP((d-r-1)*BETA3);
                  flag_L = 1;
              }
              if (s-e-1 < TURN+4) {
                  right = EXP((s-e-1)*BETA3);
                  flag_R = 0;
              }
              else { 
                  right = QfS[indxS[s-1]+e+1] + EXP((s-e-1)*BETA3);
                  flag_R = 1;
              }
              G = BETA1+BETA2;
              Qi += left * right * QDT[i_k1][indxR[j]+i][indxS[e]+d] * EXP(G);
              if (Qi >= Qpro) {
                  push_block(i, j, d, e, 2, i_k1);  //DT-i_k1
                  if (flag_L)
                      push_block(0, 0, r+1, d-1, 7, 2);    //Sec-F
                  if (flag_R)
                      push_block(0, 0, e+1, s-1, 7, 2);    //Sec-F
                  
                  return;
              }
              //DT-K of type B
              if (i_k2 != -1) {
                  Qi += left * right * QDT[i_k2][indxR[j]+i][indxS[e]+d] * EXP(G);
                  if (Qi >= Qpro) {
                      push_block(i, j, d, e, 2, i_k2);
                      if (flag_L)
                          push_block(0, 0, r+1, d-1, 7, 2);
                      if (flag_R)
                          push_block(0, 0, e+1, s-1, 7, 2);
                      
                      return;
                  }
              }
          }
    
	printf("\nTsd[%d,%d;%d,%d] with status %d: invalid place!!\n", i, j, r, s, st);
}

void decompose_arbi_struc(void)
{
	int k1, k2;
	double seed;
	double Qi, Qpro;
    
	seed = 1-drand48();
	Qi = 0;
	Qpro = seed*Qany;

    //only secondary structures, no interaction
	Qi += QR[indxR[len_r]+1]*QS[indxS[len_s]+1];
	if (Qi >= Qpro) {
        push_block(1, len_r, 0, 0, 7, 0);
        push_block(0, 0, 1, len_s, 7, 0);
        return;
	}
    //the whole structure is a rt of type eea
	Qi += QRT[0][indxR[len_r]+1][indxS[len_s]+1];
	if (Qi >= Qpro) {
        push_block(1, len_r, 1, len_s, 1, 0);
        return;
	}
    //rt of type eeb
	Qi += QRT[1][indxR[len_r]+1][indxS[len_s]+1];
	if (Qi >= Qpro) {
        push_block(1, len_r, 1, len_s, 1, 1);
        return;
	}
    //composed of rt and secondary structures
	for (k1=2; k1<len_r; k1++) 
        for (k2=2; k2<len_s; k2++) {
            Qi += QRT[0][indxR[k1]+1][indxS[k2]+1] * QR[indxR[len_r]+k1+1] * QS[indxS[len_s]+k2+1];
            if (Qi >= Qpro) {
                push_block(1, k1, 1, k2, 1, 0);
                push_block(k1+1, len_r, 0, 0, 7, 0);
                push_block(0, 0, k2+1, len_s, 7, 0);
                return;
            }
            
            Qi += QRT[1][indxR[k1]+1][indxS[k2]+1] * QR[indxR[len_r]+k1+1] * QS[indxS[len_s]+k2+1];
            if (Qi >= Qpro) {
                push_block(1, k1, 1, k2, 1, 1);
                push_block(k1+1, len_r, 0, 0, 7, 0);
                push_block(0, 0, k2+1, len_s, 7, 0);
                return;
            }
        }
    //secondary structure is on R
	for (k1=2; k1<len_r; k1++) {
        Qi += QRT[0][indxR[k1]+1][indxS[len_s]+1] * QR[indxR[len_r]+k1+1];
        if (Qi > Qpro) {
            push_block(1, k1, 1, len_s, 1, 0);
            push_block(k1+1, len_r, 0, 0, 7, 0);
            return;
        }
        Qi += QRT[1][indxR[k1]+1][indxS[len_s]+1] * QR[indxR[len_r]+k1+1];
        if (Qi>Qpro) {
            push_block(1, k1, 1, len_s, 1, 1);
            push_block(k1+1, len_r, 0, 0, 7, 0);
            return;
        }
	}
    //secondary structure is on R
	for (k2=2; k2<len_s; k2++) {
        Qi += QRT[0][indxR[len_r]+1][indxS[k2]+1] * QS[indxS[len_s]+k2+1];
        if (Qi >= Qpro) {
            push_block(1, len_r, 1, k2, 1, 0);
            push_block(0, 0, k2+1, len_s, 7, 0);
            return;
        }
        Qi += QRT[1][indxR[len_r]+1][indxS[k2]+1] * QS[indxS[len_s]+k2+1];
        if (Qi >= Qpro) {
            push_block(1, len_r, 1, k2, 1, 1);
            push_block(0, 0, k2+1, len_s, 7, 0);
            return;
        }
	}
    
	printf("\narbitrary structure: invalid place!!\n");
}

char *sample_strutures(char **seqs_r, char **seqs_s_53)
{
	int type, i, shift;
	block *T;
	char *structure;
    
	Sample = (int*) space(sizeof(int)*(len_r+len_s+2));
	Sample[0] = len_r+len_s;

	decompose_arbi_struc();
    
	while (Bstack != NULL) {
	  T = pop_block();
	  type = T->type;

      switch(type) {
          case 1:
              decompose_RT(T);
              break;
          case 2:
              decompose_DT(T);
              break;
          case 3:
              decompose_hybrid_EE(T);       //ee
              break;
          case 4:
              decompose_Tu(T);
              break;
          case 5:
              decompose_Td(T);
              break;
          case 6:
              decompose_Te(T);
              break;
          case 7:
              decompose_sec_struc(T);
              break;
          case 8:
              decompose_Qb(seqs_r, seqs_s_53, T);
              break;
          case 9:
              decompose_Qbs(seqs_r, seqs_s_53, T);
              break;
          case 10:
              decompose_Tsu(T);
              break;
          case 11:
              decompose_Tsd(T);
              break;
          case 12:
              decompose_Tse(T);
              break;
          case 13:
              decompose_hybrid(T);      //ke, ek, kk
              break;
          default:
              break;
      }
      
      free(T);
	}

	structure = (char*) space(sizeof(char)*(len_r+len_s+2));
	for (i=0; i<=len_r+len_s; i++)
        structure[i] = '.';
	structure[len_r] = '|';
	structure[len_r+len_s+1] = '\0';

	for (i=1; i<=len_r+len_s; i++) {
        if (Sample[i] != 0) {
            if (i<Sample[i] && ((i<=len_r && Sample[i]<=len_r) || (i>len_r && Sample[i]>len_r))) {
                if (i>len_r && Sample[i]>len_r)
                    shift = 1;
                else
                    shift = 0;
                structure[i+shift-1] = '(';
                structure[Sample[i]+shift-1] = ')';
            }
            else if (i<Sample[i] && i<=len_r && Sample[i]>len_r) {
                structure[Sample[i]] = ']';
                structure[i-1] = '[';
            }
        }
	}
    
	free(Sample);

	return structure;
}

int check_constraints(const char *struc, int num)
{
    int i, k;
    int flag = 0;   //if satisfy all constraints, 0 and 1 otherwise
    
    for (i=1; i<num; i++) {
        k = (i<=BP[0]) ? (i-1) : (num-i+BP[0]);
        
        if (BP[i] == -1) {          //'-'
            if (struc[k]!='(' && struc[k]!=')') {
                    flag = 1;
                    break;
            }
        }
        else if (BP[i] == -2) {     //'^'
            if (i <= BP[0]) {
                if (struc[i-1] != '[') {
                    flag = 1;
                    break;
                }
            }
            else {
                if (struc[num-i+BP[0]] != ']') {
                    flag = 1;
                    break;
                }
            }
        }
        else if (BP[i] == -3) {     //'<'
            if (struc[k] != ')') {
                flag = 1;
                break;
            }
        }
        else if (BP[i] == -4) {     //'>'
            if (struc[k] != '(') {
                flag = 1;
                break;
            }
        }
        else if (BP[i] == -5) {     //'x'
             if (struc[k] != '.') {
                flag = 1;
                break;
            }
        }
        else if (BP[i]>i && BP[i]<BP[0]) {          //pair on R
            if (struc[i-1]!='(' || struc[BP[i]-1]!=')') {
                flag = 1;
                break;
            }
        }
        else if (i>BP[0]+1 && BP[i]>(i-BP[0]-1)) {    //pair on S
            if (struc[num-BP[i]-1]!='(' || struc[num+BP[0]-i]!=')') {
                flag = 1;
                break;
            }
        }
        else if (i<=BP[0] && BP[i]>BP[0]+1) {          //interaction
            if (struc[i-1]!='[' || struc[num-BP[i]+BP[0]]!=']') {
                flag = 1;
                break;
            }
        }
        else
            ;    
    }

    return flag;
}

/**
 * add @structure to analysis list @ana_head, and
 * count the number of same structures
 */
void analyze_result(char *structure)
{
	ana *index;
	int m;

	m = strlen(structure);

	if (ana_head == NULL) {
	  ana_head = (ana *) space(sizeof(ana));
	  ana_head->structure = (char *) space(sizeof(char)*(m+1));
	  strcpy(ana_head->structure, structure);
	  ana_head->cnt = 1;
	  ana_head->next = NULL;
	}
    else {
        index = ana_head;
        while (index!=NULL && strcmp(structure, index->structure))
            index = index->next;
        
        if (index != NULL) { 
            index->cnt++;
        }
        else {
            index =(ana *) space(sizeof(ana));
            index->structure = (char *) space(sizeof(char)*(m+1));
            strcpy(index->structure, structure);
            index->cnt = 1;
            index->next = ana_head;
            ana_head = index;
        }
	}
    
	return;
}

ana *search_max_result(ana *begin)
{
	ana *index, *res;
	int max = 0;
    
	index = begin;
	if (begin == NULL)
        return NULL;
    
	while (index != NULL) {
        if (index->cnt > max) {
            res = index;
            max = index->cnt;
        }
        index = index->next;
	}
    
	return res;
}

int_block *initialize_inter_block()
{
	int_block *res;

	res = (int_block *) malloc(sizeof(int_block));
	if (res == NULL) {
        printf("initial block error!\n");
        exit(EXIT_FAILURE);
	}
    
	res->s = NULL;
	res->cnt = 1;
    res->pro = -1.0;
	res->next = NULL;
    
	return res;
}

void free_block(int_block *block)
{
	if (block->s != NULL)
        free(block->s);
    
	free(block);
}

char *get_new_string(int length, int cut)
{
	int i;
	char *s;
	
	s = (char *) malloc((length+1)*sizeof(char));
	for (i=0; i<length; i++)
	  s[i] = '.';
    
	s[length] = '\0';
	s[cut] = '|';
    
	return s;
}

/**
 * check if @string is in the interaction list. If so,
 * add its number, and return 0. Or else, return 1.
 */
int check_string(char *string)
{
	int_block *index;

	index = inter_head;
	while (index != NULL) {
        if (strcmp(string, index->s) == 0) {
            index->cnt++;
            free(string);
            return 0;
        }
        index = index->next;
	}
    
	return 1;
}

void analyze_interaction_new(char *s)
{
    int i, top = 0, n, cut;
    int hyb[MAXSTACK];      //hybrid stack
    char *inter = NULL;
    int_block *temp;

    n = strlen(s);
    for (i=0; i<n; i++) {
        if (s[i] == '|') {
            cut = i;
            break;
        }
    }

    for (i=0; i<n; i++) {
        if (s[i] == '[')
            hyb[top++] = i;
        else if (s[i] == ']') {
            if (i <= cut) {
                fprintf(stderr, "%s is an invalid structure.\n", s);
                exit(EXIT_FAILURE);
            }

            //obtain a hybrid from the structure @s
            inter = get_new_string(n, cut);
            while (s[i]==']' || s[i]=='.') {
                if (s[i] == ']') {
                    if (top <= 0) {
                        fprintf(stderr, "No elements in hybrid stack. Error!\n");
                        exit(EXIT_FAILURE);
                    }
                    
                    inter[hyb[--top]] = '[';
                    inter[i] = ']';
                }

                i++;
            }

            //1 if not found in interaction list, then append it.
            //If not, add its number by 1 of this interaction
            if (check_string(inter)) {
                temp = initialize_inter_block();
                temp->s = inter;
                temp->next = inter_head;
                inter_head = temp;
            }
        }
        else
            continue;
    }

    if (top != 0) {
        fprintf(stderr, "The hybrid stack is not empty!\n");
        exit(EXIT_FAILURE);
    }

    return;
}

/**
 * extract all hybrids from structure @s, hang them on @inter_head, and
 * count the number of same hybrids
 */
void analyze_interaction(char *s)
{
	int top = 0;
	int i, n, flag = 1;
	int stack[MAXSTACK];
	int hyb[MAXSTACK];
	int cut;
	int match_i = 0, match_j = 0;
	char *inter = NULL;
	int_block *temp;

	n = strlen(s);
	for (i=0; i<n; i++)
        if (s[i] == '|')
            cut = i;

	for (i=0; i<MAXSTACK; i++)
        hyb[i] = 0;
	for (i=0; i<n; i++) {
        if (s[i]=='(' || s[i]==')')
            flag++;
        if (s[i] == '[') {
            stack[top++] = i;
            hyb[i] = flag;
        }
        if (s[i] == ']') {
            hyb[i] = flag;
            
            if (match_i!=hyb[stack[top-1]] || match_j!=hyb[i]) {
                if (inter != NULL) {
                    //printf("%s\n", inter);
                    //free(inter);
                    
                    if (check_string(inter)) {
                        temp = initialize_inter_block();
                        temp->s = inter;
                        temp->next = inter_head;
                        inter_head = temp;
                    }
                    inter = get_new_string(n, cut);
                }
                else 
                    inter = get_new_string(n, cut);
                
                match_i = hyb[stack[top-1]];
                match_j = hyb[i]; 
            }
            
            inter[stack[--top]] = '[';
            inter[i] = ']';
// 	    printf("(%d,%d)\n", stack[--top]+1,i+1);
        }
	}
// 	printf("%s\n", inter);
    
	if (inter!=NULL && check_string(inter)) {
        temp = initialize_inter_block();
        temp->s = inter;
        temp->next = inter_head;
        inter_head = temp;
	}
    
// 	free(inter);
}

int is_overlapped(int_block *s)
{
	int_block *index;
	int i, n;
	
	n = strlen(s->s);
    
	if (top_block == NULL)
        return 0;
    
	index = top_block;
	while (index != NULL) {
        for (i=0; i<n; i++) {
            if ((s->s[i]=='[' || s->s[i]==']') && (index->s[i]=='[' || index->s[i]==']'))
                return 1;
        }
        
        index = index->next;
	}
    
	return 0;
}

void read_structure(char *s, int freq, long num_sample)
{
	int i, l, shift = 0;
	int stack1[300], index1, stack2[300], index2;
	int *pair, m;
	double pro;

	l = strlen(s);
	pro = ((double) freq) / ((double)num_sample);

	pair = (int *)space(sizeof(int)*(l+1));
	pair[0] = l-1;
    
	index1 = 0;
    index2 = 0;
	for (i=0; i<l; i++) {
	  if (s[i] == '|') {
          shift = 1;
          m = i;
      }
	  if (s[i] == '(') {
          stack1[index1] = i-shift+1;
          index1++;
	  }
      else if (s[i] == ')') {
          pair[i-shift+1] = stack1[index1-1];
          pair[stack1[index1-1]] = i-shift+1;
          index1--;
	  }
      else if (s[i] == '[') {
          stack2[index2] = i-shift+1;
          index2++;
	  }
      else if (s[i] == ']') {
          pair[i-shift+1] = stack2[index2-1];
          pair[stack2[index2-1]] = i-shift+1;
          index2--;
	  }
	}
    
	for (i=1; i<l; i++) {
        if (pair[i]!=0 && i<pair[i]) {
            P_sample[indxSample[pair[i]]+i] += pro;
        }
    }
    
    free(pair);
}

int *structure2pair(char *s)
{
	int i, n;
	int *res;
	int stack[400], top = 0;
	
	n = strlen(s);
	res = (int *) calloc(n+1, sizeof(int));
    
	for (i=0; i<n; i++) {
        if (s[i] == '.')
            continue;
        if (s[i] == '[') {
            stack[top] = i;
            top++;
        }
        if (s[i] == ']') {
            res[i] = stack[top-1];
            res[stack[top-1]] = i;
            top--;
        }
	}
    
	return res;
}

int check_sample(char *sample, char *check)
{
	int *pair, *samp;
	int i, n;

	n = strlen(sample);
	
	pair = structure2pair(check);
	samp = structure2pair(sample);
	for (i=0; i<n; i++) {
        if (pair[i] == 0)
            continue;
        if (pair[i]!=0 && i<pair[i]) {
            if (samp[i]==pair[i] && samp[samp[i]]==i) {
                free(pair);
                free(samp);
                
                return 1;
            }
        }
	}
    
	free(pair);
	free(samp);
    
	return 0;
}

void select_top_hybrid(int top)
{
	int_block *index, *maxs;
	int max, i;

	if (inter_head == NULL)
        return;
    
	for (i=0; i<top; i++) {
        index = inter_head;
        max = 0;
        while (index != NULL) {
            if (index->cnt > max) {
                max = index->cnt;
                maxs = index;
            }
            index = index->next;
        }
        
        if (is_overlapped(maxs)) {
            i--;
            if (maxs == inter_head) {
                inter_head = inter_head->next;
                free(maxs);
            }
            else {
                index = inter_head;
                while (index->next != maxs)
                    index = index->next;
                index->next = maxs->next;
                
                free(maxs);
            }
            
            if (inter_head == NULL)
                return;
            
            continue;
        }
        
        if (maxs == NULL)
            return;
        
        if (maxs == inter_head) {
            inter_head = inter_head->next;
            maxs->next = top_block;
            top_block = maxs;
        }
        else {
            index = inter_head;
            while (index->next != maxs)
                index = index->next;
            index->next = maxs->next;
            maxs->next = top_block;
            top_block = maxs;
        }
        
        if (inter_head == NULL)
            return;
	}

    return;
}

void free_list(int_block *list)
{
	int_block *index;
    
	index = list;
	while (list != NULL) {
        index = list;
        list = list->next;
        free_block(index);
	}
}

void compute_hybrid_prob(long num_sample)
{
    long count = 0;
    int_block *cur;

    if (inter_head == NULL) {
        fprintf(stdout, "%s,%d: warning: $inter_head is null.\n", __FILE__, __LINE__);
        return;
    }

    /* get the total number of hybrids */
    cur = inter_head;
    while (cur != NULL) {
        count += (long) cur->cnt;
        cur = cur->next;
    }

    cur = inter_head;
    while (cur != NULL) {
        cur->pro = ((double) cur->cnt)/num_sample;
        cur = cur->next;
    }
    
    return;
}
    
int do_sample(FILE *fp, char **seqs_r, char **seqs_s_53, long num_sample, int all_sample,
               int top_frequency, struct plist *mfe)
{
    int i, j, t;
    char *structure;
    ana *index, *max;
    double pro;
    int_block *block_i;
    struc_list *temp;
    int_block *top_index[5];
    int cov[5][5];
    int flag_i, flag_j;
    int count = 0;
    long loop;
    int doi = 5;
    int result = 0;
    int n_hy = 0;       //number of top hybrid
    
    for (loop=0; loop<num_sample; loop++) {
        structure = sample_strutures(seqs_r, seqs_s_53);
        analyze_result(structure);
            
        if (all_sample) 
            fprintf(fp, "%s\n", structure); 
        analyze_interaction(structure);

        temp = (struc_list *) space(sizeof(struc_list));

        //list all sample structures in @struc_head
        temp->s = structure;
        temp->next = struc_head;
        struc_head = temp;
    }

    compute_hybrid_prob(num_sample);

    /* print all interactions */
    /* fprintf(stdout, "All interactions:\n"); */
    /* block_i = inter_head; */
    /* while (block_i) { */
    /*     fprintf(stdout, "%s  %d\n", block_i->s, block_i->cnt); */
    /*     block_i = block_i->next; */
    /* } */
    
    select_top_hybrid(n_top);

    /* print hybrids in order */
    /* fprintf(stdout, "Hybrids in order:\n"); */
    /* block_i = top_block; */
    /* while (block_i) { */
    /*     fprintf(stdout, "%s  %d\n", block_i->s, block_i->cnt); */
    /*     block_i = block_i->next; */
    /* } */
        
    for (i=0; i<5; i++)
        for (j=0; j<5; j++) 
            cov[i][j] = 0;

    block_i = top_block;
    i = 0;
    while (block_i != NULL) {   //the length of top_index is 5
        n_hy++;         //count the actual number of top hybrids
        
        top_index[i] = block_i;
        i++;
        
        if (i >= 5)
            break;
        
        block_i = block_i->next;
    }
    if (i < doi)
        doi = i;
        
    free_list(inter_head);
        
    if (top_block==NULL || top_block->next==NULL)
        fprintf(fp, "No disjoint interaction!\n");
    else {
        //do corealtion
        temp = struc_head;
        while (temp != NULL) {
            for (i=0; i<doi; i++) {
                if (check_sample(temp->s, top_index[i]->s))
                    flag_i = 1;
                else
                    flag_i = 0;
                    
                for (j=i; j<doi; j++) {
                    if (check_sample(temp->s, top_index[j]->s))
                        flag_j = 1;
                    else
                        flag_j = 0;
                        
                    if (flag_i && flag_j)
                        cov[i][j]++;
                }
            }
                
            temp = temp->next;
        }

        fprintf(fp, "Top frequency of hybrids:\n");
        
        block_i = top_block;
        i = doi;
        while (block_i != NULL) {
            fprintf(fp, "Top %d:\n %s %d\n", i, block_i->s, block_i->cnt);
            block_i = block_i->next;
            i--;
        }

        //output the correlation matrix
        fprintf(fp, "Correlations:\n");
        fprintf(fp ,"   ");
        for (i=doi; i>0; i--)
            fprintf(fp, "%10d", i);
        fprintf(fp, "\n");
        for (i=0; i<doi; i++) {
            fprintf(fp, " %d ", doi-i);
            for (j=0; j<doi; j++)
                fprintf(fp, "%10d", cov[i][j]);
            fprintf(fp, "\n");
        }

        free_list(top_block);
        while (struc_head != NULL) {
            temp = struc_head;
            struc_head = struc_head->next;
            free(temp->s);
            free(temp);
        }
    }   //end else

    //output the top @top_frequency structures
    fprintf(fp, "Top %d frequent structures:\n", top_frequency);	
    for (i=0; i<top_frequency; i++) {
        max = search_max_result(ana_head);
            
        if (max == NULL)
            break;
        else
            fprintf(fp, "%s  %d\n", max->structure, max->cnt);

        if (constraint) {
            if (check_constraints(max->structure, len_r+len_s+2) == 1)
                count++;
        }
            
        if (max == ana_head) {
            ana_head = max->next;
            free(max);
        }
        else {
            index = ana_head;
            while (index->next!=max && index->next!=NULL)
                index = index->next;
            index->next = max->next;
                
            free(max);
        }
    }
    if (count > 0)
        result = 1;

    /* ------------------------------ probabilities by sample --------------------------------- */
    index = ana_head;
    P_sample = (double *) space (sizeof(double)*((len_r+len_s)*(len_r+len_s+1)/2)+2);
    indxSample = (int *) space (sizeof(int)*(len_r+len_s+1));
    for (i=1; i<=len_r+len_s; i++)
        indxSample[i] = (i*(i-1)) >> 1;        /* n(n-1)/2 */
    
    //select the top @top_frequency frequency structure
    index = ana_head;
    while (index != NULL) {
        read_structure(index->structure, index->cnt, num_sample);
        index = index->next;
    }
        
//    fprintf(fp, "Sample base pairing probability:\n");
    t = 0;
    for (i=1; i<=len_r+len_s; i++)
        for (j=i; j<=len_r+len_s; j++) {
            pro = P_sample[indxSample[j]+i];
            if (pro != 0.0) {
                //fprintf(fp,"%d %d %8.8e\n", i,j,pro);
                mfe[t].i = i;
                mfe[t].j = j;
                mfe[t].p = pro;
                t++;
            }
        }
        
    while (ana_head != NULL) {
        index = ana_head;
        ana_head = ana_head->next;
        
        free(index->structure);
        free(index);
    }
    
    return result;
}

void do_single_sample(FILE *fp, char **seqs_r, char **seqs_s_53)
{
    char *structure;
    
    structure = sample_strutures(seqs_r, seqs_s_53);            
    fprintf(fp, "Sample single structure:\n%s\n", structure);
    
    free(structure);
}
