#ifndef     ALIGN_SAMPLE_H
#define     ALIGN_SAMPLE_H


#include "inc.h"

typedef struct block block;

/**
 * type:
 * 0:I    1:RT  2:DT   3:Hybrid-EE   4:Tu     5:Td    6:Te
 * 7:Sec  8:Qb  9:Qbs  10:QTsu      11:QTsd  12:QTse 13:Hybrid
 *
 * status:
 * RT & DT:
 *  0:eea   1:eeb   2:me   3:em   4:fe    5:ef    6:mm   7:mf   8:fm    9:ff
 * 10:eka  11:ekb  12:mk  13:fk  14:kea  15:keb  16:km  17:kf  18:kka  19:kkb
 * Tu & Td:
 *  0:e  1:m  2:f  3:k
 * Secondary Structure:
 *  0:e        1:m        2:f        3:f
 *  4:e|empty  5:m|empty  6:f|empty  7:f|empty 
 */
struct block
{
	int i, j;
	int r, s;
	int type; 
	int status;
	block *next;
};

typedef struct ana ana;
struct ana
{
	char *structure;
	int cnt;
	ana *next;
};

typedef struct int_block int_block;
struct int_block
{
	char *s; 
	int cnt;
    double pro;         //probability of hybrid
	int_block *next;
};

typedef struct struc_list struc_list;
struct struc_list
{
	char *s; 
	struc_list *next;
};

extern ana *ana_head;
extern block *Bstack;
extern int n_top;

extern char *sample_strutures(char **seqs_r, char **seqs_s_53);
extern void analyze_result(char *structure);
extern ana *search_max_result(ana *begin);
extern int do_sample(FILE *fp, char **seqs_r, char **seqs_s_53, long num_sample, int all_sample,
                      int top_frequency, struct plist *mfe);
extern void do_single_sample(FILE *fp, char **seqs_r, char **seqs_s_53);
    
#endif
