#ifndef     STK_C
#define     STK_C


#define   MAXLENGTH   1024

/**
 * an RNA chain consisting of its name
 * and sequence
 */
typedef struct rna_seq rna_seq;
struct rna_seq {
    char name[256];         //name of rna
    char seq[MAXLENGTH];    //sequence of rna like "AUGCGCC"
    rna_seq *next;          //pointer to the next sequence
};

/**
 * a list which has the same prefix
 * of RNAs
 */
typedef struct pre_node pre_node;
struct pre_node {
    char pre_name[16];          //name of prefix
    int n_seq;                  //number of sequences which have the same prefix
    rna_seq *head;              //pointer to the first rna node
    pre_node *next;             //pointer to the next prefix node
};

/**
 * a list including all different 
 * prefixs
 */
typedef struct pre_list pre_list;
struct pre_list {
    int n_prefix;        //number of prefixs which are different mutually
    pre_node *head;      //pointer to the next prefix node
};


void read_data(char *file_name_u4, char *file_name_u6);
void transform_stk2fasta(char *u4_file_name, char *u6_file_name);


#endif
