#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stk.h"

void usage(void);


int main(int argc, char **argv)
{
    char *pos;
    char *u4_stk = "./stk/default.u4.stk";
    char *u6_stk = "./stk/default.u6.stk";

    if (argc == 2)
        usage();
    else if (argc == 3) {
        u4_stk = argv[1];
        u6_stk = argv[2];
    }

    read_data(u4_stk, u6_stk);
    
    pos = strrchr(u4_stk, '/');
    if (pos != NULL)
        u4_stk = pos+1;
    pos = strrchr(u6_stk, '/');
    if (pos != NULL)
        u6_stk = pos+1;
    transform_stk2fasta(u4_stk, u6_stk);

    fprintf(stdout, "The fasta files are written in \"./data/\".\n");
    
    return EXIT_SUCCESS;
}

void usage(void)
{
    printf("Usage:  s2f [u4file u6file]\n"
           "\'s2f\' transforms stockholm format to fasta format, which will be read by \'RNArip\'. \n"
           "Default is to read the two files from \"./stk/default.u4.stk\" and \"./stk/default.u6.stk\".\n\n"
           " Options:\n\n"
           "    u4file      stockholm format file of u4\n"
           "    u6file      stockholm format file of u6\n");

    exit(EXIT_FAILURE);
}
